//-----------------------------------------------------------------------------
// NOTE : CBoom Ŭ 
//  :  ȿ Ŭ
// ϸ : CBoom.h
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------

#ifndef _CBOOM_H_
#define _CBOOM_H_

#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include "CDxMusic.h"
#include <list>
using namespace std;

class CBoom;

struct BOOM
{
	POINT	ptPos;		// Ʈ ǥ
	int		nIndex;		// Ʈ ε
	BOOL	bDraw;		// ı
	int		nFlag;		// Ʈ 
	DWORD	dwDealy;	// Ӱ 
	int		nLoop;
};

typedef list<BOOM*>	BOOM_LIST;


//-----------------------------------------------------------------------------
class CBoom : public CDisplay
{
	private:
		BOOM_LIST m_listBoom;

		CSurface		*m_psurBoom[3];		// BOOM ǥ		
		ONLY_SPRITE		 m_osBoom[3];		// BOOM 

		CDxMusic		*m_pMusic;			// ̷Ʈ  

	public:
		CBoom();			// 
		virtual ~CBoom();	// Ҹ

		void	Create(LPDIRECTDRAW7 *pDD, CDxMusic *pMusic);		// üԼ
		void	InitBoom();											// ü ʱȭ Լ

		void	LoadBoom();											// Ʈ εԼ
		void	ReleaseBoom();										// Ʈ Լ

		void	Update();								// ü ƮԼ
		void	Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB);	// Լ
		void	Destroy();								// Լ
		void	Add(int index, int x, int y);			// Ʈ ߰Լ

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);
};

//-----------------------------------------------------------------------------

#endif
