//-----------------------------------------------------------------------------
// Note : CD2D Ŭ 
// ϸ : CD2D.cpp 
//-----------------------------------------------------------------------------

#include "CD2D.h"
#include <stdio.h>


//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CD2D::CD2D()
{
	m_nGameStates	= INTRO;
	m_nTitleSelect	= START;
	m_nChaSelect	= SP;
	m_bStart = FALSE;

	// ŸƲ 
	ZeroMemory(m_bDrawCow, sizeof(m_bDrawCow));
	m_bCowUpdate = FALSE;
	m_nCowIndex = 0;
	m_dwCowDealy = 0;
	m_bDrawOrange = 0;

	m_ptCowPos[0].x = 143;
	m_ptCowPos[0].y = 181;
	m_ptCowPos[1].x = 184;
	m_ptCowPos[1].y = 181;
	m_ptCowPos[2].x = 228;
	m_ptCowPos[2].y = 181;
	m_ptCowPos[3].x = 272;
	m_ptCowPos[3].y = 181;
	m_ptCowPos[4].x = 317;
	m_ptCowPos[4].y = 181;
	m_ptCowPos[5].x = 363;
	m_ptCowPos[5].y = 178;
	m_ptCowPos[6].x = 436;
	m_ptCowPos[6].y = 179;
	m_ptCowPos[7].x = 481;
	m_ptCowPos[7].y = 179;
	m_ptCowPos[8].x = 526;
	m_ptCowPos[8].y = 179;
	m_ptCowPos[9].x = 572;
	m_ptCowPos[9].y = 178;
	m_ptCowPos[10].x = 619;
	m_ptCowPos[10].y = 177;
	m_ptCowPos[11].x = 530;
	m_ptCowPos[11].y = 234;

	m_ptSmailePos[0].x = 320;
	m_ptSmailePos[0].y = 360;
	m_ptSmailePos[1].x = 320;
	m_ptSmailePos[1].y = 410;
	m_ptSmailePos[2].x = 320;
	m_ptSmailePos[2].y = 500;

	m_ptWordPos[0].x = 461;
	m_ptWordPos[0].y = 378;
	m_ptWordPos[1].x = 446;
	m_ptWordPos[1].y = 450;
	m_ptWordPos[2].x = 458;
	m_ptWordPos[2].y = 521;

	// ɸ
	m_ptCSelectPos[0].x = 200;	// ɸ
	m_ptCSelectPos[0].y = 390;
	m_ptCSelectPos[1].x = 560;	// 
	m_ptCSelectPos[1].y = 430;
	m_ptCSelectPos[2].x = 375;	// ü 
	m_ptCSelectPos[2].y = 420;

	m_ptExitGame.x	= 790;
	m_ptExitGame.y	= 590;

	SetRect(&m_rtPlayInfo, 600, 0, 800, 600);

	m_bKeydown[0] = FALSE;
	m_bKeydown[1] = FALSE;
	m_bKeydown[2] = FALSE;
	m_bKeydown[3] = FALSE;

	m_nStage		= 1;

	// ȭ
	m_ptDraw[0].x = 394;
	m_ptDraw[0].y = 422;
	m_ptDraw[1].x = 394;
	m_ptDraw[1].y = 422;
	m_ptDraw[2].x = 394;
	m_ptDraw[2].y = 422;

	m_ptDraw[3].x = 405;
	m_ptDraw[3].y = 521;
	m_ptDraw[4].x = 394;
	m_ptDraw[4].y = 422;

	m_ptDraw[5].x = 406;
	m_ptDraw[5].y = 507;
	m_ptDraw[6].x = 394;
	m_ptDraw[6].y = 422;

	m_ptDraw[7].x = 394;
	m_ptDraw[7].y = 422;
	m_ptDraw[8].x = 394;
	m_ptDraw[8].y = 422;
	m_ptDraw[9].x = 394;
	m_ptDraw[9].y = 422;
	m_ptDraw[10].x = 394;
	m_ptDraw[10].y = 422;
	m_ptDraw[11].x = 620;
	m_ptDraw[11].y = 570;
	m_ptDraw[12].x = 394;
	m_ptDraw[12].y = 422;
	m_nEndIndex = -1;

	ZeroMemory(m_bEndDraw, sizeof(m_bEndDraw)); 

	// 
	m_ptCrePos.x = 500;
	m_ptCrePos.y = 600;

	// ŷ
	strcpy(m_Rank[0].szName, "noname");
	strcpy(m_Rank[1].szName, "noname");
	strcpy(m_Rank[2].szName, "noname");
	m_Rank[0].score = 0;
	m_Rank[1].score = 0;
	m_Rank[2].score = 0;

	// 콺 
	ShowCursor(FALSE);

}


CD2D::~CD2D()
{
	DestroyLOSD(&m_osCSelectCha);
	DestroyLOSD(&m_osCSelectInfo);
	DestroyLOSD(&m_osCSelectShip);
	DestroyLOSD(&m_osExitGame);
	DestroyLOSD(&m_osEnding);
	DestroyLOSD(&m_osCredit);
	DestroyLOSD(&m_osTitleWord);
	DestroyLOSD(&m_osTitleCow);

}



//-----------------------------------------------------------------------------
// CBTO ʱȭ Լ (  ε, Ÿ)
//-----------------------------------------------------------------------------
void CD2D::InitCBTO()
{
	BOOL bResult;

	// ̷Ʈ  ʱȭ
	bResult = m_DMusic.Init();
	bResult = m_DMusic.SetPerformance();

	// Ʈ 
	if (bResult == TRUE)
	{
		// ### ϰ  ٶ!! ###
		m_DMusic.DataLoad("sound\\effect\\change.wav");		
		m_DMusic.DataLoad("sound\\effect\\selected.wav");		
		m_DMusic.DataLoad("sound\\effect\\shot_normal.wav");		
		m_DMusic.DataLoad("sound\\effect\\shot_moa.wav");		
		m_DMusic.DataLoad("sound\\effect\\shot_boom.wav");		
		m_DMusic.DataLoad("sound\\effect\\boom_s.wav");		
		m_DMusic.DataLoad("sound\\effect\\boom_m.wav");		
		m_DMusic.DataLoad("sound\\effect\\boom_l.wav");		
		m_DMusic.DataLoad("sound\\effect\\item.wav");		
		m_DMusic.DataLoad("sound\\effect\\boss.wav");
		m_DMusic.DataLoad("sound\\effect\\ending_1.wav");
		m_DMusic.DataLoad("sound\\effect\\ending_2.wav");
		m_DMusic.DataLoad("sound\\effect\\ending_3.wav");
		m_DMusic.DataLoad("sound\\effect\\ending_4.wav");
		m_DMusic.DataLoad("sound\\effect\\ending_5.wav");
		m_DMusic.DataLoad("sound\\effect\\clear.wav");
		m_DMusic.DataLoad("sound\\effect\\mpmax.wav");
		m_DMusic.DataLoad("sound\\effect\\crash.wav");

	}

	//  
	HRESULT hr;

	hr = m_DShow.InitDirectShow();
	strcpy(m_strBGM[BGM_TITLE], "sound\\bgm\\bgm_title.mp3");
	strcpy(m_strBGM[BGM_CSELECT], "sound\\bgm\\bgm_cselect.mp3");
	strcpy(m_strBGM[BGM_METHOD], "sound\\bgm\\bgm_method.mp3");
	strcpy(m_strBGM[BGM_STAGE1], "sound\\bgm\\bgm_stage1.mp3");
	strcpy(m_strBGM[BGM_STAGE2], "sound\\bgm\\bgm_stage2.mp3");
	strcpy(m_strBGM[BGM_STAGE3], "sound\\bgm\\bgm_stage3.mp3");
	strcpy(m_strBGM[BGM_CREDIT], "sound\\bgm\\bgm_credit.mp3");
	strcpy(m_strBGM[BGM_GOVER], "sound\\bgm\\bgm_gover.mp3");
	strcpy(m_strBGM[BGM_ENDING], "sound\\bgm\\bgm_ending.mp3");

	// CBoom ʱȭ
	m_Boom.Create(&m_pDD, &m_DMusic);

	// Ÿ Ʈ
	m_Effect.Create(&m_pDD);

	// CItem ʱȭ
	m_Item.Create(&m_pDD);

	// CFroces ʱȭ
	m_cfForces.Create(&m_pDD, &m_Effect, &m_Item, &m_DMusic, &m_Boom);

	// CEnemy ʱȭ
	m_Enemy.Create(&m_pDD);

	// CBullet ʱȭ
	m_Bullet.Create(&m_pDD, &m_cfForces);

	// CMap ʱȭ
	m_Map.Create(&m_pDD, &m_Boss, &m_DMusic);
	m_Map.Init(0);

	// CScript ʱȭ
	m_Script.Create(&m_Enemy);
	m_Script.Init(1);

	//  ʱȭ
	m_Boss.Create(&m_pDD, &m_cfForces, &m_DMusic, &m_DShow);

	// ŷ ε
	RankLoad();

}



//-----------------------------------------------------------------------------
//  Ÿ Ʈ 
//-----------------------------------------------------------------------------
HRESULT CD2D::FrameMove()
{
	static DWORD dwMaxMp;
	static BOOL bStart = FALSE;

	// m_nGameStates ¿ ŰԷ
	switch (m_nGameStates)
	{
	case TITLE:		// ŸƲ ȭ
		InputTitle();
		break;

	case CSELECT:	// ɸ Ʈ ȭ
		InputCSelect();
		break;

	case PLAYING:	// ÷ ȭ
		InputPlaying();

		//   üũ
		if ((m_cfForces.GetHp() <= 0) && (m_cfForces.GetPlane() <= 0))
		{
			
			m_DShow.Stop();
			m_nGameStates = GAMEOVER;

			// 
			m_Boom.ReleaseBoom();
			m_Boss.ReleaseBoss();
			m_Bullet.ReleaseBullet();
			m_Effect.ReleaseEffect();
			m_cfForces.ReleaseForces();
			m_Item.ReleaseItem();
			m_Map.ReleaseMap();
			m_Enemy.ReleaseEnemy();
			ReleasePlayMenu();

			// Ʈ ε 
			LoadGameOver();
			ReleaseSIntro();

			//    
			m_DShow.Play(m_strBGM[BGM_GOVER]);

		}

		if (m_cfForces.GetStateFish() == F_CREATE)
		{
			m_bKeydown[0] = FALSE;
			m_bKeydown[1] = FALSE;
			m_bKeydown[2] = FALSE;
			m_bKeydown[3] = FALSE;
		}


		// MP ƽϰ !!
		if (m_cfForces.GetMp() >= 100)
		{
			if (bStart == FALSE)
			{
				bStart = TRUE;
				dwMaxMp = timeGetTime();
				m_DMusic.PlaySound(MPMAX, FALSE);
			}
			else
			{
				if (timeGetTime() - dwMaxMp > 200)
				{
					POINT ptCenter = m_cfForces.GetCenterPos();
					m_Effect.Add(0, ptCenter.x, ptCenter.y - 60);
					dwMaxMp = timeGetTime();
				}
			}
		}
		else if (m_cfForces.GetMp() == 0)
		{
			bStart = FALSE;
		}
		

		// ũƮ Ʈ
		m_Script.Update();
		break;

	case GAMEOVER:
		InputGameOver();
		break;

	case METHOD:
		InputMethod();
		break;

	case CREDITT:
		InputCredit();
		break;

	case PLAYMENU:
		InputPlayMenu();
		break;

	case ENDING:
		InputEnding();
		break;

	case SETNAME:
		InputSetName();
		break;
	}

	return S_OK;
}



//-----------------------------------------------------------------------------
// ȭ  κ
//-----------------------------------------------------------------------------
HRESULT CD2D::Render()
{
	// m_nGameStates ¿ ȭ 
	switch (m_nGameStates)
	{
	case INTRO:		// Ʈ ȭ
		RenderIntro();
		break;

	case TITLE:		// ŸƲ ȭ
		RenderTitle();
		break;

	case CSELECT:	// ɸ Ʈ ȭ
		RenderCSelect();
		break;

	case PLAYING:	// ÷ ȭ
		RenderPlaying();
		break;

	case GAMEOVER:	//   ȭ
		RenderGameOver();
		break;

	case METHOD:	//   ȭ
		RenderMethod();
		break;

	case S_INTRO:	//  Ʈ
		RenderStageIntro();
		break;

	case EXITGAME:	//    ȭ
		RenderExitGame();
		break;

	case ENDING:	// 
		RenderEnding();
		break;

	case CREDITT:	// 
		RenderCredit();
		break;

	case PLAYMENU:
		RederPlayMenu();
		break;

	case RANKING:
		RenderRank();
		break;

	case SETNAME:
		RenderSetName();
		break;

	}

	// FPS 
	//PrintFPS();
	return S_OK;
}



//-----------------------------------------------------------------------------
// Ʈ ǥ 
//-----------------------------------------------------------------------------
HRESULT CD2D::RestoreAllSurface()		
{
	return S_OK;
}



//-----------------------------------------------------------------------------
// Ʈ ǥ ʱȭ
//-----------------------------------------------------------------------------
void CD2D::InitAllSurface()				
{
	InitCBTO();		//  ʱȭ ۾

	// ÷ȭ   ######
	CreateSurfaceFromBitmap(&m_psurPlayInfo, "image\\play_info.ora", NULL, NULL);
}




//-----------------------------------------------------------------------------
// Ʈ ε - ŸƲ ȭ
//-----------------------------------------------------------------------------
void CD2D::LoadTitle()	
{
	ReleaseTitle();

	// ŸƲ 
	CreateSurfaceFromBitmap(&m_psurTitleBack, "image\\title_back.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurTitleWord, "image\\title_word.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurTitleCow, "image\\title_cow.ora", NULL, NULL);
	m_psurTitleWord->SetColorKey((DWORD)RGB(0, 255, 0));
	m_psurTitleCow->SetColorKey((DWORD)RGB(0, 255, 0));
	LoadOnlySprData("spr\\title_word.spr", &m_osTitleWord);
	LoadOnlySprData("spr\\title_cow.spr", &m_osTitleCow);

	// ŸƲ 
	CreateSurfaceFromBitmap(&m_psurTitleSmaile, "image\\title_smail.ora", NULL, NULL);
	m_psurTitleSmaile->SetColorKey((DWORD)RGB(255, 100, 100));

	CreateSurfaceFromBitmap(&m_psurTitleSmaile1, "image\\title_smail1.ora", NULL, NULL);
	m_psurTitleSmaile1->SetColorKey((DWORD)RGB(255, 99, 99));

	// Ÿ  ʱȭ
	ZeroMemory(m_bDrawCow, sizeof(m_bDrawCow));
	m_bCowUpdate = TRUE;
	m_bDrawOrange = FALSE;
	m_nCowIndex = 0;
	m_dwCowDealy = timeGetTime();
}






//-----------------------------------------------------------------------------
// Ʈ ε - ɸ Ʈ
//-----------------------------------------------------------------------------
void CD2D::LoadCSelect()
{
	ReleaseCSelect();

	// ĳ  
	CreateSurfaceFromBitmap(&m_psurCSelectBack, "image\\cselect_back.ora", NULL, NULL);
	
	// ĳ  ĳ #### ϰ ٶ!! 2004.6.3
	CreateSurfaceFromBitmap(&m_psurCSelectCha, "image\\cselect_cha.ora", NULL, NULL);
	LoadOnlySprData("spr\\cselect_cha.spr", &m_osCSelectCha);

	// ĳ  ¸  #### ϰ ٶ!!
	CreateSurfaceFromBitmap(&m_psurCSelectInfo, "image\\cselect_cha_info.ora", NULL, NULL);
	LoadOnlySprData("spr\\cselect_info.spr", &m_osCSelectInfo);

	// ü 
	CreateSurfaceFromBitmap(&m_psurCSelectShip, "image\\cselect_ship_info.ora", NULL, NULL);
	LoadOnlySprData("spr\\cselect_ship.spr", &m_osCSelectShip);
}




//-----------------------------------------------------------------------------
// Ʈ ε - ÷ 
//-----------------------------------------------------------------------------	
void CD2D::LoadMethod()
{
	ReleaseMethod();

	//  ÷ 
	CreateSurfaceFromBitmap(&m_psurMethod, "image\\method.ora", NULL, NULL);
}




//-----------------------------------------------------------------------------
// Ʈ ε -  Ʈ
//-----------------------------------------------------------------------------
void CD2D::LoadSIntro(int nStage)
{
	//  Ʈ ȭ
	ReleaseSIntro();
	
	
	switch (nStage)
	{
	case 1:
		CreateSurfaceFromBitmap(&m_psurSIntro, "image\\stage_intro1.ora", NULL, NULL);
		break;

	case 2:
		CreateSurfaceFromBitmap(&m_psurSIntro, "image\\stage_intro2.ora", NULL, NULL);
		break;

	case 3:
		CreateSurfaceFromBitmap(&m_psurSIntro, "image\\stage_intro3.ora", NULL, NULL);
		break;
	}
}




//-----------------------------------------------------------------------------
// Ʈ ε -  
//-----------------------------------------------------------------------------
void CD2D::LoadGameOver()
{
	ReleaseGameOver();

	//   ȭ
	CreateSurfaceFromBitmap(&m_psurGameOver, "image\\gameover.ora", NULL, NULL);
}




//-----------------------------------------------------------------------------
// Ʈ ε -  
//-----------------------------------------------------------------------------
void CD2D::LoadGameExit()
{
	ReleaseGameExit();

	//  
	CreateSurfaceFromBitmap(&m_psurExitGame, "image\\exit_game.ora", NULL, NULL);
	m_psurExitGame->SetColorKey(RGB(0, 255, 0));
	LoadOnlySprData("spr\\exit_game.spr", &m_osExitGame);
}




//-----------------------------------------------------------------------------
// Ʈ ε - 
//-----------------------------------------------------------------------------
void CD2D::LoadEnding()
{
	ReleaseEnding();

	// 
	CreateSurfaceFromBitmap(&m_psurEnding, "image\\ending.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurEndingBack, "image\\ending_back.ora", NULL, NULL);
	m_psurEnding->SetColorKey(RGB(0, 255, 0));
	LoadOnlySprData("spr\\ending.spr", &m_osEnding);

	m_nEndIndex = 0;

	ZeroMemory(m_bEndDraw, sizeof(m_bEndDraw)); 
	m_bEndDraw[0] = TRUE;

	m_dwEndDealy = timeGetTime();

	m_DMusic.PlaySound(ENDING1, FALSE);
	
}




//-----------------------------------------------------------------------------
// Ʈ ε - 
//-----------------------------------------------------------------------------
void CD2D::LoadCredit()
{
	ReleaseCredit();

	// 
	CreateSurfaceFromBitmap(&m_psurCredit, "image\\credit.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurCreditPic, "image\\credit_pic.ora", NULL, NULL);
	m_psurCreditPic->SetColorKey(RGB(0, 255, 0));
	LoadOnlySprData("spr\\credit.spr", &m_osCredit);
	LoadOnlySprData("spr\\credit_pic.spr", &m_osCreditPic);

	m_ptCrePos.x = 550;
	m_ptCrePos.y = 600;
	m_ptPicPos.x = 50;
	m_ptPicPos.y = 100;

	m_nPicIndex = 0;

	m_dwPicDealy = timeGetTime();
}




//-----------------------------------------------------------------------------
// Ʈ ε - ÷ ޴
//-----------------------------------------------------------------------------
void CD2D::LoadPlayMenu()
{
	CreateSurfaceFromBitmap(&m_psurPlayMenu, "image\\playmenu.ora", NULL, NULL);
	m_psurPlayMenu->SetColorKey(RGB(0, 255, 0));
	LoadOnlySprData("spr\\playmenu.spr", &m_osPlayMenu);

	m_nPlayMenu = 0;
}



//-----------------------------------------------------------------------------
// Ʈ ε - ŷȭ
//-----------------------------------------------------------------------------
void CD2D::LoadRank()
{
	ReleaseRank();

	CreateSurfaceFromBitmap(&m_psurRankBack, "image\\rankback.ora", NULL, NULL);

	m_dwRankDealy = timeGetTime();
}


//-----------------------------------------------------------------------------
// Ʈ ε - ̸
//-----------------------------------------------------------------------------
void CD2D::LoadSetName()
{
	ReleaseSetName();

	CreateSurfaceFromBitmap(&m_psurSetName, "image\\setname.ora", NULL, NULL);
	ZeroMemory(&m_szName, sizeof(m_szName));
}



//-----------------------------------------------------------------------------
// Ʈ  - ̸
//-----------------------------------------------------------------------------
void CD2D::ReleaseSetName()
{
	if (m_psurSetName) m_psurSetName->Destroy();
	m_psurSetName = NULL;

}



//-----------------------------------------------------------------------------
// Ʈ  - ŷȭ
//-----------------------------------------------------------------------------
void CD2D::ReleaseRank()
{
	if (m_psurRankBack) m_psurRankBack->Destroy();
	m_psurRankBack = NULL;

}



//-----------------------------------------------------------------------------
// Ʈ  - ÷ ޴
//-----------------------------------------------------------------------------
void CD2D::ReleasePlayMenu()
{
	if (m_psurPlayMenu) m_psurPlayMenu->Destroy();

	m_psurPlayMenu = NULL;

	DestroyLOSD(&m_osPlayMenu);

}




//-----------------------------------------------------------------------------
// Ʈ  - ŸƲ
//-----------------------------------------------------------------------------
void CD2D::ReleaseTitle()
{
	if (m_psurTitleBack) m_psurTitleBack->Destroy();
	if (m_psurTitleWord) m_psurTitleWord->Destroy();
	if (m_psurTitleSmaile) m_psurTitleSmaile->Destroy();
	if (m_psurTitleSmaile1) m_psurTitleSmaile1->Destroy();
	if (m_psurTitleCow) m_psurTitleCow->Destroy();

	m_psurTitleBack		= NULL;
	m_psurTitleWord		= NULL;
	m_psurTitleSmaile	= NULL;
 	m_psurTitleSmaile1	= NULL;
	m_psurTitleCow		= NULL;
	
	DestroyLOSD(&m_osTitleWord);
	DestroyLOSD(&m_osTitleCow);
}




//-----------------------------------------------------------------------------
// Ʈ  - ɸ Ʈ
//-----------------------------------------------------------------------------
void CD2D::ReleaseCSelect()
{
	if (m_psurCSelectBack) m_psurCSelectBack->Destroy();
	if (m_psurCSelectCha)  m_psurCSelectCha->Destroy();
	if (m_psurCSelectInfo) m_psurCSelectInfo->Destroy();
	if (m_psurCSelectShip) m_psurCSelectShip->Destroy();

	m_psurCSelectBack	= NULL;
	m_psurCSelectCha	= NULL;
	m_psurCSelectInfo	= NULL;
	m_psurCSelectShip	= NULL;

	DestroyLOSD(&m_osCSelectCha);
	DestroyLOSD(&m_osCSelectInfo);
	DestroyLOSD(&m_osCSelectShip);
}




//-----------------------------------------------------------------------------
// Ʈ  -  
//-----------------------------------------------------------------------------
void CD2D::ReleaseMethod()
{
	if (m_psurMethod) m_psurMethod->Destroy();
	m_psurMethod = NULL;
}




//-----------------------------------------------------------------------------
// Ʈ  -  Ʈ
//-----------------------------------------------------------------------------
void CD2D::ReleaseSIntro()
{	
	if (m_psurSIntro) m_psurSIntro->Destroy();
	m_psurSIntro = NULL;
}




//-----------------------------------------------------------------------------
// Ʈ  -  
//-----------------------------------------------------------------------------
void CD2D::ReleaseGameOver()
{
	if (m_psurGameOver) m_psurGameOver->Destroy();
	m_psurGameOver = NULL;
}
	



//-----------------------------------------------------------------------------
// Ʈ  -  
//-----------------------------------------------------------------------------
void CD2D::ReleaseGameExit()
{
	if (m_psurExitGame) m_psurExitGame->Destroy();
	m_psurExitGame = NULL;
	DestroyLOSD(&m_osExitGame);
}






//-----------------------------------------------------------------------------
// Ʈ  - 
//-----------------------------------------------------------------------------
void CD2D::ReleaseEnding()
{
	if (m_psurEnding) m_psurEnding->Destroy();
	if (m_psurEndingBack) m_psurEndingBack->Destroy();
	m_psurEnding = NULL;
	m_psurEndingBack = NULL;
	DestroyLOSD(&m_osEnding);
}





//-----------------------------------------------------------------------------
// Ʈ  - 
//-----------------------------------------------------------------------------
void CD2D::ReleaseCredit()
{
	if (m_psurCredit) m_psurCredit->Destroy();
	if (m_psurCreditPic) m_psurCreditPic->Destroy();
	m_psurCredit	= NULL;
	m_psurCreditPic = NULL;
	DestroyLOSD(&m_osCredit);
	DestroyLOSD(&m_osCreditPic);
}





//-----------------------------------------------------------------------------
// Ʈ ǥ 
//-----------------------------------------------------------------------------
void CD2D::DeleteAllSurface()
{
	// ŸƲ 
	if (m_psurTitleBack) m_psurTitleBack->Destroy();
	if (m_psurTitleSmaile) m_psurTitleSmaile->Destroy();
	if (m_psurTitleSmaile1) m_psurTitleSmaile1->Destroy();
	if (m_psurTitleWord) m_psurTitleWord->Destroy();

	// ɸ Ʈ 
	if (m_psurCSelectBack) m_psurCSelectBack->Destroy();
	if (m_psurCSelectCha) m_psurCSelectCha->Destroy();
	if (m_psurCSelectInfo) m_psurCSelectInfo->Destroy();
	if (m_psurCSelectShip) m_psurCSelectShip->Destroy();

	// ÷ȭ 
	if (m_psurPlayInfo) m_psurPlayInfo->Destroy();

	//   
	if (m_psurGameOver) m_psurGameOver->Destroy();

	//  
	if (m_psurMethod) m_psurMethod->Destroy();

	//  
	if (m_psurExitGame) m_psurExitGame->Destroy();

	if (m_psurSIntro) m_psurSIntro->Destroy();

	if (m_psurEnding) m_psurEnding->Destroy();
	if (m_psurCredit) m_psurCredit->Destroy();
	if (m_psurRankBack) m_psurRankBack->Destroy();
	if (m_psurSetName) m_psurSetName->Destroy();

	// ü 
	m_Boom.Destroy();
	m_Boss.Destroy();
	m_Bullet.Destroy();
	m_Effect.Destroy();
	m_Enemy.Destroy();
	m_cfForces.Destroy();
	m_Item.Destroy();
	m_Map.Destroy();


}



//-----------------------------------------------------------------------------
// FPS 
//-----------------------------------------------------------------------------
void CD2D::PrintFPS()
{
	MyTextOut(m_strFrameStats, 0, 0, RGB(0, 255, 0), "", 13);
}



//-----------------------------------------------------------------------------
// ۿ 
//-----------------------------------------------------------------------------
void CD2D::MyTextOut(char *lpszPrint, int xPos, int yPos, COLORREF clrText,
					 char *lpszFont, int nSize)
{
	//  DC ´.
	HDC hdc;
	m_pddsBackBuffer->GetDC(&hdc);

	// Ʈ 
	HFONT hNewFont, hDefFont;
	if (lpszFont != NULL)
	{
		hNewFont = CreateFont(nSize, 0, 0, 0, 0, 0, 0, 0,
			HANGEUL_CHARSET, 0, 0, 0, 0, lpszFont);

		hDefFont = (HFONT)SelectObject(hdc, hNewFont);
	}

	//   
	SetBkMode(hdc, TRANSPARENT);
	SetTextColor(hdc, clrText);

	//  
	TextOut(hdc, xPos, yPos, lpszPrint, (int)strlen(lpszPrint));

	// ҽ 
	if (lpszFont != NULL)
	{
		SelectObject(hdc, hDefFont);
		DeleteObject(hNewFont);
	}

	// DC 
	m_pddsBackBuffer->ReleaseDC(hdc);
}




//-----------------------------------------------------------------------------
// ȭ  Լ - Ʈ ȭ
//-----------------------------------------------------------------------------
void CD2D::RenderIntro()
{
	Clear(0);

	static char strIntro[5][10] = {"Do", "you", "like", "Orange", "?"};
	static char strPrint[100];
	static int index = -1;
	static DWORD dwStart = GetTickCount(); 

	MyTextOut(strPrint, 300, 300, RGB(255, 240, 150), "ü", 15);

	if (GetTickCount() - dwStart > 1500)
	{

		if (++index != 5)
		{
			dwStart = GetTickCount();
			strcat(strPrint, "  ");
			strcat(strPrint, strIntro[index]);
		}
		else
		{
			m_nGameStates = TITLE;
			Sleep(2000);
			// ŸƲ  
			

			// ŸƲ Ʈ ε
			LoadTitle();
			m_Boom.LoadBoom();
		}

	}
}

	
		
//-----------------------------------------------------------------------------
// ȭ  Լ - ŸƲ ȭ
//-----------------------------------------------------------------------------
void CD2D::RenderTitle()
{
	RECT rtSmaile;
	static DWORD dwStart = GetTickCount();
	static BOOL bFlag = FALSE;
	RECT rtWord;
	RECT rtCow;

	SetRect(&rtSmaile, m_ptSmailePos[m_nTitleSelect].x, m_ptSmailePos[m_nTitleSelect].y,
		m_ptSmailePos[m_nTitleSelect].x + 71, m_ptSmailePos[m_nTitleSelect].y + 53);

	// 
	//m_pddsBackBuffer->Blt(NULL, m_psurTitleBack->GetDDrawSurface(), NULL, DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(0, 0,
							  m_psurTitleBack->GetDDrawSurface(), 
							  NULL,
							   DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );

	//  ִ
	if (bFlag)
	{
		//m_pddsBackBuffer->Blt(&rtSmaile, m_psurTitleSmaile->GetDDrawSurface(), NULL,
		//						DDBLT_WAIT | DDBLT_KEYSRC, NULL);

		m_pddsBackBuffer->BltFast(rtSmaile.left, rtSmaile.top,
								m_psurTitleSmaile->GetDDrawSurface(), 
								NULL,
								 DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}
	else
	{
		//m_pddsBackBuffer->Blt(&rtSmaile, m_psurTitleSmaile1->GetDDrawSurface(), NULL,
		//						DDBLT_WAIT | DDBLT_KEYSRC, NULL);

		m_pddsBackBuffer->BltFast(rtSmaile.left, rtSmaile.top,
								m_psurTitleSmaile1->GetDDrawSurface(), 
								NULL,
								 DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}
	
	//  
	// Ʈ ǥ 浹 ǥ -> ȭ  ǥ ȯ
	MakeCenterToRect(&m_osTitleWord.pSpr[m_nTitleSelect].ptSprCenterPos,
					 &m_osTitleWord.pSpr[m_nTitleSelect].rcSprPos,
					 &m_ptWordPos[m_nTitleSelect], &rtWord);

	//m_pddsBackBuffer->Blt(&rtWord, m_psurTitleWord->GetDDrawSurface(),
	//					  &m_osTitleWord.pSpr[m_nTitleSelect].rcSprPos,
	//					  DDBLT_WAIT | DDBLT_KEYSRC, NULL);

	m_pddsBackBuffer->BltFast(rtWord.left, rtWord.top,
							  m_psurTitleWord->GetDDrawSurface(), 
							  &m_osTitleWord.pSpr[m_nTitleSelect].rcSprPos,
							   DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );

	// Cow  Ʈ
	if (m_bCowUpdate == TRUE)
	{
		if ((timeGetTime() - m_dwCowDealy) > 200)
		{
			m_bDrawCow[m_nCowIndex++] = TRUE;

			m_DMusic.PlaySound(CHANGE, FALSE);

			if (m_nCowIndex == 10)
				m_DShow.Play(m_strBGM[BGM_TITLE]);

			if (m_nCowIndex == 12)
			{
				m_bCowUpdate = FALSE;
				m_bDrawOrange = TRUE;
			}
			m_dwCowDealy = timeGetTime();
		}

	}

	//  ڱ
	if (m_bDrawOrange == TRUE)
	{
		if ((timeGetTime() - m_dwCowDealy) > 400)
		{
			m_bDrawCow[11] = !m_bDrawCow[11];
			m_dwCowDealy = timeGetTime();
		}
	}


	//  
	for (int i = 0; i < 12; i++)
	{
		if (m_bDrawCow[i] == TRUE)
		{
			MakeCenterToRect(&m_osTitleCow.pSpr[i].ptSprCenterPos,
							 &m_osTitleCow.pSpr[i].rcSprPos,
							&m_ptCowPos[i], &rtCow);

			//m_pddsBackBuffer->Blt(&rtCow, m_psurTitleCow->GetDDrawSurface(),
			//					&m_osTitleCow.pSpr[i].rcSprPos,
			//					DDBLT_WAIT | DDBLT_KEYSRC, NULL);

			m_pddsBackBuffer->BltFast(rtCow.left, rtCow.top,
									m_psurTitleCow->GetDDrawSurface(), 
									&m_osTitleCow.pSpr[i].rcSprPos,
									 DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
		}
	}


	// źƮ
	m_Boom.Update();
	m_Boom.Draw(&m_pddsBackBuffer);

	if (m_bStart == TRUE)
	{
		if ((timeGetTime() - m_dwStartDealy) > 400)
		{
			m_nGameStates = CSELECT;
			// ŸƲ  
			m_DShow.Play(m_strBGM[BGM_CSELECT]);
			// ɸ   

			// Ʈ ε 
			LoadCSelect();
			ReleaseTitle();	
			m_bStart = FALSE;
			m_Boom.ReleaseBoom();

			m_bDrawOrange = FALSE;
		}
	}


	// ִ ð 
	if (GetTickCount() - dwStart > 1000)
	{
		bFlag = !bFlag;
		dwStart = GetTickCount();
	}
}




//-----------------------------------------------------------------------------
// ȭ  Լ - ɸ Ʈ
//-----------------------------------------------------------------------------
void CD2D::RenderCSelect()
{
	//  
	//m_pddsBackBuffer->Blt(NULL, m_psurCSelectBack->GetDDrawSurface(), NULL, DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(0, 0,
							  m_psurCSelectBack->GetDDrawSurface(), 
							  NULL,
							   DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );

	// ɸ
	RECT rtCha;

	// Ʈ ǥ 浹 ǥ -> ȭ  ǥ ȯ
	MakeCenterToRect(&m_osCSelectCha.pSpr[m_nChaSelect].ptSprCenterPos,
					 &m_osCSelectCha.pSpr[m_nChaSelect].rcSprPos,
					 &m_ptCSelectPos[0], &rtCha);

	// ĳ 
	//m_pddsBackBuffer->Blt(&rtCha, m_psurCSelectCha->GetDDrawSurface(),
	//	&(m_osCSelectCha.pSpr[m_nChaSelect].rcSprPos), DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(rtCha.left, rtCha.top,
							  m_psurCSelectCha->GetDDrawSurface(), 
							  &(m_osCSelectCha.pSpr[m_nChaSelect].rcSprPos),
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );

		
	MakeCenterToRect(&m_osCSelectInfo.pSpr[m_nChaSelect].ptSprCenterPos,
					 &m_osCSelectInfo.pSpr[m_nChaSelect].rcSprPos,
					 &m_ptCSelectPos[1], &rtCha);

	// ĳ  
	//m_pddsBackBuffer->Blt(&rtCha, m_psurCSelectInfo->GetDDrawSurface(),
	//	&(m_osCSelectInfo.pSpr[m_nChaSelect].rcSprPos), DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(rtCha.left, rtCha.top,
							  m_psurCSelectInfo->GetDDrawSurface(), 
							  &(m_osCSelectInfo.pSpr[m_nChaSelect].rcSprPos),
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );

	// ü 
	MakeCenterToRect(&m_osCSelectShip.pSpr[m_nChaSelect].ptSprCenterPos,
					 &m_osCSelectShip.pSpr[m_nChaSelect].rcSprPos,
					 &m_ptCSelectPos[2], &rtCha);

	//m_pddsBackBuffer->Blt(&rtCha, m_psurCSelectShip->GetDDrawSurface(),
	//	&(m_osCSelectShip.pSpr[m_nChaSelect].rcSprPos), DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(rtCha.left, rtCha.top,
							  m_psurCSelectShip->GetDDrawSurface(), 
							  &(m_osCSelectShip.pSpr[m_nChaSelect].rcSprPos),
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );



}



//-----------------------------------------------------------------------------
// ȭ  Լ - ÷ ȭ
//-----------------------------------------------------------------------------
void CD2D::RenderPlaying()
{

	// 浹 ü 
	CheckCrash(); 
	
	//  Ʈ
	if (m_Map.GetScroll())
		m_Map.ScrollMap();
	m_Enemy.UpdateShip(&m_Boom, &m_Bullet);
	m_Boss.UpdateBoss(&m_Boom, &m_Bullet);
	m_Boom.Update();
	m_cfForces.Update();
	m_Effect.Update();
	m_Item.Update();
	m_Bullet.UpdateBullet();


	// 
	m_Map.DrawMap(&m_pddsBackBuffer);

	//  
	m_pddsBackBuffer->Blt(&m_rtPlayInfo, m_psurPlayInfo->GetDDrawSurface(), NULL, DDBLT_WAIT, NULL);

	//  
	m_Enemy.Draw(&m_pddsBackBuffer, &m_Boom, &m_Bullet);

	// 
	m_Boss.Draw(&m_pddsBackBuffer, &m_Boom, &m_Bullet);

	//  Ʈ
	m_Boom.Draw(&m_pddsBackBuffer);

	// Ʊ 
	m_cfForces.DrawSay(&m_pddsBackBuffer);
	m_cfForces.Draw(&m_pddsBackBuffer);
	m_cfForces.DrawInfo(&m_pddsBackBuffer);

	// Ʈ
	m_Effect.Draw(&m_pddsBackBuffer);

	// 
	m_Item.Draw(&m_pddsBackBuffer);

	//  Ѿ
	m_Bullet.Draw(&m_pddsBackBuffer);

	//  Ŭ
	m_cfForces.DrawClear(&m_pddsBackBuffer);

	// 
	m_Boss.DrawEnege(&m_pddsBackBuffer);
}





//-----------------------------------------------------------------------------
// ȭ  Լ -  Լ
//-----------------------------------------------------------------------------
void CD2D::RenderGameOver()
{

	//m_pddsBackBuffer->Blt(NULL, m_psurGameOver->GetDDrawSurface(), NULL, 
	//					  DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(0, 0,
							  m_psurGameOver->GetDDrawSurface(), 
							  NULL,
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );
}





//-----------------------------------------------------------------------------
// ȭ  Լ -  ÷̹
//-----------------------------------------------------------------------------
void CD2D::RenderMethod()
{
	//m_pddsBackBuffer->Blt(NULL, m_psurMethod->GetDDrawSurface(), NULL, 
	//					  DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(0, 0,
							  m_psurMethod->GetDDrawSurface(), 
							  NULL,
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );

	m_cfForces.SetScore(0);
}





//-----------------------------------------------------------------------------
// ȭ  Լ -  Ұȭ
//-----------------------------------------------------------------------------
void CD2D::RenderStageIntro()
{

	//  Ұȭ ׸.
	//m_pddsBackBuffer->Blt(NULL, m_psurSIntro->GetDDrawSurface(), NULL, 
	//					  DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(0, 0,
							  m_psurSIntro->GetDDrawSurface(), 
							  NULL,
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );


	//   üũ
	if ((timeGetTime() - m_dwTimeSIntro) > 3000)
	{
		switch (m_nStage)
		{
		case 1:
			// Ʈ ε
			m_Enemy.LoadEnemy(1);
			m_Boom.LoadBoom();
			m_Boss.LoadBoss(1);
			m_Bullet.LoadBullet();
			m_Effect.LoadEffect();
			m_cfForces.LoadForces(m_nChaSelect);
			m_Item.LoadItem();
			m_Map.LoadMap(1);
			LoadPlayMenu();

			// ü ʱȭ
			m_nGameStates = PLAYING;
			m_cfForces.InitNewShip();
			m_Boom.InitBoom();
			m_Boss.InitBoss();
			m_Boss.SetStage(0);
			m_Bullet.InitBullet();
			m_Effect.InitEffect();
			m_Item.InitItem();
			m_Map.InitMap(0);
			m_Enemy.InitEnemy();
			m_Script.Init(0);
			m_Script.Start();

			m_bKeydown[0] = FALSE;
			m_bKeydown[1] = FALSE;
			m_bKeydown[2] = FALSE;
			m_bKeydown[3] = FALSE;
			m_DShow.Play(m_strBGM[BGM_STAGE1]);

			// Ʈ ε
			LoadSIntro(2);

			break;

		case 2:
			// Ʈε
			m_Enemy.LoadEnemy(2);
			m_Boss.LoadBoss(2);
			m_Map.LoadMap(2);

			// ü ʱ
			m_nGameStates = PLAYING;
			m_cfForces.InItShip();
			m_Boom.InitBoom();
			m_Boss.InitBoss();
			m_Boss.SetStage(1);
			m_Bullet.InitBullet();
			m_Effect.InitEffect();
			m_Item.InitItem();
			m_Map.SetStage(m_nStage);
			m_Map.InitMap(1);
			m_Enemy.InitEnemy();
			m_Script.Init(1);
			m_Script.Start();

			m_bKeydown[0] = FALSE;
			m_bKeydown[1] = FALSE;
			m_bKeydown[2] = FALSE;
			m_bKeydown[3] = FALSE;
			m_DShow.Play(m_strBGM[BGM_STAGE2]);
			
			//  Ʈ
			m_cfForces.SetScore(500 * m_cfForces.GetPlane() + 200 * m_cfForces.GetBoom() + m_cfForces.GetHp());
			

			// Ʈ ε
			LoadSIntro(3);
			break;

		case 3:
			// Ʈ ʱȭ
			m_Enemy.LoadEnemy(3);
			m_Boss.LoadBoss(3);
			m_Map.LoadMap(3);

			// ü ʱȭ
			m_nGameStates = PLAYING;
			m_cfForces.InItShip();
			m_Boom.InitBoom();
			m_Boss.InitBoss();
			m_Boss.SetStage(2);
			m_Bullet.InitBullet();
			m_Effect.InitEffect();
			m_Item.InitItem();
			m_Map.SetStage(m_nStage);
			m_Map.InitMap(2);
			m_Enemy.InitEnemy();
			m_Script.Init(2);
			m_Script.Start();

			m_bKeydown[0] = FALSE;
			m_bKeydown[1] = FALSE;
			m_bKeydown[2] = FALSE;
			m_bKeydown[3] = FALSE;
			m_DShow.Play(m_strBGM[BGM_STAGE3]);

			//  Ʈ
			m_cfForces.SetScore(500 * m_cfForces.GetPlane() + 200 * m_cfForces.GetBoom() + m_cfForces.GetHp());

			// Ʈ ε
			ReleaseSIntro();
			break;
		}

		m_nStage++;
		m_cfForces.SetSay(1);
	}
}



//-----------------------------------------------------------------------------
// ȭ  Լ -   ȭ
//-----------------------------------------------------------------------------
void CD2D::RenderExitGame()
{
	Clear(0);

	static DWORD dwTime = timeGetTime();

	RECT rtDraw;

	// Ʈ ǥ 浹 ǥ -> ȭ  ǥ ȯ
	MakeCenterToRect(&m_osExitGame.pSpr[0].ptSprCenterPos,
					 &m_osExitGame.pSpr[0].rcSprPos,
					 &m_ptExitGame,
					 &rtDraw);



	// ĳ 
	//m_pddsBackBuffer->Blt(&rtDraw, m_psurExitGame->GetDDrawSurface(),
	//					  &m_osExitGame.pSpr[0].rcSprPos,
	//					  DDBLT_WAIT | DDBLT_KEYSRC, NULL);

	m_pddsBackBuffer->BltFast(rtDraw.left, rtDraw.top,
							  m_psurExitGame->GetDDrawSurface(), 
							  &m_osExitGame.pSpr[0].rcSprPos,
							  DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );

	if ((timeGetTime() - dwTime) > 1500)
		DestroyWindow(m_hWnd);

}




//-----------------------------------------------------------------------------
// ȭ  Լ - 
//-----------------------------------------------------------------------------
void CD2D::RenderEnding()
{
	Clear(0);

	RECT rtDraw;

	//  
	//m_pddsBackBuffer->Blt(NULL, m_psurEndingBack->GetDDrawSurface(),
	//					  NULL, DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(0, 0,
							  m_psurEndingBack->GetDDrawSurface(), 
							  NULL,
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );



	for (int i = 0; i <= 11; i++)
	{
		if (m_bEndDraw[i] == FALSE)
			continue;

		MakeCenterToRect(&m_osEnding.pSpr[i].ptSprCenterPos,
			&m_osEnding.pSpr[i].rcSprPos,
			&m_ptDraw[i],
			&rtDraw);

		//m_pddsBackBuffer->Blt(&rtDraw, m_psurEnding->GetDDrawSurface(), 
		//				 &m_osEnding.pSpr[i].rcSprPos,
		//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);


		m_pddsBackBuffer->BltFast(rtDraw.left, rtDraw.top,
								m_psurEnding->GetDDrawSurface(), 
								&m_osEnding.pSpr[i].rcSprPos,
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}

	if ((timeGetTime() - m_dwEndDealy) > 5000)
	{
		m_nEndIndex++;

		if (m_nEndIndex == 12)
		{
			m_nGameStates = CREDITT;
			m_nEndIndex = 0;
			ZeroMemory(m_bEndDraw, sizeof(m_bEndDraw)); 

			// 
			m_DShow.Stop();
			m_DShow.Play(m_strBGM[BGM_CREDIT]);

			// Ʈ ε
			LoadCredit();
			ReleaseEnding();
			m_bPlay = TRUE;
		}

		m_dwEndDealy = timeGetTime();

		//  
		if (m_nEndIndex == 1)
			m_DShow.Play(m_strBGM[BGM_ENDING]);
		else if (m_nEndIndex == 3)
			m_DMusic.PlaySound(ENDING2, FALSE);
		else if (m_nEndIndex == 5)
			m_DMusic.PlaySound(ENDING3, FALSE);
		else if (m_nEndIndex == 6)
			m_DMusic.PlaySound(ENDING4, FALSE);
		else if (m_nEndIndex == 8)
			m_DMusic.PlaySound(ENDING5, FALSE);

		m_bEndDraw[m_nEndIndex] = TRUE;
		if ((m_nEndIndex != 3) && (m_nEndIndex != 5) && (m_nEndIndex != 0) && (m_nEndIndex != 1))
			m_bEndDraw[m_nEndIndex - 1] = FALSE;

		if (m_nEndIndex == 4)
		{
			m_bEndDraw[2] = FALSE;
			m_bEndDraw[0] = FALSE;

		}
		else if (m_nEndIndex == 6)
		{
			m_bEndDraw[4] = FALSE;
		}
	}
	
}






//-----------------------------------------------------------------------------
// ȭ  Լ - 
//-----------------------------------------------------------------------------
void CD2D::RenderCredit()
{
	Clear(0);

	RECT rtPic;

	MakeCenterToRect(&m_osCredit.pSpr[0].ptSprCenterPos,
					 &m_osCredit.pSpr[0].rcSprPos,
					 &m_ptCrePos,
					 &m_rtDraw);

	MakeCenterToRect(&m_osCreditPic.pSpr[m_nPicIndex].ptSprCenterPos,
					 &m_osCreditPic.pSpr[m_nPicIndex].rcSprPos,
					 &m_ptPicPos,
					 &rtPic);

	m_rtSprite.left	  = m_osCredit.pSpr[0].rcSprPos.left;
	m_rtSprite.top	  = m_osCredit.pSpr[0].rcSprPos.top;
	m_rtSprite.right  = m_osCredit.pSpr[0].rcSprPos.right;
	m_rtSprite.bottom = m_osCredit.pSpr[0].rcSprPos.bottom;
		
	if (m_rtDraw.top < 0)
	{
		m_rtSprite.top += (-m_rtDraw.top);
		m_rtDraw.top = 0;
	}
	if (m_rtDraw.bottom > 600)
	{
		m_rtSprite.bottom -= (m_rtDraw.bottom - 600);
		m_rtDraw.bottom = 600;
	}

	// ο
	//m_pddsBackBuffer->Blt(&m_rtDraw, m_psurCredit->GetDDrawSurface(), 
	//					  &m_rtSprite,
	//					  DDBLT_WAIT, NULL);

	m_pddsBackBuffer->BltFast(m_rtDraw.left, m_rtDraw.top,
							  m_psurCredit->GetDDrawSurface(), 
							  &m_rtSprite,
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );


	//m_pddsBackBuffer->Blt(&rtPic, m_psurCreditPic->GetDDrawSurface(), 
	//					  &m_osCreditPic.pSpr[m_nPicIndex].rcSprPos,
	//					  DDBLT_WAIT | DDBLT_KEYSRC, NULL);

	m_pddsBackBuffer->BltFast(rtPic.left, rtPic.top,
							  m_psurCreditPic->GetDDrawSurface(), 
							  &m_osCreditPic.pSpr[m_nPicIndex].rcSprPos, 
							  DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	// Ʈ
	if ((--m_ptCrePos.y) < -1341)
		m_ptCrePos.y = -1341;

	if (timeGetTime() - m_dwPicDealy > 10000)
	{
		if (++m_nPicIndex > 5)
			m_nPicIndex = 5;

		m_dwPicDealy = timeGetTime();
	}

}



//-----------------------------------------------------------------------------
// ȭ  Լ - ÷ ޴
//-----------------------------------------------------------------------------
void CD2D::RederPlayMenu()
{
	//Clear(0);

	// 
	m_Map.DrawMap(&m_pddsBackBuffer);

	//  
	m_pddsBackBuffer->Blt(&m_rtPlayInfo, m_psurPlayInfo->GetDDrawSurface(), NULL, DDBLT_WAIT, NULL);

	//  
	m_Enemy.Draw(&m_pddsBackBuffer, &m_Boom, &m_Bullet);

	// 
	m_Boss.Draw(&m_pddsBackBuffer, &m_Boom, &m_Bullet);

	//  Ʈ
	m_Boom.Draw(&m_pddsBackBuffer);

	// Ʊ 
	m_cfForces.DrawSay(&m_pddsBackBuffer);
	m_cfForces.Draw(&m_pddsBackBuffer);
	m_cfForces.DrawInfo(&m_pddsBackBuffer);

	// Ʈ
	m_Effect.Draw(&m_pddsBackBuffer);

	// 
	m_Item.Draw(&m_pddsBackBuffer);

	//  Ѿ
	m_Bullet.Draw(&m_pddsBackBuffer);

	//  Ŭ
	m_cfForces.DrawClear(&m_pddsBackBuffer);

	// 
	m_Boss.DrawEnege(&m_pddsBackBuffer);

	// ޴ 
	POINT point;
	point.x = 300;
	point.y = 300;
	RECT rtDraw;
	MakeCenterToRect(&m_osPlayMenu.pSpr[m_nPlayMenu].ptSprCenterPos,
					 &m_osPlayMenu.pSpr[m_nPlayMenu].rcSprPos,
					 &point,
					 &rtDraw);

	m_pddsBackBuffer->BltFast(rtDraw.left, rtDraw.top,
							  m_psurPlayMenu->GetDDrawSurface(), 
							  &m_osPlayMenu.pSpr[m_nPlayMenu].rcSprPos, 
							  DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
}




//-----------------------------------------------------------------------------
// ȭ  Լ - ŷȭ
//-----------------------------------------------------------------------------
void CD2D::RenderRank()
{
	m_pddsBackBuffer->BltFast(0, 0,
							  m_psurRankBack->GetDDrawSurface(), 
							  NULL, 
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY);

	HDC hdc;
	char szPrint[MAX_PATH];
	m_pddsBackBuffer->GetDC(&hdc);

	SetTextColor(hdc, RGB(242, 101, 34));
	SetBkMode(hdc, TRANSPARENT);

	TextOut(hdc, 165, 237, m_Rank[0].szName, (int)strlen(m_Rank[0].szName));
	TextOut(hdc, 165, 302, m_Rank[1].szName, (int)strlen(m_Rank[1].szName));
	TextOut(hdc, 165, 365, m_Rank[2].szName, (int)strlen(m_Rank[2].szName));

	wsprintf(szPrint, "%ld", m_Rank[0].score);
	TextOut(hdc, 310, 237, szPrint, (int)strlen(szPrint));

	wsprintf(szPrint, "%ld", m_Rank[1].score);
	TextOut(hdc, 310, 302, szPrint, (int)strlen(szPrint));

	wsprintf(szPrint, "%ld", m_Rank[2].score);
	TextOut(hdc, 310, 365, szPrint, (int)strlen(szPrint));

	m_pddsBackBuffer->ReleaseDC(hdc);

	if (timeGetTime() - m_dwRankDealy > 5000)
	{
		// ŸƲ ȭ
		m_nGameStates = TITLE;

		// Ʈ ε 
		LoadTitle();		
		m_Boom.LoadBoom();
		//m_DShow.Stop();
		ReleaseRank();
		RankSave();
	}
}



//-----------------------------------------------------------------------------
// ȭ  Լ - ŷȭ
//-----------------------------------------------------------------------------
void CD2D::RenderSetName()
{
	Clear(0);
	m_pddsBackBuffer->BltFast(200, 200,
							  m_psurSetName->GetDDrawSurface(), 
							  NULL, 
							  DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY);

	HDC hdc;
	m_pddsBackBuffer->GetDC(&hdc);

	SetTextColor(hdc, RGB(242, 50, 34));
	SetBkMode(hdc, TRANSPARENT);

	TextOut(hdc, 410, 375, m_szName, (int)strlen(m_szName));

	m_pddsBackBuffer->ReleaseDC(hdc);
}



//-----------------------------------------------------------------------------
// Ű Է Լ - ̸
//-----------------------------------------------------------------------------
void CD2D::InputSetName()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0; i < (int)dwElements; i++)
	{
		if (didod[i].dwOfs == DIK_RETURN)	// ENTER Ű
		{
			if (didod[i].dwData && 0x80)
			{
				m_DMusic.PlaySound(SELECTED, FALSE);
				strcpy(m_Rank[3].szName, m_szName);
				m_Rank[3].score = m_cfForces.GetScore();

				// 
				RANK temp;
				for (int i = 0; i < 3; i++)
				{
					for (int j = i + 1; j < 4; j++)
					{
						if (m_Rank[i].score < m_Rank[j].score)
						{
							strcpy(temp.szName, m_Rank[i].szName);
							temp.score = m_Rank[i].score;

							strcpy(m_Rank[i].szName, m_Rank[j].szName);
							m_Rank[i].score = m_Rank[j].score;

							strcpy(m_Rank[j].szName, temp.szName);
							m_Rank[j].score = temp.score;
							
						}
					}
				}

				m_nGameStates = RANKING;
				ReleaseSetName();
				LoadRank();
			}
		}
		else if (didod[i].dwOfs == DIK_BACK) // 齺̽
		{
			if (didod[i].dwData && 0x80)
			{
				int index;
				if ((index = (int)strlen(m_szName)) != 0)
				{
					m_szName[index - 1] = '\0';
				}
			}
		}
		else if (didod[i].dwOfs == DIK_A)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "A");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_B)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "B");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_C)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "C");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_D)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "D");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_E)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "E");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_F)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "F");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_G)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "G");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_H)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "H");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_I)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "I");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_J)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "J");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_K)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "K");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_L)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "L");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_M)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "M");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_N)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "N");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_O)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "O");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_P)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "P");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_Q)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "Q");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_R)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "R");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_S)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "S");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_T)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "T");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_U)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "U");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_V)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "V");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_W)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "W");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_X)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "X");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_Y)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "Y");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
		else if (didod[i].dwOfs == DIK_Z)
		{
			if (didod[i].dwData && 0x80)
			{
				if (strlen(m_szName) < 5) strcat(m_szName, "Z");
				m_DMusic.PlaySound(CHANGE, FALSE);
			}
		}
	}
}

				


//-----------------------------------------------------------------------------
// Ű Է Լ - ÷ ޴
//-----------------------------------------------------------------------------
void CD2D::InputPlayMenu()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0; i < (int)dwElements; i++)
	{
		if (didod[i].dwOfs == DIK_RETURN)	// ENTER Ű
		{
			if (didod[i].dwData && 0x80)
			{
				if (m_nPlayMenu == 0)
				{
					m_nGameStates = TITLE;

					m_Boom.ReleaseBoom();
					m_Boss.ReleaseBoss();
					m_Bullet.ReleaseBullet();
					m_Effect.ReleaseEffect();
					m_cfForces.ReleaseForces();
					m_Item.ReleaseItem();
					m_Map.ReleaseMap();
					m_Enemy.ReleaseEnemy();
					ReleasePlayMenu();

					LoadTitle();		
					m_Boom.LoadBoom();
					m_DShow.Stop();
				}
				else if (m_nPlayMenu == 1)
				{
					m_nGameStates = PLAYING;
					m_nPlayMenu = 0;

					m_bKeydown[0] = FALSE;
					m_bKeydown[1] = FALSE;
					m_bKeydown[2] = FALSE;
					m_bKeydown[3] = FALSE;
				}
			}
		}
		else if (didod[i].dwOfs == DIK_UP)	// UP Ű
		{
			if (didod[i].dwData && 0x80)
			{
				m_DMusic.PlaySound(CHANGE, FALSE);
				if (--m_nPlayMenu < 0)
				{
					m_nPlayMenu = 0;
				}
			}
		}
		else if (didod[i].dwOfs == DIK_DOWN)	// UP Ű
		{
			if (didod[i].dwData && 0x80)
			{
				m_DMusic.PlaySound(CHANGE, FALSE);
				if (++m_nPlayMenu > 1)
				{
					m_nPlayMenu = 1;
				}
			}
		}
	}

}



//-----------------------------------------------------------------------------
// Ű Է Լ - ŸƲ ȭ
//-----------------------------------------------------------------------------
void CD2D::InputTitle()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0; i < (int)dwElements; i++)
	{
		if (didod[i].dwOfs == DIK_UP)	// UP Ű
		{
			if (didod[i].dwData && 0x80)
			{//----------------------------------------------------------------
				// 
				m_DMusic.PlaySound(CHANGE, FALSE);

				if (--m_nTitleSelect < 0) m_nTitleSelect = 0;
			}//----------------------------------------------------------------
		}
		else if (didod[i].dwOfs == DIK_DOWN)	// DOWN Ű
		{
			if (didod[i].dwData && 0x80)
			{//----------------------------------------------------------------
				// 
				m_DMusic.PlaySound(CHANGE, FALSE);

				if (++m_nTitleSelect > 2) m_nTitleSelect = 2;
			}//----------------------------------------------------------------
		}
		else if (didod[i].dwOfs == DIK_SPACE)	// ŷ Ű
		{
			if (didod[i].dwData && 0x80)
			{
					m_nGameStates = RANKING;
					m_DShow.Stop();
					LoadRank();
					ReleaseTitle();
			}
		}
		else if (didod[i].dwOfs == DIK_RETURN)	// ENTER Ű
		{
			if (didod[i].dwData && 0x80)
			{//----------------------------------------------------------------
				// 
				m_DMusic.PlaySound(SELECTED, FALSE);
				

				switch (m_nTitleSelect)
				{
				case START:		// 
					if (m_bDrawOrange == TRUE)
					{
						m_bStart = TRUE;
						m_dwStartDealy = timeGetTime();
						m_Boom.Add(0, 400, 200);
						m_Boom.Add(0, 480, 250);
						m_Boom.Add(1, 456, 239);
						m_DMusic.PlaySound(BOOM_L, FALSE);
						m_DMusic.PlaySound(BOOM_S, FALSE);
						m_DMusic.PlaySound(BOOM_M, FALSE);
					}
					break;
					
				case CREDIT:	// 
					if (m_bDrawOrange == TRUE)
					{
						m_nGameStates = CREDITT;
						m_dwCreDealy = timeGetTime();

						//  .
						m_DShow.Play(m_strBGM[BGM_CREDIT]);

						// Ʈ ε 
						LoadCredit();
						ReleaseTitle();

						m_bPlay = FALSE;
					}
					break;

				case EXIT:		// 
					if (m_bDrawOrange == TRUE)
					{
						m_DShow.Stop();
						m_nGameStates = EXITGAME;

						// Ʈ ε 
						LoadGameExit();
						ReleaseTitle();
					}
					break;
				}
			}//----------------------------------------------------------------
		}
		
	}// end for()
}



//-----------------------------------------------------------------------------
// Ű Է Լ - ɸ Ʈ
//-----------------------------------------------------------------------------
void CD2D::InputCSelect()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i=0; i < (int)dwElements; i++)
	{
		if (didod[i].dwOfs == DIK_RIGHT)	// RIGHT Ű
		{
			if (didod[i].dwData && 0x80)
			{//----------------------------------------------------------------
				// 
				m_DMusic.PlaySound(CHANGE, FALSE);

				if (++m_nChaSelect > 2)
					m_nChaSelect = 2;
			}//----------------------------------------------------------------
		}
		else if (didod[i].dwOfs == DIK_LEFT) // LEFT Ű
		{
			if (didod[i].dwData && 0x80)
			{//----------------------------------------------------------------
				// 
				m_DMusic.PlaySound(CHANGE, FALSE);

				if (--m_nChaSelect < 0)
					m_nChaSelect = 0;
			}//----------------------------------------------------------------
		}
		else if (didod[i].dwOfs == DIK_RETURN)	// ENTER Ű
		{
			if (didod[i].dwData && 0x80)
			{//----------------------------------------------------------------
				// 
				m_DMusic.PlaySound(SELECTED, FALSE);
				Sleep(200);

				m_nGameStates = METHOD;	//  
				m_cfForces.SetKindShip(m_nChaSelect);		// ɸ 
				
				m_DShow.Play(m_strBGM[BGM_METHOD]);

				// Ʈ ε
				LoadMethod();
				ReleaseCSelect();
			}//----------------------------------------------------------------
		}// end if()
	}// end for()

}




//-----------------------------------------------------------------------------
// Ű Է Լ - ÷ ȭ
//-----------------------------------------------------------------------------
void CD2D::InputPlaying()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	//  Ŭ
	if (m_cfForces.GetClear() == TRUE)
	{
		if (m_nStage == 4)
		{
			m_DShow.Stop();
			m_nGameStates = ENDING;
			m_dwEndDealy = timeGetTime();

			//  ۾
			m_Boom.ReleaseBoom();
			m_Boss.ReleaseBoss();
			m_Bullet.ReleaseBullet();
			m_Effect.ReleaseEffect();
			m_cfForces.ReleaseForces();
			m_Item.ReleaseItem();
			m_Map.ReleaseMap();
			m_Enemy.ReleaseEnemy();
			ReleasePlayMenu();

			// Ʈ ε
			LoadEnding();

			m_DMusic.StopSound(CLEAR);
		}
		else
		{
			m_DShow.Stop();
			m_nGameStates = S_INTRO;

			m_DMusic.StopSound(CLEAR);

		}
		m_dwTimeSIntro = timeGetTime();
		m_cfForces.SetClear(FALSE);

		return;
	}

	if ((m_cfForces.GetStateFish() == F_CREATE) || (m_cfForces.GetStateFish() == F_CLEAR))
		return;

	// Ű  б
	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0;i < (int)dwElements; i++)
	{
		//----------------------------------------------------------------
		if (didod[i].dwOfs == DIK_LEFT)
		{
			if (didod[i].dwData && 0x80)
			{
				// Űٿ
				m_bKeydown[LEFT] = TRUE;
				m_cfForces.SetStateFish(F_LEFT);
			}
			else
			{
				m_bKeydown[LEFT] = FALSE;
				m_cfForces.SetStateFish(F_FRONT);
			}
				// Ű 
		}
		//----------------------------------------------------------------
		else if (didod[i].dwOfs == DIK_RIGHT)
		{
			if (didod[i].dwData && 0x80)
			{
				// Űٿ
				m_bKeydown[RIGHT] = TRUE;
				m_cfForces.SetStateFish(F_RIGHT);
			}
			else
			{
				m_bKeydown[RIGHT] = FALSE;
				m_cfForces.SetStateFish(F_FRONT);
			}
				// Ű 
		}
		//----------------------------------------------------------------
		else if (didod[i].dwOfs == DIK_DOWN)
		{
			if (didod[i].dwData && 0x80)
				// Űٿ
				m_bKeydown[DOWN] = TRUE;
			else
				m_bKeydown[DOWN] = FALSE;
				// Ű 
		}
		//----------------------------------------------------------------
		else if (didod[i].dwOfs == DIK_UP)
		{
			if (didod[i].dwData && 0x80)
				// Űٿ
				m_bKeydown[UP] = TRUE;
			else
				m_bKeydown[UP] = FALSE;
				// Ű 
		}
		else if (didod[i].dwOfs == DIK_Z)
		{
			switch (m_nChaSelect)
			{
			case SP:
				// Ѿ ߰
				m_cfForces.BT_Add(30, 0, FALSE, 2);
				m_cfForces.BT_Add(-30, 0, FALSE, 2);
				m_cfForces.BT_Add(0, -10, FALSE, 2);
				m_DMusic.PlaySound(SHOT_N, FALSE);
				break;
				
			case PAI:
				// Ѿ ߰
				m_cfForces.BT_Add(30, +20, FALSE, 1);
				m_cfForces.BT_Add(-30, +20, FALSE, 0);
				m_cfForces.BT_Add(0, 0, FALSE, 2);
				m_DMusic.PlaySound(SHOT_N, FALSE);
				break;

			case ZT:
				// Ѿ ߰
				m_cfForces.BT_Add(60, 30, FALSE, 0);
				m_cfForces.BT_Add(-60, 30, FALSE, 1);
				m_cfForces.BT_Add(0, 0, FALSE, 2);
				m_DMusic.PlaySound(SHOT_N, FALSE);
				break;
			}

		}
		else if (didod[i].dwOfs == DIK_X)
		{
			if (didod[i].dwData && 0x80)
			{
				switch (m_nChaSelect)
				{
				case SP:
					//  
					if (m_cfForces.GetMp() >= 100)
					{
						POINT ptCenter = m_cfForces.GetCenterPos();
						m_Effect.Add(0, ptCenter.x, ptCenter.y - 60);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y - 40);
						m_cfForces.SetMP();
						m_cfForces.SetFace(FACE_SPSHOT);
						m_DMusic.PlaySound(SHOT_M, FALSE);


						POINT pt = m_cfForces.GetCenterPos();
						m_Boom.Add(1, pt.x, pt.y - 60);
						m_Boom.Add(0, pt.x - 30, pt.y - 90);
						m_Boom.Add(0, pt.x + 30, pt.y - 30);
						m_Boom.Add(0, pt.x - 30, pt.y - 30);
						m_Boom.Add(0, pt.x -+ 30, pt.y - 90);
					}
					break;

				case PAI:
					if (m_cfForces.GetMp() >= 100)
					{
						POINT ptCenter = m_cfForces.GetCenterPos();
						m_Effect.Add(0, ptCenter.x, ptCenter.y - 60);
						m_cfForces.BT_Add(ptCenter.x - 40, ptCenter.y - 40);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y - 60);
						m_cfForces.BT_Add(ptCenter.x + 40, ptCenter.y - 40);
						m_cfForces.SetMP();
						m_cfForces.SetFace(FACE_SPSHOT);
						m_DMusic.PlaySound(SHOT_M, FALSE);

						POINT pt = m_cfForces.GetCenterPos();
						m_Boom.Add(1, pt.x, pt.y - 60);
						m_Boom.Add(0, pt.x - 30, pt.y - 90);
						m_Boom.Add(0, pt.x + 30, pt.y - 30);
						m_Boom.Add(0, pt.x - 30, pt.y - 30);
						m_Boom.Add(0, pt.x -+ 30, pt.y - 90);
					}
					break;

				case ZT:
					//  
					if (m_cfForces.GetMp() >= 100)
					{
						POINT ptCenter = m_cfForces.GetCenterPos();
						m_Effect.Add(0, ptCenter.x, ptCenter.y - 60);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y - 40);
						m_cfForces.SetMP();
						m_cfForces.SetFace(FACE_SPSHOT);
						m_DMusic.PlaySound(SHOT_M, FALSE);

						POINT pt = m_cfForces.GetCenterPos();
						m_Boom.Add(1, pt.x, pt.y - 60);
						m_Boom.Add(0, pt.x - 30, pt.y - 90);
						m_Boom.Add(0, pt.x + 30, pt.y - 30);
						m_Boom.Add(0, pt.x - 30, pt.y - 30);
						m_Boom.Add(0, pt.x -+ 30, pt.y - 90);
					}
					break;
				}
			}

		}
		else if (didod[i].dwOfs == DIK_C)
		{
			if (didod[i].dwData && 0x80)
			{
				switch (m_nChaSelect)
				{
				case SP:
					//  
					if (m_cfForces.GetBoom() != 0)
					{
						m_cfForces.SetStateFish(F_MUJUC);
						POINT ptCenter = m_cfForces.GetCenterPos();

						m_cfForces.BT_Add(ptCenter.x - 150, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x + 150, ptCenter.y);

						m_cfForces.BT_Add(ptCenter.x, ptCenter.y - 150);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y + 150);

						m_cfForces.BT_Add(ptCenter.x, ptCenter.y);
					
						m_cfForces.SetBoom(-1);
						m_Bullet.AllDelBullet();			//  Ѿ 
						m_cfForces.SetFace(FACE_SPSHOT);
						m_DMusic.PlaySound(SHOT_B, FALSE);

						m_cfForces.SetPrevBullet(1);		// Ѿ -> Prev
						m_cfForces.SetBullet(9);			 //  Ѿ˷	
						m_cfForces.SetMTime(timeGetTime());
						m_cfForces.SetMujuc(TRUE);

						POINT pt = m_cfForces.GetCenterPos();
						m_Boom.Add(1, pt.x, pt.y - 60);
						m_Boom.Add(0, pt.x - 30, pt.y - 90);
						m_Boom.Add(0, pt.x + 30, pt.y - 30);
						m_Boom.Add(0, pt.x - 30, pt.y - 30);
						m_Boom.Add(0, pt.x -+ 30, pt.y - 90);
					}
					break;

				case PAI:
					// Űٿ
					//  
					if (m_cfForces.GetBoom() != 0)
					{
						m_cfForces.SetStateFish(F_MUJUC);
						POINT ptCenter = m_cfForces.GetCenterPos();

						m_cfForces.BT_Add(ptCenter.x, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y - 30);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y - 60);
		
						m_cfForces.BT_Add(ptCenter.x - 60, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x - 120, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x - 180, ptCenter.y);

						m_cfForces.BT_Add(ptCenter.x + 60, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x + 120, ptCenter.y);
						m_cfForces.BT_Add(ptCenter.x + 180, ptCenter.y);

						m_cfForces.BT_Add(ptCenter.x, ptCenter.y + 30);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y + 60);
		
						m_cfForces.SetBoom(-1);
						m_Bullet.AllDelBullet();  //  Ѿ 
						m_cfForces.SetFace(FACE_SPSHOT);
						m_DMusic.PlaySound(SHOT_B, FALSE);

						m_cfForces.SetPrevBullet(1);		// Ѿ -> Prev
						m_cfForces.SetBullet(9);			 //  Ѿ˷	
						m_cfForces.SetMTime(timeGetTime());
						m_cfForces.SetMujuc(TRUE);

						POINT pt = m_cfForces.GetCenterPos();
						m_Boom.Add(1, pt.x, pt.y - 60);
						m_Boom.Add(0, pt.x - 30, pt.y - 90);
						m_Boom.Add(0, pt.x + 30, pt.y - 30);
						m_Boom.Add(0, pt.x - 30, pt.y - 30);
						m_Boom.Add(0, pt.x -+ 30, pt.y - 90);
					}
					break;

				case ZT:
					// Űٿ
					//  
					if (m_cfForces.GetBoom() != 0)
					{
						m_cfForces.SetStateFish(F_MUJUC);
						POINT ptCenter = m_cfForces.GetCenterPos();

						m_cfForces.BT_Add(ptCenter.x - 60, ptCenter.y - 80);
						m_cfForces.BT_Add(ptCenter.x + 60, ptCenter.y - 80);

						m_cfForces.BT_Add(ptCenter.x, ptCenter.y + 100);
						m_cfForces.BT_Add(ptCenter.x, ptCenter.y - 150);
						m_cfForces.BT_Add(ptCenter.x + 120, ptCenter.y - 60);
						m_cfForces.BT_Add(ptCenter.x - 120, ptCenter.y - 60);
						m_cfForces.BT_Add(ptCenter.x + 240, ptCenter.y - 20);
						m_cfForces.BT_Add(ptCenter.x - 240, ptCenter.y - 20);
						m_cfForces.SetBoom(-1);
						m_Bullet.AllDelBullet();  //  Ѿ 
						m_cfForces.SetFace(FACE_SPSHOT);
						m_DMusic.PlaySound(SHOT_B, FALSE);

						m_cfForces.SetPrevBullet(1);		// Ѿ -> Prev
						m_cfForces.SetBullet(9);			 //  Ѿ˷	
						m_cfForces.SetMTime(timeGetTime());
						m_cfForces.SetMujuc(TRUE);

						POINT pt = m_cfForces.GetCenterPos();
						m_Boom.Add(1, pt.x, pt.y - 60);
						m_Boom.Add(0, pt.x - 30, pt.y - 90);
						m_Boom.Add(0, pt.x + 30, pt.y - 30);
						m_Boom.Add(0, pt.x - 30, pt.y - 30);
						m_Boom.Add(0, pt.x -+ 30, pt.y - 90);
					}
					break;
				}

			}

		}
		else if (didod[i].dwOfs == DIK_ESCAPE)
		{
			if (didod[i].dwData && 0x80)
			{
				m_nGameStates = PLAYMENU;
			}
		}
	}

	if (m_bKeydown[RIGHT])
		m_cfForces.MoveRight();
	if (m_bKeydown[LEFT])
		m_cfForces.MoveLeft();
	if (m_bKeydown[UP])
		m_cfForces.MoveUp();
	if (m_bKeydown[DOWN])
		m_cfForces.MoveDown();	
}





//-----------------------------------------------------------------------------
// Ű Է Լ -  
//-----------------------------------------------------------------------------
void CD2D::InputGameOver()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0;i < (int)dwElements; i++)
	{
		//----------------------------------------------------------------
		if (didod[i].dwOfs == DIK_RETURN)
		{
			if (didod[i].dwData && 0x80)
			{

				// ŸƲ ȭ
				//m_nGameStates = TITLE;

				// Ʈ ε 
				//LoadTitle();		
				//m_Boom.LoadBoom();
				//m_DShow.Stop();

				if ((m_NameIndex = NewScore()) < 3) // ھ
				{
					m_nGameStates = SETNAME;
					m_DShow.Stop();
					ReleaseGameOver();
					LoadSetName();
				}
				else // ׳ 
				{
					m_nGameStates = RANKING;
					m_DShow.Stop();
					ReleaseGameOver();
					LoadRank();
				}
			}
		}
	}
}





//-----------------------------------------------------------------------------
// Ű Է Լ -  ÷ 
//-----------------------------------------------------------------------------
void CD2D::InputMethod()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0;i < (int)dwElements; i++)
	{
		//----------------------------------------------------------------
		if (didod[i].dwOfs == DIK_RETURN)
		{
			if (didod[i].dwData && 0x80)
			{
				m_nGameStates = S_INTRO;
				m_dwTimeSIntro = timeGetTime();
				m_nStage = 1;  //  1

				//  
				m_DShow.Stop();

				// Ʈ ε
				LoadSIntro(1);
				ReleaseMethod();
			}
		}
	}
}




//-----------------------------------------------------------------------------
// Ű Է Լ -  
//-----------------------------------------------------------------------------
void CD2D::InputCredit()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0;i < (int)dwElements; i++)
	{
		//----------------------------------------------------------------
		if (didod[i].dwOfs == DIK_ESCAPE)
		{
			if (didod[i].dwData && 0x80)
			{
				if (m_bPlay == FALSE)
				{
					// ŸƲ ȭ
					m_nGameStates = TITLE;

					// Ʈ ε
					LoadTitle();
					ReleaseCredit();
					m_Boom.LoadBoom();
					m_DShow.Stop();
				}
				else
				{
					if ((m_NameIndex = NewScore()) < 3) // ھ
					{
						m_nGameStates = SETNAME;
						m_DShow.Stop();
						ReleaseCredit();
						LoadSetName();
					}
					else // ׳ 
					{
						m_nGameStates = RANKING;
						m_DShow.Stop();
						ReleaseCredit();
						LoadRank();
					}
				}
			}
		}
	}

}




//-----------------------------------------------------------------------------
// Ű Է Լ - 
//-----------------------------------------------------------------------------
void CD2D::InputEnding()
{
	// Ű ۿ
	DIDEVICEOBJECTDATA didod[BUFFER_SIZE_KEY];
	DWORD dwElements;

	m_DInputKey.ReadBufferedData(didod, &dwElements);

	for (int i = 0;i < (int)dwElements; i++)
	{
		//----------------------------------------------------------------
		if (didod[i].dwOfs == DIK_ESCAPE)
		{
			if (didod[i].dwData && 0x80)
			{
				m_nGameStates = CREDITT;
				m_nEndIndex = 0;
				ZeroMemory(m_bEndDraw, sizeof(m_bEndDraw)); 

				// 
				m_DShow.Stop();
				m_DShow.Play(m_strBGM[BGM_CREDIT]);

				// Ʈ ε
				LoadCredit();
				ReleaseEnding();

				m_bPlay = TRUE;
			}
		}
	}

}




//-----------------------------------------------------------------------------
// 浹 üũ Լ
//-----------------------------------------------------------------------------
void CD2D::CheckCrash()
{
	if ((m_cfForces.GetStateFish() == F_CREATE) || (m_cfForces.GetStateFish() == F_CLEAR))
		return;

	// Ʊ Ѿ - >  ü###################################################
	BULLET *BulletFish	= m_cfForces.GetBullet();				// Ʊ Ѿ
	ENEMY_LIST *Enemy	= m_Enemy.GetEnemy();					//  ü

	// ɸ
	BOSS_LIST *pBoss = m_Boss.GetListBoss();
	ONLY_SPRITE* posBoss;//

	ONLY_SPRITE* posFish	= m_cfForces.GetOnlySprite();		// Ʊ Ѿ Ʈ 
	ONLY_SPRITE* posEnemy	= m_Enemy.GetOnlySprite();			//  Ʈ 
	
	int nStateBullet		= m_cfForces.GetStateBullet();		// Ʊ Ѿ 

	RECT rtFish;
	RECT rtEnemy;
	RECT rtBoss;

	BULLET::iterator	 itorFish;
	ENEMY_LIST::iterator itorEnemy;
	BOSS_LIST::iterator	 itorBoss;

	int nCntFish  = -1;
	int nCntEnemy = -1;

	BOOL bDestroy;


	// ð ?? ## 2004.7.16
	for (itorFish = BulletFish->begin(); itorFish != BulletFish->end(); ++itorFish)
	{
		// Ʊ Ѿ ġ
		MakeCollToRect(&posFish->pSpr[nStateBullet].ptSprCenterPos,
					   &posFish->pSpr[nStateBullet].rcSprPos,
					   &posFish->pSpr[nStateBullet].rcSprCollision,
					   &(*itorFish)->ptPos, &rtFish);
		bDestroy = FALSE;

		for (itorEnemy = Enemy->begin(); itorEnemy != Enemy->end(); ++itorEnemy)
		{
			// ü ġ
			MakeCollToRect(&posEnemy->pSpr[(*itorEnemy)->nShip].ptSprCenterPos,
						   &posEnemy->pSpr[(*itorEnemy)->nShip].rcSprPos,
						   &posEnemy->pSpr[(*itorEnemy)->nShip].rcSprCollision,
						   &((*itorEnemy)->ptPos),
						   &rtEnemy);
			// 浹 ü
			// ((*itorEnemy)->nLife > 0) 2004.6.23 𶧹 ู ߴ..Ф
			if (IsCrash(rtFish, rtEnemy) == TRUE && ((*itorEnemy)->nLife > 0)) // 浹̸..
			{
				if (bDestroy == FALSE)
				{
					bDestroy = TRUE;

					// MP 
					m_cfForces.SetMP(2);
					
				}

				//   
				if ((*itorFish)->bSp == TRUE) // ƽ
				{
					(*itorEnemy)->nLife -= 5;
				}
				else // ϹѾ
				{
					if ((*itorFish)->bEx == TRUE)
						(*itorEnemy)->nLife -= 5;
					else
						(*itorEnemy)->nLife--;
					// Ʈ
					m_Effect.Add(2, (*itorEnemy)->ptPos.x + ((rand()%2)?20:-20), (*itorEnemy)->ptPos.y);
				}

				if (((*itorEnemy)->nLife) <= 0)
				{
					//  
					if ((*itorEnemy)->nFlag < 8)
					{
						m_DMusic.PlaySound(BOOM_S, FALSE);
						m_cfForces.SetScore(20);
					}
					else if (((*itorEnemy)->nFlag >= 8) && ((*itorEnemy)->nFlag <= 11))
					{
						m_DMusic.PlaySound(BOOM_M, FALSE);
						m_cfForces.SetScore(40);
					}
					else
					{
						m_DMusic.PlaySound(BOOM_S, FALSE);
						m_cfForces.SetScore(10);
					}


					//  
					switch ((*itorEnemy)->nFlag)
					{
					case 7:
						m_Item.Add(5, (*itorEnemy)->ptPos.x, (*itorEnemy)->ptPos.y);
						break;
					case 8:
						m_Item.Add(ITEM_P, (*itorEnemy)->ptPos.x, (*itorEnemy)->ptPos.y);
						break;
					case 9:
						m_Item.Add(ITEM_P, (*itorEnemy)->ptPos.x, (*itorEnemy)->ptPos.y);
						break;
					case 10:
						m_Item.Add(ITEM_B, (*itorEnemy)->ptPos.x, (*itorEnemy)->ptPos.y);
						break;
					case 11:
						m_Item.Add(ITEM_A, (*itorEnemy)->ptPos.x, (*itorEnemy)->ptPos.y);
						break;
					}
	
	
				}
				(*itorEnemy)->nState = WARING;
			}
		} // ü for


		// Ʊ Ѿ VS ü 浹üũ
		for (itorBoss = pBoss->begin(); itorBoss != pBoss->end(); ++itorBoss)
		{
			posBoss	= m_Boss.GetOnlySprite((*itorBoss)->nOpt);

			//  浹
			MakeCollToRect(&posBoss->pSpr[(*itorBoss)->nDrawBoss].ptSprCenterPos,
						   &posBoss->pSpr[(*itorBoss)->nDrawBoss].rcSprPos,
						   &posBoss->pSpr[(*itorBoss)->nDrawBoss].rcSprCollision,
						   &(*itorBoss)->ptPos, &rtBoss);

			// 浹̸..
			if (IsCrash(rtFish, rtBoss) == TRUE && ((*itorBoss)->nLife > 0)) 
			{
				if (!bDestroy)
				{
					bDestroy = TRUE;
				}

				// ¦ ¦
				(*itorBoss)->nState = B_WARNING;

				//   
				if ((*itorFish)->bSp == TRUE) // ƽ
				{
					(*itorBoss)->nLife -= 5;
				}
				else // ϹѾ
				{
					if ((*itorFish)->bEx == TRUE)
						(*itorBoss)->nLife -= 5;
					else
						(*itorBoss)->nLife--;

					// Ʈ
					m_Effect.Add(2, (*itorBoss)->ptPos.x + ((rand()%2)?20:-20), (*itorBoss)->ptPos.y);
				}

				//  Ʊü MP 
				m_cfForces.SetMP(2);
			}
		}


		// Ʊ Ѿ  ߰
		if (bDestroy == TRUE)
		{
			(*itorFish)->bLife = FALSE;
		}

	}// out - for



	// Ʊü - >  Ѿ###################################################
	POINT ptFishPos = m_cfForces.GetCenterPos();		// ǽ ߽ǥ
	int nDrawFish = m_cfForces.GetDrawFish();
	// posFish

	BULLET_LIST* pBullet = m_Bullet.GetBullet();		//  Ѿ Ʈ
	ONLY_SPRITE* posBullet = m_Bullet.GetOnlySprite();	//  Ѿ 

	//rtFish
	RECT rtBullet;
	BULLET_LIST::iterator itorBullet;

	// Ʊ ü 浹 ǥ
	MakeCollToRect(&(posFish->pSpr[nDrawFish].ptSprCenterPos),
				   &(posFish->pSpr[nDrawFish].rcSprPos),
				   &(posFish->pSpr[nDrawFish].rcSprCollision),	
				   &ptFishPos, &rtFish);

	// Ʊü VS  Ѿ	############
	for (itorBullet = pBullet->begin(); itorBullet != pBullet->end(); ++itorBullet)
	{
		for (int i = 0; i < (*itorBullet)->nCnt; i++)
		{
			// ȭ ǥ 
			MakeCollToRect(&posBullet->pSpr[(*itorBullet)->nIndex].ptSprCenterPos,
						   &posBullet->pSpr[(*itorBullet)->nIndex].rcSprPos,
						   &posBullet->pSpr[(*itorBullet)->nIndex].rcSprCollision,
						   &((*itorBullet)->pptBullet[i]),
						   &rtBullet);

			// 浹 üũ
			if ((IsCrash(rtFish, rtBullet) == TRUE) && ((*itorBullet)->pbLife[i]))
			{
				// 浹̸..
				(*itorBullet)->pbLife[i] = FALSE;


				// ϶
				if ((m_cfForces.GetMujuc() == FALSE) && (m_cfForces.GetStateFish() != F_CREATE))
				{
					m_cfForces.SetHP(10);
					// 
					m_DMusic.PlaySound(CRASH, FALSE);
					// Ʈ
					POINT ptEffect = m_cfForces.GetCenterPos();
					m_Effect.Add(1, ptEffect.x, ptEffect.y);

					// ¦..
					m_cfForces.SetStateFish(F_WARING);

					//  
					m_cfForces.SetFace(FACE_WARNING);
				}	
			}
		}
	}

	// Ʊ ü VS ü 浹üũ #########
	for (itorBoss = pBoss->begin(); itorBoss != pBoss->end(); ++itorBoss)
	{
		posBoss	= m_Boss.GetOnlySprite((*itorBoss)->nOpt);

		//  浹
		MakeCollToRect(&posBoss->pSpr[(*itorBoss)->nDrawBoss].ptSprCenterPos,
					   &posBoss->pSpr[(*itorBoss)->nDrawBoss].rcSprPos,
					   &posBoss->pSpr[(*itorBoss)->nDrawBoss].rcSprCollision,
					   &(*itorBoss)->ptPos, &rtBoss);

		// 浹̸..
		if ((IsCrash(rtFish, rtBoss) == TRUE) && ((*itorBoss)->nLife > 0)) 
		{
			// ¦ ¦
			(*itorBoss)->nState = B_WARNING;

			// 
			(*itorBoss)->nLife--;

			// ° ƴҰ
			if ((m_cfForces.GetMujuc() == FALSE) && (m_cfForces.GetStateFish() != F_CREATE))
			{
				m_cfForces.SetHP(10);

				// Ʈ
				POINT ptEffect = m_cfForces.GetCenterPos();
				m_Effect.Add(1, ptEffect.x, ptEffect.y);

				// ¦..
				m_cfForces.SetStateFish(F_WARING);

				//  
				m_cfForces.SetFace(FACE_WARNING);
			}
		}
	}


	// Ʊü -> ü ###################################################
	for (itorEnemy = Enemy->begin(); itorEnemy != Enemy->end(); ++itorEnemy)
	{
		// ü ġ
		MakeCollToRect(&posEnemy->pSpr[(*itorEnemy)->nShip].ptSprCenterPos,
					   &posEnemy->pSpr[(*itorEnemy)->nShip].rcSprPos,
					   &posEnemy->pSpr[(*itorEnemy)->nShip].rcSprCollision,
					   &((*itorEnemy)->ptPos),
					   &rtEnemy);

			// 浹 ü
		if (IsCrash(rtFish, rtEnemy) == TRUE)
		{
			bDestroy = TRUE;

			// HP 
			if ((m_cfForces.GetMujuc() == FALSE) && (m_cfForces.GetStateFish() != F_CREATE))
			{
				m_cfForces.SetHP(10);
				m_cfForces.SetStateFish(F_WARING);
			}


			if ((--(*itorEnemy)->nLife) <= 0)
			{
				//  
				if ((*itorEnemy)->nShip <= 7)
					m_DMusic.PlaySound(BOOM_S, FALSE);
				else if ((*itorEnemy)->nShip > 8 && (*itorEnemy)->nShip <= 11)
					m_DMusic.PlaySound(BOOM_M, FALSE);
				else
					m_DMusic.PlaySound(BOOM_S, FALSE);
			}
			(*itorEnemy)->nState = WARING;
		}


	}// in _ for

	
	ITEM_LIST* listItem = m_Item.GetItemList();
	ONLY_SPRITE* posItem = m_Item.GetOnlySprite();
	RECT rtItem;

	ITEM_LIST::iterator itorItem;
	// Ʊü ->  ###################################################
	for (itorItem = listItem->begin(); itorItem != listItem->end(); ++itorItem)
	{
		// ü ġ // error!!
		MakeCollToRect(&posItem->pSpr[(*itorItem)->nIndex].ptSprCenterPos,
					   &posItem->pSpr[(*itorItem)->nIndex].rcSprPos,
					   &posItem->pSpr[(*itorItem)->nIndex].rcSprCollision,
					   &((*itorItem)->ptPos),
					   &rtItem);

			// 浹 ü
		if (IsCrash(rtFish, rtItem) == TRUE)
		{
			// 
			m_DMusic.PlaySound(ITEM, FALSE);

			//  ȿ 
			switch ((*itorItem)->nFlag)
			{
			case ITEM_P:
				if (m_cfForces.GetStateBullet() == 8)
				{
					m_Item.Add(ITEM_500, (*itorItem)->ptPos.x, (*itorItem)->ptPos.y);
					// 
					m_cfForces.SetScore(500);
				}
				else
				{
					m_Item.Add(ITEM_PW, (*itorItem)->ptPos.x, (*itorItem)->ptPos.y);
				}

				if (m_cfForces.GetMujuc() == TRUE)
					m_cfForces.SetPrevBullet();
				else
					m_cfForces.SetBullet(1);
				(*itorItem)->bLife = FALSE;
				break;

			case ITEM_B:
				m_cfForces.SetBoom(1);
				(*itorItem)->bLife = FALSE;
				break;

			case ITEM_A:
				m_cfForces.SetBoom(1);

				if (m_cfForces.GetMujuc() == TRUE)
					m_cfForces.SetPrevBullet();
				else
					m_cfForces.SetBullet(1);

				(*itorItem)->bLife = FALSE;
				break;

			case 5:
				m_cfForces.SetHP(-50);
				(*itorItem)->bLife = FALSE;
				break;
			}
		}

	}// in _ for	
}





//-----------------------------------------------------------------------------
//  浹 üũ Լ
//-----------------------------------------------------------------------------
BOOL CD2D::IsCrash(RECT rt1, RECT rt2)
{
	if (rt1.left > rt2.right || rt1.right < rt2.left || 
		rt1.top > rt2.bottom || rt1.bottom < rt2.top)
	{
		return FALSE;
	}
	else
		return TRUE;

}



//-----------------------------------------------------------------------------
// ο ھ?
// ϰ ŷ
//-----------------------------------------------------------------------------
int CD2D::NewScore()
{
	int result = 0;
	DWORD score = m_cfForces.GetScore();

	for (int i = 0; i < 3; i++)
	{
		if (score < m_Rank[i].score)
			result++;
	}

	return result;
}




//-----------------------------------------------------------------------------
// ŷ Ͽ ε
//-----------------------------------------------------------------------------
void CD2D::RankLoad()
{
	FILE  *fp;
	
	//  
	fp = fopen("rank.dat", "rb");
	if (fp == NULL)
		return;

	fread(m_Rank, sizeof(RANK), 3, fp);

	fclose(fp);
}



//-----------------------------------------------------------------------------
// ŷ Ͽ ̺
//-----------------------------------------------------------------------------
void CD2D::RankSave()
{
	FILE  *fp;
	
	//  
	fp = fopen("rank.dat", "wb");
	if (fp == NULL)
		return;

	fwrite(m_Rank, sizeof(RANK), 3, fp);

	fclose(fp);
}



//-----------------------------------------------------------------------------
// Ʈ  Ʈ &Ʈ о̴ Լ
//-----------------------------------------------------------------------------
BOOL CD2D::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
		return FALSE;

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
	{
		delete[] os->pSpr;
		os->pSpr = NULL;
		return FALSE;
	}

	fclose(fp);

	return TRUE;
}





//-----------------------------------------------------------------------------
// ONLY_SPRITE Ҵ  Լ
//-----------------------------------------------------------------------------
void CD2D::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
	{
		delete[] os->pSpr;
		os->pSpr = NULL;
	}
}




//-----------------------------------------------------------------------------
// ߽ǥ ̿ؼ ȭ  ǥ 
//  - 1 : Ʈ ߽ǥ
//        2 : Ʈ ̹ǥ
//		  3 : ũ ߽ǥ
//        4 :   ǥ
//-----------------------------------------------------------------------------
inline void CD2D::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
										POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);

}




//-----------------------------------------------------------------------------
// ߽ǥ ̿ؼ ȭ 浹 ǥ 
//  - 1 : Ʈ ߽ǥ
//        2 : Ʈ ̹ǥ
//        3 : Ʈ 浹 ǥ
//		  4 : ũ ߽ǥ
//        5 :   ǥ
//-----------------------------------------------------------------------------
inline void CD2D::MakeCollToRect(POINT *ptSprite, RECT *rtSprite, RECT *rtColl,
									POINT *ptScreen, RECT *rtScreen)
{
	// ߽ǥ 
	int left = ptScreen->x - ((ptSprite->x));
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top + (rtSprite->bottom - rtSprite->top);

	left	+= rtColl->left;
	top		+= rtColl->top;
	right	-= ((rtSprite->right - rtSprite->left) - rtColl->right);
	bottom	-= ((rtSprite->bottom - rtSprite->top) - rtColl->bottom);

	SetRect(rtScreen, left, top, right, bottom);

}









