//-----------------------------------------------------------------------------
// NOTE : CEffect Ŭ 
//  :  ȿ Ŭ
// ϸ : CEffect.cpp
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------

#include "CEffect.h"


//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CEffect::CEffect()
{
	
}


CEffect::~CEffect()
{

}



//-----------------------------------------------------------------------------
// ʱȭ (ǥ ,)
//-----------------------------------------------------------------------------
void CEffect::Create(LPDIRECTDRAW7 *pDD)
{
	m_pDD = *pDD;
}





//-----------------------------------------------------------------------------
// ʱⰪ..
//-----------------------------------------------------------------------------
void CEffect::InitEffect()
{
	EFFECT_LIST::iterator itor;

	for (itor = m_listEffect.begin(); itor != m_listEffect.end(); ++itor)
	{
		delete (*itor);
	}

	m_listEffect.clear();
}






//-----------------------------------------------------------------------------
// ʱⰪ..
//-----------------------------------------------------------------------------
void CEffect::LoadEffect()
{
	//  ۾
	ReleaseEffect();

	// Ʈ  б ## ϰ  ٶ ##
	LoadOnlySprData("spr\\e_1.spr", (ONLY_SPRITE*)&m_osEffect[0]);
	LoadOnlySprData("spr\\e_2.spr", (ONLY_SPRITE*)&m_osEffect[1]);
	LoadOnlySprData("spr\\e_3.spr", (ONLY_SPRITE*)&m_osEffect[2]);
	LoadOnlySprData("spr\\e_4.spr", (ONLY_SPRITE*)&m_osEffect[3]);

	CreateSurfaceFromBitmap(&m_psurEffect[0], "image\\e_1.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurEffect[1], "image\\e_2.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurEffect[2], "image\\e_3.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurEffect[3], "image\\e_4.ora", NULL, NULL);

	m_psurEffect[0]->SetColorKey(RGB(0, 0, 0));
	m_psurEffect[1]->SetColorKey(RGB(0, 0, 0));
	m_psurEffect[2]->SetColorKey(RGB(0, 0, 0));
	m_psurEffect[3]->SetColorKey(RGB(0, 0, 0));

}





//-----------------------------------------------------------------------------
// ʱⰪ..
//-----------------------------------------------------------------------------
void CEffect::ReleaseEffect()
{
	if (m_psurEffect[0]) m_psurEffect[0]->Destroy();
	if (m_psurEffect[1]) m_psurEffect[1]->Destroy();
	if (m_psurEffect[2]) m_psurEffect[2]->Destroy();
	if (m_psurEffect[3]) m_psurEffect[3]->Destroy();

	DestroyLOSD(&m_osEffect[0]);
	DestroyLOSD(&m_osEffect[1]);
	DestroyLOSD(&m_osEffect[2]);
	DestroyLOSD(&m_osEffect[3]);

	m_psurEffect[0] = NULL;
	m_psurEffect[1] = NULL;
	m_psurEffect[2] = NULL;
	m_psurEffect[3] = NULL;
}



//-----------------------------------------------------------------------------
// Ʈ ߰
//-----------------------------------------------------------------------------
void CEffect::Add(int flag, int x, int y)
{
	EFFECT *add;
	add = new EFFECT;
	if (add == NULL)
		return;
	
	add->ptPos.x = x;
	add->ptPos.y = y;
	add->nIndex	 = -1;
	add->bDraw   = TRUE;
	add->nFlag	 = flag;

	m_listEffect.push_back(add);
}




//-----------------------------------------------------------------------------
// Ʈ Ʈ
//-----------------------------------------------------------------------------
void CEffect::Update()
{
	EFFECT_LIST::iterator itor;
	EFFECT_LIST::iterator del[30];
	int nCnt = -1;;

	for (itor = m_listEffect.begin(); itor != m_listEffect.end(); ++itor)
	{
		switch ((*itor)->nFlag)
		{
		case 0:		// Ʈ 0 - Ʊü Ư
			if (++(*itor)->nIndex > 9)
			{
				del[++nCnt] = itor;
			}
			break;

		case 1:		// Ʈ 1	- Ʊü ѿ ¾
			if (++(*itor)->nIndex > 5)
			{
				del[++nCnt] = itor;
			}
			break;
		case 2:		// Ʈ 2 - ü Ѿ˿ ¾
			if (++(*itor)->nIndex > 6)
			{
				del[++nCnt] = itor;
			}
			break;
		case 3:		// Ʈ 3 - Ʊü  Ʈ
			if (++(*itor)->nIndex > 18)
			{
				del[++nCnt] = itor;
			}
			break;
		} // switch

	}


	// 
	for (int i = 0; i <= nCnt; i++)
	{
		delete *del[i];
		m_listEffect.erase(del[i]);
	}

}




//-----------------------------------------------------------------------------
// Ʈ ׸
//-----------------------------------------------------------------------------
void CEffect::Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	EFFECT_LIST::iterator itor;
	RECT rtDraw, rtSprite;

	// Ʈ
	//Update();


	// Ʈ ο
	for (itor = m_listEffect.begin(); itor != m_listEffect.end(); ++itor)
	{
		MakeCenterToRect(&m_osEffect[(*itor)->nFlag].pSpr[(*itor)->nIndex].ptSprCenterPos,
						 &m_osEffect[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos,
						 &(*itor)->ptPos,
						 &rtDraw);


		//## ----------------------------------------
		rtSprite.left	= m_osEffect[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.left;
		rtSprite.top	= m_osEffect[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.top;
		rtSprite.right	= m_osEffect[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.right;
		rtSprite.bottom = m_osEffect[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.bottom;


		
		//  Ų 
		if (rtDraw.left < 0)
		{
			rtSprite.left += (-rtDraw.left);
			rtDraw.left = 0;
		}
		if (rtDraw.right > 600)
		{
			rtSprite.right -= (rtDraw.right - 600);
			rtDraw.right = 600;
		}
		if (rtDraw.top < 0)
		{
			rtSprite.top += (-rtDraw.top);
			rtDraw.top = 0;

		}
		if (rtDraw.bottom > 600)
		{
			rtSprite.bottom -= (rtDraw.bottom - 600);
			rtDraw.bottom = 600;
		}
	
		//(*m_pddsBB)->Blt(&rtDraw, m_psurEffect[(*itor)->nFlag]->GetDDrawSurface(),
		//				 &rtSprite,
		//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);


		(*m_pddsBB)->BltFast(rtDraw.left, rtDraw.top,
								m_psurEffect[(*itor)->nFlag]->GetDDrawSurface(),
								&rtSprite,
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}




}





//-----------------------------------------------------------------------------
// Ʈ ı
//-----------------------------------------------------------------------------
void CEffect::Destroy()
{
	EFFECT_LIST::iterator itor;

	for (itor = m_listEffect.begin(); itor != m_listEffect.end(); ++itor)
	{
		delete (*itor);
	}

	if (m_psurEffect[0]) m_psurEffect[0]->Destroy();
	if (m_psurEffect[1]) m_psurEffect[1]->Destroy();
	if (m_psurEffect[2]) m_psurEffect[2]->Destroy();
	if (m_psurEffect[3]) m_psurEffect[3]->Destroy();

	DestroyLOSD(&m_osEffect[0]);
	DestroyLOSD(&m_osEffect[1]);
	DestroyLOSD(&m_osEffect[2]);
	DestroyLOSD(&m_osEffect[3]);

	
}





//-----------------------------------------------------------------------------
// Ʈ  ε
//-----------------------------------------------------------------------------
BOOL CEffect::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
		return FALSE;

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
	{
		delete[] os->pSpr;
		os->pSpr = NULL;
		return FALSE;
	}

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  
//-----------------------------------------------------------------------------
void CEffect::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
		delete[] os->pSpr;
	os->pSpr = NULL;

}



//-----------------------------------------------------------------------------
// ǥ ̿ؼ ȭ ǥ 
//-----------------------------------------------------------------------------
inline void CEffect::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
							POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);

}










