//-----------------------------------------------------------------------------
// NOTE : CEffect Ŭ 
//  : Ʈ ȿ Ŭ
// ϸ : CEffect.h
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------

#ifndef _CEFFECT_H_
#define _CEFFECT_H_

#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include <list>
using namespace std;

class CEffect;

struct EFFECT
{
	POINT	ptPos;		// Ʈ ǥ
	int		nIndex;		// Ʈ ε
	BOOL	bDraw;		// ı
	int		nFlag;		// Ʈ 
};

typedef list<EFFECT*>	EFFECT_LIST;


//-----------------------------------------------------------------------------
class CEffect : public CDisplay
{
	private:
		EFFECT_LIST m_listEffect;

		CSurface		*m_psurEffect[4];		// EFFECT ǥ		
		ONLY_SPRITE		 m_osEffect[4];			// EFFECT Ʈ 

	public:
		CEffect();
		virtual ~CEffect();

		void	Create(LPDIRECTDRAW7 *pDD);
		void	InitEffect();

		void	LoadEffect();
		void	ReleaseEffect();

		void	Update();
		void	Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB);
		void	Destroy();
		void	Add(int index, int x, int y);

		EFFECT_LIST* GetListEffect() { return &m_listEffect; }

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);
};

//-----------------------------------------------------------------------------

#endif
