//-----------------------------------------------------------------------------
// NOTE : CEnemy Ŭ  
//  :   Ŭ
// ϸ : CEnemy.cpp
// 2004.8.27	ora_llundiov
//-----------------------------------------------------------------------------


#include "CEnemy.h"

//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CEnemy::CEnemy()
{
	m_psurShip		= NULL;
}


CEnemy::~CEnemy()
 {
 }


//-----------------------------------------------------------------------------
 // ʱȭ Լ
//-----------------------------------------------------------------------------
void CEnemy::Create(LPDIRECTDRAW7 *pDD)
{
	m_pDD = *pDD;
}





//-----------------------------------------------------------------------------
 // ʱⰪ
//-----------------------------------------------------------------------------
void CEnemy::InitEnemy()
{
	// 
	ENEMY_LIST::iterator itorShip;
	for (itorShip = m_listEnemy.begin(); itorShip != m_listEnemy.end(); ++itorShip)
	{
		delete (*itorShip);
	}

	m_listEnemy.clear();
}




//-----------------------------------------------------------------------------
 // ʱⰪ
//-----------------------------------------------------------------------------
void CEnemy::LoadEnemy(int nStage)
{
	// 
	ReleaseEnemy();

	switch (nStage)
	{
	case 1:
		{
			// Ʈ ǥ
			CreateSurfaceFromBitmap(&m_psurShip, "image\\e_ship.ora", NULL, NULL);
			m_psurShip->SetColorKey(RGB(0, 255, 0));
			// Ʈ 
			LoadOnlySprData("spr\\e_ship.spr", (ONLY_SPRITE*)&m_osShip);
		}
		break;

	case 2:
		{
			CreateSurfaceFromBitmap(&m_psurShip, "image\\e_ship1.ora", NULL, NULL);
			m_psurShip->SetColorKey(RGB(0, 255, 0));
			LoadOnlySprData("spr\\e_ship1.spr", (ONLY_SPRITE*)&m_osShip);
		}
		break;

	case 3:
		{
			CreateSurfaceFromBitmap(&m_psurShip, "image\\e_ship2.ora", NULL, NULL);
			m_psurShip->SetColorKey(RGB(0, 255, 0));
			LoadOnlySprData("spr\\e_ship2.spr", (ONLY_SPRITE*)&m_osShip);
		}
		break;
	}
}






//-----------------------------------------------------------------------------
 // ʱⰪ
//-----------------------------------------------------------------------------
void CEnemy::ReleaseEnemy()
{
	DestroyLOSD(&m_osShip);
	if (m_psurShip) m_psurShip->Destroy();

	m_psurShip = NULL;
}



//-----------------------------------------------------------------------------
//  ߰
// ship		:  
// move		:  
// bul		: Ѿ 
// move		: ̵ 
// bulmove  : Ѿ 
// dealy	: Ѿ ߻ 
//-----------------------------------------------------------------------------
void CEnemy::AddShip(int x, int y, int ship, int move, int bul,
					 int bulmove, DWORD dealy)
{
	ENEMY *add;
	add = new ENEMY;
	if (add == NULL)
		return;

	add->nShip		= ship;
	add->nFlag		= ship;
	add->nMove		= move;
	add->nState		= NORMAL;

	add->dwDealy	 = dealy;
	add->nBullet	 = bul;
	add->nBulMove	 = bulmove;

	//   
	if (ship <= 7)
		add->nLife = 20;
	else if (ship > 7 && ship <= 11)
		add->nLife = 70;
	else
		add->nLife = 6;

	// ʱ 
	add->ptPos.x	= x;
	add->ptPos.y	= y;

	switch (move)
	{
	case 0:
		add->nMoveX		= -4.;
		add->nMoveY		= 4.;
		add->nAcc		= 0.1;
		break;

	case 1:
		add->nMoveX		= 4.;
		add->nMoveY		= 4.;
		add->nAcc		= 0.1;
		break;

	case 2:
		add->nMoveX		= 0.;
		add->nMoveY		= 3.;
		add->nAcc		= 0.;
		break;

	case 3:
		add->nMoveX		= 0.;
		add->nMoveY		= 3.;
		add->nAcc		= 0.;
		break;

	case 4:
		add->nMoveX		= 0.;
		add->nMoveY		= 4.;
		add->nAcc		= 0.1;
		break;

	case 5:
		add->nMoveX		= 0.;
		add->nMoveY		= 4.;
		add->nAcc		= 0.;
		break;
	}

	add->dwCreateTime = timeGetTime();
	

	m_listEnemy.push_back(add);
}




//-----------------------------------------------------------------------------
//   Ʈ
//-----------------------------------------------------------------------------
void CEnemy::UpdateShip(CBoom *pBoom, CBullet *pBullet)
{
	ENEMY_LIST::iterator itor;
	ENEMY_LIST::iterator del[30];
	int index = -1;


	for (itor = m_listEnemy.begin(); itor != m_listEnemy.end(); ++itor)
	{
		// ̵ Ʈ
		switch ((*itor)->nMove)
		{
		case 0:// -----------------------------------------------
			// ǥ Ʈ
			(*itor)->ptPos.x += (int)(*itor)->nMoveX;
			(*itor)->ptPos.y += (int)(*itor)->nMoveY;
			(*itor)->nMoveY  += (*itor)->nAcc;

			// Ѿ 
			if (((timeGetTime() - (*itor)->dwCreateTime) > (*itor)->dwDealy) && ((*itor)->ptPos.y < 300))
			{
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y + 60, (*itor)->nBulMove, (*itor)->nBullet);
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 5, 0);
				(*itor)->dwCreateTime = timeGetTime();
			}
			break;

		case 1:// -----------------------------------------------
			// ǥ Ʈ
			(*itor)->ptPos.x += (int)(*itor)->nMoveX;
			(*itor)->ptPos.y += (int)(*itor)->nMoveY;
			(*itor)->nMoveY  += (*itor)->nAcc;

			// Ѿ 
			if (((timeGetTime() - (*itor)->dwCreateTime) > (*itor)->dwDealy) && ((*itor)->ptPos.y < 300))
			{
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y + 60, (*itor)->nBulMove, (*itor)->nBullet);
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 5, 0);
				(*itor)->dwCreateTime = timeGetTime();
			}
			break;

		case 2:// -----------------------------------------------
			// ǥ Ʈ
			(*itor)->ptPos.x += (int)(*itor)->nMoveX;
			(*itor)->ptPos.y += (int)(*itor)->nMoveY;
			(*itor)->nMoveY  += (*itor)->nAcc;

			if ((*itor)->ptPos.y > 200)
			{
				(*itor)->nMoveY = 0;
				(*itor)->nMoveX = 1;
			}

			// Ѿ 
			if (((timeGetTime() - (*itor)->dwCreateTime) > (*itor)->dwDealy) && ((*itor)->ptPos.y < 250))
			{
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y + 60, (*itor)->nBulMove, (*itor)->nBullet);
				(*itor)->dwCreateTime = timeGetTime();
			}
			break;

		case 3:// -----------------------------------------------
			// ǥ Ʈ
			(*itor)->ptPos.x += (int)(*itor)->nMoveX;
			(*itor)->ptPos.y += (int)(*itor)->nMoveY;
			(*itor)->nMoveY  += (*itor)->nAcc;

			if ((*itor)->ptPos.y > 210)
			{
				(*itor)->nMoveY = 0;
				(*itor)->nMoveX = -1;
			}

			// Ѿ 
			if (((timeGetTime() - (*itor)->dwCreateTime) > (*itor)->dwDealy) && ((*itor)->ptPos.y < 250))
			{
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y + 60, (*itor)->nBulMove, (*itor)->nBullet);
				//pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 5, 1);
				(*itor)->dwCreateTime = timeGetTime();
			}
			break;

		case 4:// -----------------------------------------------
			// ǥ Ʈ
			(*itor)->ptPos.x += (int)(*itor)->nMoveX;
			(*itor)->ptPos.y += (int)(*itor)->nMoveY;
			(*itor)->nMoveY  += (*itor)->nAcc;

			if (((timeGetTime() - (*itor)->dwCreateTime) > (*itor)->dwDealy) && ((*itor)->ptPos.y < 250))
			{
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y + 60, (*itor)->nBulMove, (*itor)->nBullet);
				//pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 5, 1);
				(*itor)->dwCreateTime = timeGetTime();
			}
			break;

		case 5:// -----------------------------------------------
			// ǥ Ʈ
			(*itor)->ptPos.x += (int)(*itor)->nMoveX;
			(*itor)->ptPos.y += (int)(*itor)->nMoveY;
			(*itor)->nMoveY  += (*itor)->nAcc;

			if (((timeGetTime() - (*itor)->dwCreateTime) > (*itor)->dwDealy) && ((*itor)->ptPos.y < 250))
			{
				pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y + 60, (*itor)->nBulMove, (*itor)->nBullet);
				//pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 5, 1);
				(*itor)->dwCreateTime = timeGetTime();
			}
			break;
		}// -----------------------------------------------


		//  Ʈ ¦ ¦..^^
		if ((*itor)->nState == WARING)
		{
			switch ((*itor)->nFlag)
			{
			case 1:
				if ((*itor)->nShip != 2)
					(*itor)->nShip = 2;
				else
				{
					(*itor)->nShip = 0;
					(*itor)->nState = NORMAL;
				}
				break;
			case 2:
				if ((*itor)->nShip != 5)
					(*itor)->nShip = 5;
				else
				{
					(*itor)->nShip = 3;
					(*itor)->nState = NORMAL;
				}
				break;
			case 3:
				if ((*itor)->nShip != 8)
					(*itor)->nShip = 8;
				else
				{
					(*itor)->nShip = 6;
					(*itor)->nState = NORMAL;
				}
				break;
			case 4:
				if ((*itor)->nShip != 11)
					(*itor)->nShip = 11;
				else
				{
					(*itor)->nShip = 9;
					(*itor)->nState = NORMAL;
				}
				break;
			case 5:
				if ((*itor)->nShip != 14)
					(*itor)->nShip = 14;
				else
				{
					(*itor)->nShip = 12;
					(*itor)->nState = NORMAL;
				}
				break;
			case 6:
				if ((*itor)->nShip != 17)
					(*itor)->nShip = 17;
				else
				{
					(*itor)->nShip = 15;
					(*itor)->nState = NORMAL;
				}
				break;
			case 7:
				if ((*itor)->nShip != 20)
					(*itor)->nShip = 20;
				else
				{
					(*itor)->nShip = 18;
					(*itor)->nState = NORMAL;
				}
				break;
			case 8:
				if ((*itor)->nShip != 23)
					(*itor)->nShip = 23;
				else
				{
					(*itor)->nShip = 21;
					(*itor)->nState = NORMAL;
				}
				break;
			case 9:
				if ((*itor)->nShip != 26)
					(*itor)->nShip = 26;
				else
				{
					(*itor)->nShip = 24;
					(*itor)->nState = NORMAL;
				}
				break;
			case 10:
				if ((*itor)->nShip != 29)
					(*itor)->nShip = 29;
				else
				{
					(*itor)->nShip = 27;
					(*itor)->nState = NORMAL;
				}
				break;
			case 11:
				if ((*itor)->nShip != 32)
					(*itor)->nShip = 32;
				else
				{
					(*itor)->nShip = 30;
					(*itor)->nState = NORMAL;
				}
				break;
			case 12:
				if ((*itor)->nShip != 35)
					(*itor)->nShip = 35;
				else
				{
					(*itor)->nShip = 33;
					(*itor)->nState = NORMAL;
				}
				break;
			}
			
		}
		else
		{
				switch ((*itor)->nFlag)
				{
				case 1:
					if ((*itor)->nShip == 0)
						(*itor)->nShip = 1;
					else
						(*itor)->nShip = 0;
					break;
				case 2:
					if ((*itor)->nShip == 3)
						(*itor)->nShip = 4;
					else
						(*itor)->nShip = 3;
					break;
				case 3:
					if ((*itor)->nShip == 6)
						(*itor)->nShip = 7;
					else
						(*itor)->nShip = 6;
					break;
				case 4:
					if ((*itor)->nShip == 9)
						(*itor)->nShip = 10;
					else
						(*itor)->nShip = 9;
					break;
				case 5:
					if ((*itor)->nShip == 12)
						(*itor)->nShip = 13;
					else
						(*itor)->nShip = 12;
					break;
				case 6:
					if ((*itor)->nShip == 15)
						(*itor)->nShip = 16;
					else
						(*itor)->nShip = 15;
					break;
				case 7:
					if ((*itor)->nShip == 18)
						(*itor)->nShip = 19;
					else
						(*itor)->nShip = 18;
					break;
				case 8:
					if ((*itor)->nShip == 21)
						(*itor)->nShip = 22;
					else
						(*itor)->nShip = 21;
					break;
				case 9:
					if ((*itor)->nShip == 24)
						(*itor)->nShip = 25;
					else
						(*itor)->nShip = 24;
					break;
				case 10:
					if ((*itor)->nShip == 27)
						(*itor)->nShip = 28;
					else
						(*itor)->nShip = 27;
					break;
				case 11:
					if ((*itor)->nShip == 30)
						(*itor)->nShip = 31;
					else
						(*itor)->nShip = 30;
					break;
				case 12:
					if ((*itor)->nShip == 33)
						(*itor)->nShip = 34;
					else
						(*itor)->nShip = 33;
					break;
				}
		}



		 //  üũ
		if (((*itor)->ptPos.x < -100) || ((*itor)->ptPos.x > 700) ||
			((*itor)->ptPos.y > 700 || ((*itor)->nLife <= 0)))
		{
			//  ȿ ü  
			if ((*itor)->nLife <= 0)
			{
				if ((*itor)->nFlag < 8)
				{
					pBoom->Add(0, (*itor)->ptPos.x, (*itor)->ptPos.y);
				}
				else if ((*itor)->nFlag >= 8 && (*itor)->nFlag <= 11)
				{
					pBoom->Add(1, (*itor)->ptPos.x, (*itor)->ptPos.y);
				}
				else
				{
					pBoom->Add(0, (*itor)->ptPos.x, (*itor)->ptPos.y);
				}
			}

			del[++index] = itor;
		}
	}

	 // 
	for (int i = 0; i <= index; i++)
	{
		delete (*del[i]);
		m_listEnemy.erase(del[i]);
	}
}





//-----------------------------------------------------------------------------
//  Լ 
//------------------------------------------------------------------------------
void CEnemy::Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB, CBoom *pBoom, CBullet *pBullet)
{
	// 
	//UpdateShip(pBoom, pBullet);

	// 
	ENEMY_LIST::iterator itor;
	RECT rtDraw;
	RECT rtSprite;

	for (itor = m_listEnemy.begin(); itor != m_listEnemy.end(); ++itor)
	{
		MakeCenterToRect(&m_osShip.pSpr[(*itor)->nShip].ptSprCenterPos,
						 &m_osShip.pSpr[(*itor)->nShip].rcSprPos,
						 &((*itor)->ptPos),
						 &rtDraw);

		//## ----------------------------------------
		rtSprite.left	= m_osShip.pSpr[(*itor)->nShip].rcSprPos.left;
		rtSprite.top	= m_osShip.pSpr[(*itor)->nShip].rcSprPos.top;
		rtSprite.right	= m_osShip.pSpr[(*itor)->nShip].rcSprPos.right;
		rtSprite.bottom = m_osShip.pSpr[(*itor)->nShip].rcSprPos.bottom;
		
		//  Ų 
		if (rtDraw.left < 0)
		{
			rtSprite.left += (-rtDraw.left);
			rtDraw.left = 0;
		}
		if (rtDraw.right > 600)
		{
			rtSprite.right -= (rtDraw.right - 600);
			rtDraw.right = 600;
		}
		if (rtDraw.top < 0)
		{
			rtSprite.top += (-rtDraw.top);
			rtDraw.top = 0;
		}
		if (rtDraw.bottom > 600)
		{
			rtSprite.bottom -= (rtDraw.bottom - 600);
			rtDraw.bottom = 600;
		}

		//(*m_pddsBB)->Blt(&rtDraw, m_psurShip->GetDDrawSurface(), 
		//				 &rtSprite,
		//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);


		(*m_pddsBB)->BltFast(rtDraw.left, rtDraw.top,
								m_psurShip->GetDDrawSurface(), 
								&rtSprite,
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}

}




//-----------------------------------------------------------------------------
//  ۾
//-----------------------------------------------------------------------------
void CEnemy::Destroy()
{
	
	// 
	ENEMY_LIST::iterator itorShip;
	for (itorShip = m_listEnemy.begin(); itorShip != m_listEnemy.end(); ++itorShip)
	{
		delete (*itorShip);
	}

	m_psurShip->Destroy();
	DestroyLOSD(&m_osShip);

	m_psurShip = NULL;
	
}




//-----------------------------------------------------------------------------
// Ʈ  ε
//-----------------------------------------------------------------------------
BOOL CEnemy::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
		return FALSE;

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
	{
		delete[] os->pSpr;
		os->pSpr = NULL;
		return FALSE;
	}

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  
//-----------------------------------------------------------------------------
void CEnemy::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
		delete[] os->pSpr;
	os->pSpr = NULL;
}



//-----------------------------------------------------------------------------
// ǥ ̿ؼ ȭ ǥ 
//-----------------------------------------------------------------------------
inline void CEnemy::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
							POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);

}

















