//-----------------------------------------------------------------------------
// Note: CEnemy Ŭ 
//  :  Ŭ
// ϸ : CEnemy.h
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------


#ifndef _CENEMY_H_
#define _CENEMY_H_


#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include "CBullet.h"
#include "CBoom.h"
#include <list>
using namespace std;

struct ENEMY
{
	POINT	ptPos;		//  ߽ ǥ
	int		nLife;		//  
	int		nState;		//  
	int		nShip;		// 
	int		nBulMove;	// Ѿ 
	int		nBullet;	// Ѿ 
	int		nMove;		//  
	int		nFlag;		//  
	double	nMoveX;	
	double	nMoveY;		
	double	nAcc;			// ӵ
	DWORD	dwCreateTime;	//  ð
	DWORD	dwDealy;
};

typedef list<ENEMY*>	ENEMY_LIST;

enum SHIPSTATE { NORMAL, WARING };


//Class CEnemy ##
//-----------------------------------------------------------------------------
class CEnemy : public CDisplay
{
	private:

		ENEMY_LIST		m_listEnemy;		// 	Ʈ

		CSurface		*m_psurShip;		// BOOM ǥ		
		ONLY_SPRITE		 m_osShip;		// BOOM 

	public:
		CEnemy();
		virtual ~CEnemy();

		// ʱȭ
		void Create(LPDIRECTDRAW7 *pDD);
		void InitEnemy();

		void LoadEnemy(int nStage);
		void ReleaseEnemy();

		// ߰Լ
		void AddShip(int x, int y, int ship, int move,
			int bul, int bulmove, DWORD dealy);

		// Ʈ Լ
		void UpdateShip(CBoom *pBoom,  CBullet *pBullet);

		// ׸ Լ
		void Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB, CBoom *pBoom,  CBullet *pBullet);

		// 
		void Destroy();

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);

		// ׼ 
		ENEMY_LIST*		GetEnemy() { return &m_listEnemy; }
		ONLY_SPRITE*	GetOnlySprite() { return &m_osShip; }
};

//-----------------------------------------------------------------------------
#endif












