
//-----------------------------------------------------------------------------
// Note : CForces Ŭ 
//  : Ʊ ĳ Ŭ
// ϸ : CForces.cpp
// 2004.8.27 Ora_llundiov
//-----------------------------------------------------------------------------

#include "CForces.h"
#include <stdio.h>

//-----------------------------------------------------------------------------
//  / Ҹ Լ
//-----------------------------------------------------------------------------
CForces::CForces()
{
	m_nCountPlane	= CNT_PLANE;		//  ü
	m_nCountBomb	= CNT_BOMB;			//  Ź
	m_nHP			= 100;				// 
	m_nMP			= 0;				// 
	m_nStateBullet  = 8;				// Ѿ Ŀ  6~~8
	m_nPrevBullet   = 6;
	m_nStateFish	= F_FRONT;
	m_nDrawFish		= 0;
	m_nStateFace	= FACE_NORMAL;
	m_nMoveFrame	= MOVE_TO_FRAME;	// Ӵ ̵Ÿ
	m_ptCenterPos.x = START_POS_X;		// ü ȭ ߽ġ
	m_ptCenterPos.y	= START_POS_Y;
	m_psurFish		= NULL;				// ҵǽ Ʈ ǥ
	m_bMujuc		= FALSE;
	m_bClear		= FALSE;
	m_nKindShip		= 0;				//   (ҵǽ, , Ը)
	m_dwScore		= 0;
	m_bClearMove	= FALSE;

	m_ptFace.x		= 635;
	m_ptFace.y		= 57;

	m_ptClearPos.x = 300;
	m_ptClearPos.y = 200;
	m_bDrawClear   = FALSE;

	m_ptHP.x = 690;
	m_ptHP.y = 167;

	m_ptMP.x = 690;
	m_ptMP.y = 184;

	m_ptBoom.x = 705;
	m_ptBoom.y = 280;

	m_ptPlane.x = 705;
	m_ptPlane.y = 256;

	// ϱ 
	m_ptSayPos.x = 5;
	m_ptSayPos.y = 595;
	m_ptWordPos.x = 20;
	m_ptWordPos.y = 540;
	m_bSay = FALSE;
}


CForces::~CForces()
{

}



//-----------------------------------------------------------------------------
// ʱȭ ۾
//-----------------------------------------------------------------------------
BOOL CForces::Create(LPDIRECTDRAW7 *pDD,CEffect* pEffect, CItem *pItem,
					 CDxMusic *pDMusic, CBoom *pBoom)
{
	m_pDD = *pDD;
	m_pEffect = pEffect;
	m_pItem	= pItem;
	m_pDMusic = pDMusic;
	m_pBoom = pBoom;

	return TRUE;
}




//-----------------------------------------------------------------------------
// HP,MP, ü ʱ  Լ
//-----------------------------------------------------------------------------
void CForces::InItShip()
{
	m_nMP			= 0;				// 
	m_nStateFish	= F_FRONT;
	m_nDrawFish		= 0;				// Ʈ ü ε
	m_ptCenterPos.x = START_POS_X;		// ü ȭ ߽ġ
	m_ptCenterPos.y	= START_POS_Y;
	m_bMujuc		= FALSE;			// 

	m_dwExDealy = timeGetTime();
}





//-----------------------------------------------------------------------------
// HP,MP, ü ʱ  Լ
//-----------------------------------------------------------------------------
void CForces::InitNewShip()
{
	m_nHP			= 100;
	m_nMP			= 0;				// 
	m_nCountPlane	= CNT_PLANE;		//  ü
	m_nCountBomb	= CNT_BOMB;			//  Ź
	m_nStateBullet	= 6;
	m_nStateFish	= F_FRONT;
	m_nDrawFish		= 0;				// Ʈ ü ε
	m_ptCenterPos.x = START_POS_X;		// ü ȭ ߽ġ
	m_ptCenterPos.y	= START_POS_Y;
	m_bMujuc		= FALSE;			// 

	m_dwExDealy = timeGetTime();
}




//-----------------------------------------------------------------------------
// HP,MP, ü ʱ  Լ
//-----------------------------------------------------------------------------
void CForces::LoadForces(int nCha)
{
	//  ۾
	ReleaseForces();

	switch (nCha)
	{
	case 0:
		// 
		CreateSurfaceFromBitmap(&m_psurFish, "image\\play_fish.ora", NULL, NULL);
		LoadOnlySprData("spr\\play_fish.spr", (ONLY_SPRITE*)&m_osFish);
		m_psurFish->SetColorKey(RGB(0, 255, 0));

		// ƽ
		CreateSurfaceFromBitmap(&m_psurSp, "image\\play_fish_sp.ora", NULL, NULL);
		LoadOnlySprData("spr\\play_fish_sp.spr", (ONLY_SPRITE*)&m_osSp);
		m_psurSp->SetColorKey(RGB(0, 0, 0));

		// 
		CreateSurfaceFromBitmap(&m_psurFace, "image\\face_sp.ora", NULL, NULL);
		LoadOnlySprData("spr\\face_sp.spr", (ONLY_SPRITE*)&m_osFace);
		m_psurFace->SetColorKey(RGB(0, 255, 0));

		// ϱ
		CreateSurfaceFromBitmap(&m_psurSay, "image\\say_sp.ora", NULL, NULL);
		LoadOnlySprData("spr\\say_sp.spr", (ONLY_SPRITE*)&m_osSay);
		m_psurSay->SetColorKey(RGB(0, 255, 0));
		break;

	case 1:
		// 
		CreateSurfaceFromBitmap(&m_psurFish, "image\\play_tail.ora", NULL, NULL);
		LoadOnlySprData("spr\\play_tail.spr", (ONLY_SPRITE*)&m_osFish);
		m_psurFish->SetColorKey(RGB(0, 255, 0));

		// ƽ
		CreateSurfaceFromBitmap(&m_psurSp, "image\\play_tail_sp.ora", NULL, NULL);
		LoadOnlySprData("spr\\play_tail_sp.spr", (ONLY_SPRITE*)&m_osSp);
		m_psurSp->SetColorKey(RGB(0, 0, 0));

		// 
		CreateSurfaceFromBitmap(&m_psurFace, "image\\face_pai.ora", NULL, NULL);
		LoadOnlySprData("spr\\face_sp.spr", (ONLY_SPRITE*)&m_osFace);
		m_psurFace->SetColorKey(RGB(0, 255, 0));

		// ϱ
		CreateSurfaceFromBitmap(&m_psurSay, "image\\say_pai.ora", NULL, NULL);
		LoadOnlySprData("spr\\say_pai.spr", (ONLY_SPRITE*)&m_osSay);
		m_psurSay->SetColorKey(RGB(0, 255, 0));
		break;

	case 2:
		// 
		CreateSurfaceFromBitmap(&m_psurFish, "image\\play_head.ora", NULL, NULL);
		LoadOnlySprData("spr\\play_head.spr", (ONLY_SPRITE*)&m_osFish);
		m_psurFish->SetColorKey(RGB(0, 255, 0));

		// ƽ
		CreateSurfaceFromBitmap(&m_psurSp, "image\\play_zt_sp.ora", NULL, NULL);
		LoadOnlySprData("spr\\play_zt_sp.spr", (ONLY_SPRITE*)&m_osSp);
		m_psurSp->SetColorKey(RGB(0, 0, 0));

		// 
		CreateSurfaceFromBitmap(&m_psurFace, "image\\face_zt.ora", NULL, NULL);
		LoadOnlySprData("spr\\face_sp.spr", (ONLY_SPRITE*)&m_osFace);
		m_psurFace->SetColorKey(RGB(0, 255, 0));

		// ϱ
		CreateSurfaceFromBitmap(&m_psurSay, "image\\say_zt.ora", NULL, NULL);
		LoadOnlySprData("spr\\say_zt.spr", (ONLY_SPRITE*)&m_osSay);
		m_psurSay->SetColorKey(RGB(0, 255, 0));
		break;
	}


	// 
	LoadOnlySprData("spr\\play_info_item.spr", (ONLY_SPRITE*)&m_osInfo);
	CreateSurfaceFromBitmap(&m_psurInfo, "image\\play_info_item.ora", NULL, NULL);
	m_psurInfo->SetColorKey(RGB(0, 255, 0));


	// Ŭ
	CreateSurfaceFromBitmap(&m_psurClear, "image\\stageclear.ora", NULL, NULL);
	m_psurClear->SetColorKey(RGB(0, 255, 0));
	LoadOnlySprData("spr\\stageclear.spr", (ONLY_SPRITE*)&m_osClear);
}




//-----------------------------------------------------------------------------
// HP,MP, ü ʱ  Լ
//-----------------------------------------------------------------------------
void CForces::ReleaseForces()
{
	DestroyLOSD((ONLY_SPRITE*)&m_osFish);
	DestroyLOSD((ONLY_SPRITE*)&m_osSp);
	DestroyLOSD((ONLY_SPRITE*)&m_osFace);
	DestroyLOSD((ONLY_SPRITE*)&m_osClear);
	DestroyLOSD((ONLY_SPRITE*)&m_osInfo);
	DestroyLOSD((ONLY_SPRITE*)&m_osSay);

	if (m_psurFish)	m_psurFish->Destroy();
	if (m_psurSp)	m_psurSp->Destroy();
	if (m_psurFace)	m_psurFace->Destroy();
	if (m_psurClear)m_psurClear->Destroy();
	if (m_psurInfo)	m_psurInfo->Destroy();
	if (m_psurSay)	m_psurSay->Destroy();

	m_psurFish	= NULL;
	m_psurSp	= NULL;
	m_psurFace	= NULL;
	m_psurClear = NULL;
	m_psurInfo	= NULL;
	m_psurSay	= NULL;
}



//-----------------------------------------------------------------------------
// ü  Ʈ ## ߿  ˰ мٶ 2004.7.16
//-----------------------------------------------------------------------------
BOOL CForces::Update()
{
	static int nMove = 0;

	// ϶
	if (m_bMujuc == TRUE)
	{

		//  ¦
		if (m_nDrawFish != 3)
			m_nDrawFish = 3;
		else
			m_nDrawFish = 0;

		if ((timeGetTime() - m_dwStartM) >= 5000)
		{
			m_bMujuc = FALSE;
			m_nStateFish = F_FRONT;
			m_nStateBullet = m_nPrevBullet;
		}
	}
	else if(m_bMujuc == FALSE)
	{
		//ĳ  Ʈ
		switch (m_nStateFish)
		{
		case F_FRONT:
		case F_BACK:
			m_nDrawFish  = !m_nDrawFish;
			break;

		case F_LEFT:
			m_nDrawFish  = 5;
			break;

		case F_RIGHT:
			m_nDrawFish  = 4;
			break;

		case F_WARING: // 浿 
			m_nDrawFish  = 2;
			m_nStateFish = F_FRONT;
			break;

		case F_CREATE:
			if (m_nDrawFish != 3)
				m_nDrawFish = 3;
			else
				m_nDrawFish = 0;

			if ((m_ptCenterPos.y -= 3) <= 550)
			{
				SetStateFish(F_MUJUC);
				m_bMujuc = TRUE;
				m_dwStartM = timeGetTime();
				m_nPrevBullet = 6;
				m_nStateBullet = 9;
			}
			break;

		case F_CLEAR:
			m_nDrawFish  = !m_nDrawFish;
			SetSay(4);

			if ((timeGetTime() - m_dwClearDealy) > 5000)
			{
				m_bClearMove = TRUE;
				if (m_nStateBullet == 9)
					m_nStateBullet = m_nPrevBullet;
			}

			// ̱ 
			if (m_bClearMove == TRUE)
			{
				if ((m_ptCenterPos.y -= (++nMove)) <= 0)
				{
					m_bClear = TRUE;
					m_bClearMove = FALSE;
					m_bDrawClear = FALSE;
					nMove = 0;
				}
			}
			break;
		}
	}

	// Ѿ Ʈ
	BT_Update();

	//  Ʈ
	if (m_nHP <= 0)
	{
		//  ߰
		m_pItem->Add(2,	m_ptCenterPos.x, m_ptCenterPos.y);
		m_pItem->Add(0,	m_ptCenterPos.x + 100, m_ptCenterPos.y + 100);
		m_pEffect->Add(3, m_ptCenterPos .x, m_ptCenterPos.y);
		m_pDMusic->PlaySound(6, FALSE);
		// ϱ
		SetSay(2);

		if (--m_nCountPlane >= 0)
		{
			SetHP();				 // HP ʱȭ
			SetMP();				 // MP ʱȭ
			SetBoom();				 // ź ʱȭ
			m_nStateFish = F_CREATE; // ¸ 
			m_nStateBullet = 6;
			m_ptCenterPos.x = 300;
			m_ptCenterPos.y = 650;
		}

	}




	return TRUE;
}




//-----------------------------------------------------------------------------
// ü ǥ鿡 ׸
//-----------------------------------------------------------------------------
void CForces::Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	// ǥ 
	//Update();

	RECT rtSprite;

	// ĳ ǥ  index 0  ҵǽ ü
	MakeCenterToRect(&(m_osFish.pSpr[m_nDrawFish].ptSprCenterPos),
					 &(m_osFish.pSpr[m_nDrawFish].rcSprPos),
					 &m_ptCenterPos, &m_rtPos);

	//## ----------------------------------------
	rtSprite.left	= m_osFish.pSpr[m_nDrawFish].rcSprPos.left;
	rtSprite.top	= m_osFish.pSpr[m_nDrawFish].rcSprPos.top;
	rtSprite.right	= m_osFish.pSpr[m_nDrawFish].rcSprPos.right;
	rtSprite.bottom = m_osFish.pSpr[m_nDrawFish].rcSprPos.bottom;


		
	//  Ų 
	if (m_rtPos.left < 0)
	{
		rtSprite.left += (-m_rtPos.left);
		m_rtPos.left = 0;
	}
	if (m_rtPos.right > 600)
	{
		rtSprite.right -= (m_rtPos.right - 600);
		m_rtPos.right = 600;
	}
	if (m_rtPos.top < 0)
	{
		rtSprite.top += (-m_rtPos.top);
		m_rtPos.top = 0;

	}
	if (m_rtPos.bottom > 600)
	{
		rtSprite.bottom -= (m_rtPos.bottom - 600);
		m_rtPos.bottom = 600;
	}
	


	//(*m_pddsBB)->Blt(&m_rtPos, m_psurFish->GetDDrawSurface(),
	//				  &rtSprite,
	//				  DDBLT_WAIT | DDBLT_KEYSRC, NULL);


	// Ѿ ׸
	BT_Draw(m_pddsBB);

	// ĳ͸ ׸
	(*m_pddsBB)->BltFast(m_rtPos.left, m_rtPos.top,
						 m_psurFish->GetDDrawSurface(),
						 &rtSprite,
						 DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );



}




//-----------------------------------------------------------------------------
//  Ŭ
//-----------------------------------------------------------------------------
void CForces::DrawClear(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	RECT rtClear;

	if (m_bDrawClear == TRUE)
	{
		MakeCenterToRect(&(m_osClear.pSpr[0].ptSprCenterPos),
						 &(m_osClear.pSpr[0].rcSprPos),
						 &m_ptClearPos, &rtClear);


		//  Ŭ
		//((*m_pddsBB)->Blt(&rtClear, m_psurClear->GetDDrawSurface(),
		//				  &(m_osClear.pSpr[0].rcSprPos),
		//				  DDBLT_WAIT | DDBLT_KEYSRC, NULL));


		(*m_pddsBB)->BltFast(rtClear.left, rtClear.top,
								m_psurClear->GetDDrawSurface(),
								&(m_osClear.pSpr[0].rcSprPos),
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}
}


//-----------------------------------------------------------------------------
// ĳ ϱ
//-----------------------------------------------------------------------------
void CForces::DrawSay(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	RECT rtSay, rtWord;

	if (m_bSay == TRUE)
	{
		MakeCenterToRect(&(m_osSay.pSpr[0].ptSprCenterPos),
						 &(m_osSay.pSpr[0].rcSprPos),
						 &m_ptSayPos, &rtSay);

		MakeCenterToRect(&(m_osSay.pSpr[m_nFlagSay].ptSprCenterPos),
						 &(m_osSay.pSpr[m_nFlagSay].rcSprPos),
						 &m_ptWordPos, &rtWord);

		// ĳ
		((*m_pddsBB)->Blt(&rtSay, m_psurSay->GetDDrawSurface(),
						  &(m_osSay.pSpr[0].rcSprPos),
						  DDBLT_WAIT | DDBLT_KEYSRC, NULL));

		// 
		((*m_pddsBB)->Blt(&rtWord, m_psurSay->GetDDrawSurface(),
						  &(m_osSay.pSpr[m_nFlagSay].rcSprPos),
						  DDBLT_WAIT | DDBLT_KEYSRC, NULL));

		if (timeGetTime() - m_dwSayDealy > 4000)
			m_bSay = FALSE;
	}
}


//-----------------------------------------------------------------------------
//  ۾
//-----------------------------------------------------------------------------
void CForces::Destroy()
{
	BULLET::iterator itor;

	for (itor = m_listBullet.begin(); itor != m_listBullet.end(); ++itor)
	{
		delete (*itor);
	}

	DestroyLOSD((ONLY_SPRITE*)&m_osFish);
	DestroyLOSD((ONLY_SPRITE*)&m_osSp);
	DestroyLOSD((ONLY_SPRITE*)&m_osFace);
	DestroyLOSD((ONLY_SPRITE*)&m_osClear);
	DestroyLOSD((ONLY_SPRITE*)&m_osInfo);
	DestroyLOSD((ONLY_SPRITE*)&m_osSay);

	if (m_psurFish)	m_psurFish->Destroy();
	if (m_psurSp) m_psurSp->Destroy();
	if (m_psurFace)	m_psurFace->Destroy();
	if (m_psurClear) m_psurClear->Destroy();
	if (m_psurInfo)	m_psurInfo->Destroy();
	if (m_psurSay)	m_psurSay->Destroy();
}





//-----------------------------------------------------------------------------
//  ̵
//-----------------------------------------------------------------------------
void CForces::MoveRight()
{

	m_ptCenterPos.x += MOVE_TO_FRAME;

	// ó
	if (m_ptCenterPos.x > 590)
		m_ptCenterPos.x -= MOVE_TO_FRAME;
}



//-----------------------------------------------------------------------------
//  ̵
//-----------------------------------------------------------------------------
void CForces::MoveLeft()
{

	m_ptCenterPos.x -= MOVE_TO_FRAME;

	// ó
	if (m_ptCenterPos.x < 10)
		m_ptCenterPos.x += MOVE_TO_FRAME;
}



//-----------------------------------------------------------------------------
//  ̵
//-----------------------------------------------------------------------------
void CForces::MoveUp()
{

	m_ptCenterPos.y -= MOVE_TO_FRAME;

		// ó
	if (m_ptCenterPos.y < 52)
		m_ptCenterPos.y += MOVE_TO_FRAME;

}



//-----------------------------------------------------------------------------
// Ʒ ̵
//-----------------------------------------------------------------------------
void CForces::MoveDown()
{

	m_ptCenterPos.y += MOVE_TO_FRAME;

	if (m_ptCenterPos.y > 550)
		m_ptCenterPos.y -= MOVE_TO_FRAME;
}




//-----------------------------------------------------------------------------
// Ѿ ߰
//-----------------------------------------------------------------------------
void CForces::BT_Add(int x, int y, BOOL sp, int flag)
{
	BUL *pAdd = new BUL;
	if (pAdd == NULL)
		return;

	pAdd->ptPos.x = m_ptCenterPos.x + x;
	
	pAdd->bLife	= TRUE;
	if ((pAdd->bSp = sp) == FALSE)
	{
		pAdd->ptPos.y = m_ptCenterPos.y - 40 + y;
	}
	else
	{
		pAdd->ptPos.y = m_ptCenterPos.y - 100;
	}
	pAdd->nSpIndex  = 0;
	pAdd->dblFlag	= flag;
	pAdd->dMoveX = 0;
	pAdd->dMoveY = 0;
	pAdd->dAcc = 0;
	pAdd->bEx = FALSE;
	pAdd->nExFlag = 0;

	m_listBullet.push_back(pAdd);

	if (timeGetTime() - m_dwExDealy > 1500)
	{
		if (m_nStateBullet == 6)
		{
			BT_Add(0, +10, 0, -2.0, 1.0, 0.4);
			BT_Add(0, +10, 0, 2.0, 1.0, 0.4);
		}
		else if (m_nStateBullet == 7)
		{
			BT_Add(0, +15, 0, -2.0, 1.0, 0.4);
			BT_Add(0, +10, 0, 0.0, 1.0, 0.4);
			BT_Add(0, +15, 0, 2.0, 1.0, 0.4);
		}
		else if (m_nStateBullet == 8)
		{
			BT_Add(0, +20, 0, -4.0, 1.0, 0.4);
			BT_Add(0, +15, 0, -2.0, 1.0, 0.4);
			BT_Add(0, +10, 0, 0.0, 1.0, 0.4);
			BT_Add(0, +15, 0, 2.0, 1.0, 0.4);
			BT_Add(0, +20, 0, 4.0, 1.0, 0.4);
		}
		m_dwExDealy = timeGetTime();
	}
}



//-----------------------------------------------------------------------------
// Ѿ ߰ - EX Ѿ
// flag  : 1 0 2
// movex : x  
// movey : y 
// acc   : ӵ
//-----------------------------------------------------------------------------
void CForces::BT_Add(int x, int y, int flag, double movex, double movey, double acc)
{
	BUL *pAdd = new BUL;
	if (pAdd == NULL)
		return;

	pAdd->ptPos.x = m_ptCenterPos.x + x;
	pAdd->ptPos.y = m_ptCenterPos.y + y;
	pAdd->bSp = FALSE;
	pAdd->bLife	= TRUE;
	pAdd->nSpIndex  = 10;
	pAdd->dblFlag	= -1;
	pAdd->dMoveX = movex;
	pAdd->dMoveY = movey;
	pAdd->dAcc = acc;
	pAdd->bEx = TRUE;
	pAdd->nExFlag = flag;

	m_listBullet.push_back(pAdd);
}




//-----------------------------------------------------------------------------
//   ߰Լ
//-----------------------------------------------------------------------------
void CForces::BT_Add(int x, int y)
{

	BUL *pAdd = new BUL;
	if (pAdd == NULL)
		return;

	pAdd->ptPos.x = x;
	pAdd->ptPos.y = y;
	pAdd->bLife	  = TRUE;
	pAdd->bSp     = TRUE;
	pAdd->nSpIndex= 0;
	pAdd->dMoveX = 0;
	pAdd->dMoveY = 0;
	pAdd->dAcc = 0;
	pAdd->bEx = FALSE;
	pAdd->nExFlag = 0;

	m_listBullet.push_back(pAdd);

}



//-----------------------------------------------------------------------------
// Ѿ Ʈ , ˻)
//-----------------------------------------------------------------------------
void CForces::BT_Update()
{

	BULLET::iterator itor;
	BULLET::iterator del[30];
	int cnt = -1;

	// ŵ Ѿ ã´
	for (itor = m_listBullet.begin(); itor != m_listBullet.end(); ++itor)
	{
		if ((*itor)->bSp == TRUE) // ƽ Ѿ
		{
			switch (m_nKindShip)
			{
			case 0: // ũ
				(*itor)->nSpIndex = !(*itor)->nSpIndex;
				break;

			case 1: // 
				if (++(*itor)->nSpIndex == 11)
				{
					(*itor)->nSpIndex = 5;
				}
				break;

			case 2: // Ʈ
				if (++(*itor)->nSpIndex == 6)
				{
					(*itor)->nSpIndex = 3;
				}
				break;
			}

			if (((*itor)->ptPos.y -= 20) <= -10)// || (*itor)->bLife == FALSE )
			{
				del[++cnt] = itor;
			}

		}
		else if ((*itor)->bSp == FALSE) 
		{
			if ((*itor)->bEx == FALSE) // ϹѾ
			{
				if ((*itor)->dblFlag == 0)
				{
					(*itor)->ptPos.x -= 5;
				}
				else if((*itor)->dblFlag == 1)
				{
					(*itor)->ptPos.x += 5;
				}
				
				//  ˻
				if ((((*itor)->ptPos.y -= 30) <= -10) || ((*itor)->bLife == FALSE))
				{
					del[++cnt] = itor;
				}
			}
			else if ((*itor)->bEx == TRUE) // Ex Ѿ
			{
				//(*itor)->dMoveX += (*itor)->dAcc;
				if (++(*itor)->nExFlag > 10)
				{
					(*itor)->dAcc = 2.0;
					(*itor)->dAcc *= -(1.0);
					(*itor)->nExFlag = -10000;
				}

				(*itor)->dMoveY += (*itor)->dAcc;

				(*itor)->ptPos.x += (*itor)->dMoveX;
				(*itor)->ptPos.y += (*itor)->dMoveY;

				if ((*itor)->nSpIndex == 10)
				{
					(*itor)->nSpIndex = 11;
				}
				else if ((*itor)->nSpIndex == 11)
				{
					(*itor)->nSpIndex = 10;
				}
				
				//  ˻
				if (((*itor)->ptPos.y <= -10) || ((*itor)->bLife == FALSE))
				{
					if ((*itor)->bLife == FALSE)
						m_pEffect->Add(2, (*itor)->ptPos.x, (*itor)->ptPos.y);
					del[++cnt] = itor;
				}

				
			}
		}
	}

	// Ѿ 
	for (int i = 0; i <= cnt; i++)
	{
		delete (*del[i]);
		m_listBullet.erase(del[i]);
	}
	
}





//-----------------------------------------------------------------------------
// Ѿ ׸
//-----------------------------------------------------------------------------
void CForces::BT_Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	RECT rtDraw, rtSprite;
	BULLET::iterator itor;

	for (itor = m_listBullet.begin(); itor != m_listBullet.end(); ++itor)
	{
		if ((*itor)->bSp == TRUE)
		{
			MakeCenterToRect(&m_osSp.pSpr[(*itor)->nSpIndex].ptSprCenterPos,
							 &m_osSp.pSpr[(*itor)->nSpIndex].rcSprPos,
							 &(*itor)->ptPos,
							 &rtDraw);

			//## ----------------------------------------
			rtSprite.left	= m_osSp.pSpr[(*itor)->nSpIndex].rcSprPos.left;
			rtSprite.top	= m_osSp.pSpr[(*itor)->nSpIndex].rcSprPos.top;
			rtSprite.right	= m_osSp.pSpr[(*itor)->nSpIndex].rcSprPos.right;
			rtSprite.bottom = m_osSp.pSpr[(*itor)->nSpIndex].rcSprPos.bottom;
		}
		else
		{
			if ((*itor)->bEx == FALSE)
			{
				MakeCenterToRect(&m_osFish.pSpr[m_nStateBullet].ptSprCenterPos,
								&m_osFish.pSpr[m_nStateBullet].rcSprPos,
								&(*itor)->ptPos, &rtDraw);

				//## ----------------------------------------
				rtSprite.left	= m_osFish.pSpr[m_nStateBullet].rcSprPos.left;
				rtSprite.top	= m_osFish.pSpr[m_nStateBullet].rcSprPos.top;
				rtSprite.right	= m_osFish.pSpr[m_nStateBullet].rcSprPos.right;
				rtSprite.bottom = m_osFish.pSpr[m_nStateBullet].rcSprPos.bottom;
			}
			else if ((*itor)->bEx == TRUE)
			{
				MakeCenterToRect(&m_osFish.pSpr[(*itor)->nSpIndex].ptSprCenterPos,
								&m_osFish.pSpr[(*itor)->nSpIndex].rcSprPos,
								&(*itor)->ptPos, &rtDraw);

				//## ----------------------------------------
				rtSprite.left	= m_osFish.pSpr[(*itor)->nSpIndex].rcSprPos.left;
				rtSprite.top	= m_osFish.pSpr[(*itor)->nSpIndex].rcSprPos.top;
				rtSprite.right	= m_osFish.pSpr[(*itor)->nSpIndex].rcSprPos.right;
				rtSprite.bottom = m_osFish.pSpr[(*itor)->nSpIndex].rcSprPos.bottom;
			}
		}
		
		//  Ų 
		if (rtDraw.left < 0)
		{
			rtSprite.left += (-rtDraw.left);
			rtDraw.left = 0;
		}
		if (rtDraw.right > 600)
		{
			rtSprite.right -= (rtDraw.right - 600);
			rtDraw.right = 600;
		}
		if (rtDraw.top < 0)
		{
			rtSprite.top += (-rtDraw.top);
			rtDraw.top = 0;

		}
		if (rtDraw.bottom > 600)
		{
			rtSprite.bottom -= (rtDraw.bottom - 600);
			rtDraw.bottom = 600;
		}

		if ((*itor)->bSp == TRUE)	// ƽ
		{
			(*m_pddsBB)->Blt(&rtDraw, m_psurSp->GetDDrawSurface(),
							 &rtSprite,
							 DDBLT_WAIT | DDBLT_KEYSRC, NULL);
		}
		else if ((*itor)->bSp == FALSE) // ϹѾ
		{
			//(*m_pddsBB)->Blt(&rtDraw, m_psurFish->GetDDrawSurface(),
			//				 &rtSprite,
			//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);


			(*m_pddsBB)->BltFast(rtDraw.left, rtDraw.top,
									m_psurFish->GetDDrawSurface(), 
									&rtSprite,
									DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
		}
	}

}





//-----------------------------------------------------------------------------
// ÷  ׸
//-----------------------------------------------------------------------------
void CForces::DrawInfo(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	BOOL bMax = FALSE;
	static BOOL bFlag = FALSE;

	RECT rtHPScreen, rtHPSprite;
	RECT rtMPScreen, rtMPSprite;

	static int nHPIndex = 1;
	static int nMPIndex = 2;

	// ¦ ¦ Ʈ
	if (m_nHP <= 30)
	{
		nHPIndex = !nHPIndex;
	}
	else
	{
		nHPIndex = 1;
	}

	if (m_nMP >= 100)
	{
		if (nMPIndex == 3)
			nMPIndex = 2;
		else
			nMPIndex = 3;
	}
	else
	{
		nMPIndex = 2;
	}

	//  ¾Ʈ
	switch (m_nStateFace)
	{
	case FACE_NORMAL:
		break;
	case FACE_SPSHOT:
	case FACE_WARNING:
		if ((timeGetTime() - m_dwChangeTime) > 500)
			m_nStateFace = FACE_NORMAL;
		break;
	}


	// ɸ  ׸
	RECT rtFace;
	MakeCenterToRect(&m_osFace.pSpr[m_nStateFace].ptSprCenterPos,
					 &m_osFace.pSpr[m_nStateFace].rcSprPos,
					 &m_ptFace,
				     &rtFace);

	//(*m_pddsBB)->Blt(&rtFace, m_psurFace->GetDDrawSurface(),
	//				&m_osFace.pSpr[m_nStateFace].rcSprPos,
	//				DDBLT_WAIT | DDBLT_KEYSRC, NULL);


	(*m_pddsBB)->BltFast(rtFace.left, rtFace.top,
						 m_psurFace->GetDDrawSurface(), 
						 &m_osFace.pSpr[m_nStateFace].rcSprPos,
						 DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );


	// HP
	MakeCenterToRect(&m_osInfo.pSpr[nHPIndex].ptSprCenterPos,
					 &m_osInfo.pSpr[nHPIndex].rcSprPos,
					 &m_ptHP,
				     &rtHPScreen);

	rtHPSprite.left		= m_osInfo.pSpr[nHPIndex].rcSprPos.left + 1;
	rtHPSprite.top		= m_osInfo.pSpr[nHPIndex].rcSprPos.top + 1;
	rtHPSprite.right	= m_osInfo.pSpr[nHPIndex].rcSprPos.right - (100 - m_nHP);
	rtHPSprite.bottom	= m_osInfo.pSpr[nHPIndex].rcSprPos.bottom;

	rtHPScreen.right -= (100 - m_nHP);

	//(*m_pddsBB)->Blt(&rtHPScreen, m_psurInfo->GetDDrawSurface(),
	//				&rtHPSprite,
	//				DDBLT_WAIT | DDBLT_KEYSRC, NULL);


	(*m_pddsBB)->BltFast(rtHPScreen.left, rtHPScreen.top,
						 m_psurInfo->GetDDrawSurface(),
						 &rtHPSprite,
						 DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );

	// MP
	MakeCenterToRect(&m_osInfo.pSpr[nMPIndex].ptSprCenterPos,
					 &m_osInfo.pSpr[nMPIndex].rcSprPos,
					 &m_ptMP,
				     &rtMPScreen);

	rtMPSprite.left		= m_osInfo.pSpr[nMPIndex].rcSprPos.left + 1;
	rtMPSprite.top		= m_osInfo.pSpr[nMPIndex].rcSprPos.top + 1;
	rtMPSprite.right	= m_osInfo.pSpr[nMPIndex].rcSprPos.right - (100 - m_nMP);
	rtMPSprite.bottom	= m_osInfo.pSpr[nMPIndex].rcSprPos.bottom;

	rtMPScreen.right -= (100 - m_nMP);

	//(*m_pddsBB)->Blt(&rtMPScreen, m_psurInfo->GetDDrawSurface(),
	//				&rtMPSprite,
	//				DDBLT_WAIT | DDBLT_KEYSRC, NULL);

	
	(*m_pddsBB)->BltFast(rtMPScreen.left, rtMPScreen.top,
						 m_psurInfo->GetDDrawSurface(),
						 &rtMPSprite,
						 DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );


	RECT rtBoom;
	RECT rtPlane;


	// 
	MakeCenterToRect(&m_osInfo.pSpr[4].ptSprCenterPos,
					 &m_osInfo.pSpr[4].rcSprPos,
					 &m_ptPlane,
				     &rtPlane);

	for (int i = 0; i < m_nCountPlane; i++)
	{
		rtPlane.left  += (11);
		rtPlane.right += (11);

		//(*m_pddsBB)->Blt(&rtPlane, m_psurInfo->GetDDrawSurface(),
		//				 &m_osInfo.pSpr[4].rcSprPos,
		//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);

		(*m_pddsBB)->BltFast(rtPlane.left, rtPlane.top,
								m_psurInfo->GetDDrawSurface(),
								&m_osInfo.pSpr[4].rcSprPos,
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}

	// ź
	MakeCenterToRect(&m_osInfo.pSpr[5].ptSprCenterPos,
					 &m_osInfo.pSpr[5].rcSprPos,
					 &m_ptBoom,
				     &rtBoom);

	for (int i = 0; i < m_nCountBomb; i++)
	{
		rtBoom.left  += (11);
		rtBoom.right += (11);

		//(*m_pddsBB)->Blt(&rtBoom, m_psurInfo->GetDDrawSurface(),
		//				 &m_osInfo.pSpr[5].rcSprPos,
		//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);


		(*m_pddsBB)->BltFast(rtBoom.left, rtBoom.top,
								m_psurInfo->GetDDrawSurface(),
								&m_osInfo.pSpr[5].rcSprPos,
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}

	//  
	HDC hDC;
	(*m_pddsBB)->GetDC(&hDC);
	char strScore[MAX_PATH];

	HFONT hNewFont, hDefFont;
	hNewFont = CreateFont(12, 0, 0, 0, FW_ULTRABOLD, 0, 0, 0,
		HANGEUL_CHARSET, 0, 0, ANTIALIASED_QUALITY, 0, "ü");

	hDefFont = (HFONT)SelectObject(hDC, hNewFont);

	//   
	SetBkMode(hDC, TRANSPARENT);
	SetTextColor(hDC, RGB(255, 0, 0));

	//  
	wsprintf(strScore, "%ld", m_dwScore); 
	TextOut(hDC, 716, 230, strScore, (int)strlen(strScore));

	// ҽ 
	SelectObject(hDC, hDefFont);
	DeleteObject(hNewFont);

	(*m_pddsBB)->ReleaseDC(hDC);

}




//-----------------------------------------------------------------------------
// Ѿ (Ŀ) 
//-----------------------------------------------------------------------------
void CForces::BT_SetPower(int nPower)
{

	if (!nPower)
	{
		if (++m_nStateBullet > 9)
			m_nStateBullet = 9;
	}
	else
	{
		m_nStateBullet = 1;
	}

}



//-----------------------------------------------------------------------------
// ü HP  Լ
//-----------------------------------------------------------------------------
void CForces::SetHP(int power)
{
	if (power == 0)
	{
		m_nHP = 100;
	}
	else if (power > 0)
	{
		if ((m_nHP -= power) < 0)
			m_nHP = 0;
	}
	else
	{
		if ((m_nHP -= power) > 100)
			m_nHP = 100;
	}

}



//-----------------------------------------------------------------------------
// ü MP  Լ
//-----------------------------------------------------------------------------
void CForces::SetMP(int power)
{
	if (power == 0)
	{
		m_nMP = 0;
	}
	else
	{
		if ((m_nMP += power) > 100)
			m_nMP = 100;
	}
}




//-----------------------------------------------------------------------------
// ź  Լ
//-----------------------------------------------------------------------------
void CForces::SetBoom(int inc)
{
	if (inc == 0)
	{
		m_nCountBomb = 2;
	}
	else
	{
		m_nCountBomb += inc;
	}
}



//-----------------------------------------------------------------------------
//   Լ
//-----------------------------------------------------------------------------
void CForces::SetPlane(int inc)
{
	if (inc == 0)
	{
		m_nCountPlane = 2;
	}
	else
	{
		m_nCountPlane += inc;
	}
}




//-----------------------------------------------------------------------------
//  Ѿ Ŀ
//-----------------------------------------------------------------------------
void CForces::SetBullet(int inc)
{
	if (inc == 0)
	{
		m_nStateBullet = 6;
	}
	else if (inc == 9)
	{
		m_nStateBullet = 9;
	}
	else
	{
		if ((m_nStateBullet += inc) > 8)
			m_nStateBullet = 8;
	}

}





//-----------------------------------------------------------------------------
//  Ѿ   ϶  
//-----------------------------------------------------------------------------
void CForces::SetPrevBullet()
{
	if ((++m_nPrevBullet) > 8)
		m_nPrevBullet = 8;
}





//-----------------------------------------------------------------------------
//   Լ
//-----------------------------------------------------------------------------
void CForces::SetScore(DWORD inc)
{
	if (inc != 0)
		m_dwScore += inc;
	else
		m_dwScore = 0;
}



//-----------------------------------------------------------------------------
// Ʈ  ε
//-----------------------------------------------------------------------------
BOOL CForces::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
		return FALSE;

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
	{
		delete[] os->pSpr;
		os->pSpr = NULL;
		return FALSE;
	}

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  
//-----------------------------------------------------------------------------
void CForces::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
		delete[] os->pSpr;
	os->pSpr = NULL;
}



//-----------------------------------------------------------------------------
// ǥ ̿ؼ ȭ ǥ 
//-----------------------------------------------------------------------------
inline void CForces::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
							POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);

}










