//-----------------------------------------------------------------------------
// NOTE : CItem Ŭ 
//  :  Ŭ
// ϸ : CItem.h
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------

#ifndef _CITEM_H_
#define _CITEM_H_

#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include <list>
using namespace std;

class CItem;

struct ITEM
{
	POINT	ptPos;		//  ǥ
	int		nIndex;		//  ε
	BOOL	bLife;		// ı
	int		nFlag;		//  
	DWORD	dwDealy;	// Ʈ 

	int		nMove;		// ̴  (0 ~ 7) ð
	int		nMoveX;		// X 
	int		nMoveY;		// Y 
};

typedef list<ITEM*>	ITEM_LIST;


//-----------------------------------------------------------------------------
class CItem : public CDisplay
{
	private:
		ITEM_LIST m_listItem;

		CSurface		*m_psurItem;	// ITEM ǥ		
		ONLY_SPRITE		 m_osItem;		// ITEM 

	public:
		CItem();
		virtual ~CItem();

		void	Create(LPDIRECTDRAW7 *pDD);
		void	InitItem();

		void	LoadItem();
		void	ReleaseItem();

		void	Update();
		void	Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB);
		void	Destroy();
		void	Add(int flag, int x, int y);

		// о Լ
		ITEM_LIST*	 GetItemList() { return &m_listItem; };
		ONLY_SPRITE* GetOnlySprite() { return &m_osItem; };

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);
};

//-----------------------------------------------------------------------------

#endif