
//-----------------------------------------------------------------------------
// NOTE : CMap Ŭ 
//  :    Ŭ
// ϸ : CMap.cpp
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------

#include "CMap.h"
#include <stdio.h>


int stage[3][20][3] = {
   {{0, 7, 8},
	{0, 10, 11}, 
	{9, 0, 0}, 
	{0, 6, 0},
	{0, 0, 0},
	{0, 3, 0}, 
	{0, 0, 0}, 
	{0, 0, 5},
	{2, 0, 0},
	{0, 9, 0},
	{0, 0, 0},
	{0, 4, 0}, 
	{0, 0, 0}, 
	{0, 0, 6},
	{0, 0, 0},
	{0, 1, 0}, 
	{6, 0, 0}, 
	{0, 0, 0},
	{0, 0, 1},
    {0, 0, 0}},

   {{7, 21, 22},
	{10, 23, 24}, 
	{14, 15, 16}, 
	{6, 7, 8},
	{3, 4, 5},
	{0, 1, 2}, 
	{18, 19, 16}, 
	{15, 16, 17},
	{12, 13, 14},
	{9, 25, 11},
	{6, 7, 8},
	{3, 4, 5}, 
	{0, 1, 2}, 
	{18, 19, 20},
	{15, 16, 17},
	{12, 13, 14}, 
	{9, 10, 11}, 
	{6, 7, 8},
	{5, 4, 3},
    {0, 1, 2}},

   {{24, 28, 29},
	{26, 27, 24}, 
    {24, 25, 24},
    {24, 24, 24},
    {24, 23, 24},
    {24, 22, 24},
    {24, 21, 24},
    {24, 19, 20},
    {24, 17, 18},
    {24, 15, 16},
    {24, 24, 24},
    {13, 14, 24},
    {11, 12, 24},
    {9, 10, 24},
    {7, 8, 24},
    {24, 6, 24},
    {24, 4, 5},
    {24, 2, 3},
    {24, 0, 1},
    {24, 24, 24}}
};

//-----------------------------------------------------------------------------
//  / Ҹ Լ
//-----------------------------------------------------------------------------
CMap::CMap()
{
	m_psurMap		= NULL;

	m_bScroll		= TRUE;
	SetRect(&m_rtDrawMap, 0, 200, 600, 800);
	SetRect(&m_rtBack, 0, 0, 600, 600);

	m_nMaxPos = 19;
	m_nCurPos = 16;
	m_nStage = 1;
}


CMap::~CMap()
{
}




//-----------------------------------------------------------------------------
//  ̽  ʵ ε
//-----------------------------------------------------------------------------		
void CMap::Create(LPDIRECTDRAW7 *pDD, CBoss *pBoss, CDxMusic *pMusic)		
{

	m_pDD = *pDD;
	m_pBoss = pBoss;
	m_pMusic = pMusic;
}






//-----------------------------------------------------------------------------
// ʱⰪ..
//-----------------------------------------------------------------------------	
void CMap::InitMap(int nStage)
{
	m_nStage = nStage;
	m_bScroll = TRUE;
	m_nMaxPos = 19;
	m_nCurPos = 16;
	LoadTile();
}




//-----------------------------------------------------------------------------
// ʱȭ Լ
//-----------------------------------------------------------------------------		
void CMap::Init(int nStage)					
{
	SetRect(&m_rtDrawMap, 0, 200, 600, 800);
	SetRect(&m_rtBack, 0, 0, 600, 600);

	m_nMaxPos = 19;
	m_nCurPos = 16;
}




//-----------------------------------------------------------------------------
// ʱȭ Լ
//-----------------------------------------------------------------------------	
void CMap::LoadMap(int nStage)
{

	//  ۾
	ReleaseMap();

	switch (nStage)
	{
	case 1:
		// Ʈ  б ## ϰ  ٶ ##
		LoadOnlySprData("map\\stage1.map", (ONLY_SPRITE*)&m_osTile);

		// Ʈ ǥ б
		CreateSurfaceFromBitmap(&m_psurTile, "map\\stage1.ora", NULL, NULL);
		m_psurTile->SetColorKey(RGB(0, 255, 0));

		CreateSurface(&m_psurMap, 600, 800);
		break;

	case 2:
		// Ʈ  б ## ϰ  ٶ ##
		LoadOnlySprData("map\\stage2.map", (ONLY_SPRITE*)&m_osTile);

		// Ʈ ǥ б
		CreateSurfaceFromBitmap(&m_psurTile, "map\\stage2.ora", NULL, NULL);
		m_psurTile->SetColorKey(RGB(0, 255, 0));

		CreateSurface(&m_psurMap, 600, 800);
		break;

	case 3:
		// Ʈ  б ## ϰ  ٶ ##
		LoadOnlySprData("map\\stage3_m.map", (ONLY_SPRITE*)&m_osTile);

		// Ʈ ǥ б
		CreateSurfaceFromBitmap(&m_psurTile, "map\\stage3_m.ora", NULL, NULL);
		m_psurTile->SetColorKey(RGB(0, 255, 0));

		CreateSurface(&m_psurMap, 600, 800);
		break;
	}
}


//-----------------------------------------------------------------------------
// ʱȭ Լ
//-----------------------------------------------------------------------------	
void CMap::ReleaseMap()
{
	if (m_psurMap)  m_psurMap->Destroy();
	if (m_psurTile) m_psurTile->Destroy();
	DestroyLOSD(&m_osTile);

	m_psurMap = NULL;
	m_psurTile = NULL;
}




//-----------------------------------------------------------------------------
//  ̽ -> ̽  
//-----------------------------------------------------------------------------		
void CMap::DrawMap(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	// ũ
	//if (m_bScroll)
	//	ScrollMap();

	//  ׸
	//(*m_pddsBB)->Blt(&m_rtBack, m_psurMap->GetDDrawSurface(),
	//				 &m_rtDrawMap, DDBLT_WAIT, NULL);


	(*m_pddsBB)->BltFast(m_rtBack.left, m_rtBack.top,
						 m_psurMap->GetDDrawSurface(), 
						 &m_rtDrawMap,
						 DDBLTFAST_WAIT | DDBLTFAST_NOCOLORKEY );
}




//-----------------------------------------------------------------------------
// Ÿ ̽ -> ʼ̽ Ÿ 
//-----------------------------------------------------------------------------		
void CMap::LoadTile()		
{
	RECT rtMap, rtTile;
	int nCurPos = m_nCurPos;

	for (int i = 0; i < 4; i++)
	{
		rtMap.top	 = i * 200;
		rtMap.bottom = rtMap.top + 200;

		for (int j = 0; j < 3; j++)
		{
			rtMap.left  = j * 200;
			rtMap.right = rtMap.left + 200;

			rtTile.top		= m_osTile.pSpr[ stage[m_nStage][nCurPos][j] ].rcSprPos.top		+ 1;
			rtTile.left		= m_osTile.pSpr[ stage[m_nStage][nCurPos][j] ].rcSprPos.left	+ 1;
			rtTile.right	= m_osTile.pSpr[ stage[m_nStage][nCurPos][j] ].rcSprPos.right	- 1;
			rtTile.bottom	= m_osTile.pSpr[ stage[m_nStage][nCurPos][j] ].rcSprPos.bottom	- 1; 

			//Ÿ ׸
			(m_psurMap->GetDDrawSurface())->Blt(&rtMap, m_psurTile->GetDDrawSurface(),
												&rtTile,
												DDBLT_WAIT | DDBLT_KEYSRC, NULL);


			//(m_psurMap->GetDDrawSurface())->BltFast(rtMap.left, rtMap.top,
			//										m_psurTile->GetDDrawSurface(), 
			//										&rtTile,
			//										DDBLTFAST_SRCCOLORKEY );
		}

		nCurPos++;
	}
}




//-----------------------------------------------------------------------------
//  ũ
//-----------------------------------------------------------------------------		
void CMap::ScrollMap()		
{
	if (m_bScroll)
	{
		m_rtDrawMap.top		-= 1;
		m_rtDrawMap.bottom	-= 1;
	}

	if (m_rtDrawMap.top <= 0)
	{
		if (--m_nCurPos < 0)
		{
			m_nCurPos = 0;
			m_bScroll = FALSE;

			switch (m_nStage)
			{
			case 0:
				m_pBoss->AddBoss(0, 0, -1, 300, -50); //  ߰
				// 
				m_pMusic->PlaySound(9, FALSE);
				break;

			case 1:
				m_pBoss->AddBoss(1, 0, -1, 300, -50); //  ߰
				// 
				m_pMusic->PlaySound(9, FALSE);
				break;

			case 2:
				// 
				m_pMusic->PlaySound(9, FALSE);
				m_pBoss->AddBoss(2, 0, -1, 300, -50); //  ߰
				m_pBoss->AddBoss(2, 1,  1, 150, -100); //  ߰
				m_pBoss->AddBoss(2, 1,  2, 450, -100); //  ߰
				m_pBoss->AddBoss(2, 2, -1, 300, 100); //  ߰
				break;
			}
		}

		// Ÿ ٽ ε
		LoadTile();

		//  ǥ ʱȭ
		if (m_bScroll)
			SetRect(&m_rtDrawMap, 0, 200, 600, 800);
	}

}




//-----------------------------------------------------------------------------
//  Լ
//-----------------------------------------------------------------------------		
void CMap::Destroy()		
{
	if (m_psurMap) m_psurMap->Destroy();
	if (m_psurTile) m_psurTile->Destroy();
	DestroyLOSD(&m_osTile);
}







//-----------------------------------------------------------------------------
// Ʈ  ε
//-----------------------------------------------------------------------------
BOOL CMap::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
		return FALSE;

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
		return FALSE;

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  
//-----------------------------------------------------------------------------
void CMap::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
		delete[] os->pSpr;
	os->pSpr = NULL;

}



//-----------------------------------------------------------------------------
// ǥ ̿ؼ ȭ ǥ 
//-----------------------------------------------------------------------------
inline void CMap::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
								 	POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);
}

















