
//-----------------------------------------------------------------------------
// NOTE : CMap Ŭ 
//  :    Ŭ
// ϸ : CMap.h
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------

#ifndef _CMAP_H_
#define _CMAP_H_

#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include "CBoss.h"
#include "CDxMusic.h"

//-----------------------------------------------------------------------------
class CMap : public CDisplay
{
	private:
		CSurface		*m_psurMap;		// 鼭̽ µ ǥ
		CSurface		*m_psurTile;	// Ÿ ǥ
		ONLY_SPRITE		m_osTile;		// Ÿ Ʈ 

		RECT			m_rtDrawMap;	// ǥ -> 鼭̽ µ ǥ
		RECT			m_rtBack;		// 鼭̽  ǥ
		int				m_nCurPos;		//  迭   ġ;
		int				m_nMaxPos;		//  ִε
		int				m_nStage;		// 

		BOOL			m_bScroll;		// ũ 

		// ü 
		CBoss			*m_pBoss;
		CDxMusic		*m_pMusic;

	public:
		CMap();
		~CMap();

		void Create(LPDIRECTDRAW7 *pDD, CBoss *pBoss, CDxMusic *pMusic);	//  ε
		void InitMap(int nStage);
		void Init(int nStage);		// ʱȭ & 

		void LoadMap(int nStage);
		void ReleaseMap();

		void DrawMap(LPDIRECTDRAWSURFACE7 *m_pddsBB);	//  ̽ ->  ̽
		void LoadTile();								// Ÿ ̽ ->  ̽
		void ScrollMap();								//  ũ Ų
		void Destroy();									//  ۾

		// 
		void SetStage(int nStage) { m_nStage = nStage; }
		BOOL GetScroll() { return m_bScroll; }

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);
};
//-----------------------------------------------------------------------------

#endif