#BasicWebServerAppTest

import unittest
import BasicWebServerApp
import os
import CharonBase

class BasicWebServerAppTest(unittest.TestCase):
    def setUp(self):
        self.wsApp = BasicWebServerApp.BasicWebServerApp()
    def testtranslatePath(self):
        self.wsApp.root = "C:\\python23"
        self.assertEquals("C:\\python23\\lib\\idle",self.wsApp.translatePath('/lib/idle'))
    def testguessType(self):
        self.assertEquals(self.wsApp.guessType("hello.py"),'text/plain')
        self.assertEquals(self.wsApp.guessType("index.html"),'text/html')
        self.assertEquals(self.wsApp.guessType("something.unknown"),'application/octet-stream')                  
    def testviewPath(self):
        print os.getcwd()
        resp = CharonBase.Response(0,None)
        path = os.path.join(os.getcwd(),"\\BasicWebServerAppTest.py")
        self.wsApp.viewPath(path,resp,None)
        actual = resp.rfile.readline()
        self.assertEquals(actual,"#BasicWebServerAppTest\n")

if __name__=="__main__":
    unittest.main(argv=('','-v'))
