//-----------------------------------------------------------------------------
// NOTE : CBoom Ŭ 
//  :  ȿ Ŭ
// ϸ : CBoom.cpp
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------

#include "CBoom.h"


//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CBoom::CBoom()
{
	
}


CBoom::~CBoom()
{

}



//-----------------------------------------------------------------------------
// ʱȭ (ǥ ,)
//-----------------------------------------------------------------------------
void CBoom::Create(LPDIRECTDRAW7 *pDD, CDxMusic *pMusic)
{
	m_pDD = *pDD;
	m_pMusic = pMusic;
}




//-----------------------------------------------------------------------------
// ʱⰪ..
//-----------------------------------------------------------------------------
void CBoom::InitBoom()
{
	BOOM_LIST::iterator itor;

	for (itor = m_listBoom.begin(); itor != m_listBoom.end(); ++itor)
	{
		delete (*itor);
	}

	m_listBoom.clear();
}





//-----------------------------------------------------------------------------
// Ʈ ǥ &  ε
//-----------------------------------------------------------------------------
void CBoom::LoadBoom()
{
	// ۾
	ReleaseBoom();

	// Ʈ  б ## ϰ  ٶ ##
	LoadOnlySprData("spr\\effect_boom.spr",  (ONLY_SPRITE*)&m_osBoom[0]);
	LoadOnlySprData("spr\\effect_boom1.spr", (ONLY_SPRITE*)&m_osBoom[1]);
	LoadOnlySprData("spr\\effect_boom2.spr", (ONLY_SPRITE*)&m_osBoom[2]);

	CreateSurfaceFromBitmap(&m_psurBoom[0], "image\\effect_boom.ora", NULL, NULL);
	CreateSurfaceFromBitmap(&m_psurBoom[1], "image\\effect_boom1.ora", NULL, NULL);	
	CreateSurfaceFromBitmap(&m_psurBoom[2], "image\\effect_boom2.ora", NULL, NULL);

	m_psurBoom[0]->SetColorKey(RGB(0, 0, 0));
	m_psurBoom[1]->SetColorKey(RGB(0, 0, 0));
	m_psurBoom[2]->SetColorKey(RGB(0, 0, 0));
}







//-----------------------------------------------------------------------------
// Ʈ ǥ &  
//-----------------------------------------------------------------------------
void CBoom::ReleaseBoom()
{
	if (m_psurBoom[0])
		m_psurBoom[0]->Destroy();
	if (m_psurBoom[1])
		m_psurBoom[1]->Destroy();
	if (m_psurBoom[2])
		m_psurBoom[2]->Destroy();

	DestroyLOSD(&m_osBoom[0]);
	DestroyLOSD(&m_osBoom[1]);
	DestroyLOSD(&m_osBoom[2]);

	m_psurBoom[0] = NULL;
	m_psurBoom[1] = NULL;
	m_psurBoom[2] = NULL;
}



//-----------------------------------------------------------------------------
// Ʈ ߰
//-----------------------------------------------------------------------------
void CBoom::Add(int flag, int x, int y)
{
	BOOM *add;
	add = new BOOM;
	if (add == NULL)
		return;
	
	add->ptPos.x = x;
	add->ptPos.y = y;
	add->nIndex	 = -1;
	add->bDraw   = TRUE;
	add->nFlag	 = flag;
	add->dwDealy = timeGetTime();
	add->nLoop	 = 0;

	m_listBoom.push_back(add);
}




//-----------------------------------------------------------------------------
// Ʈ Ʈ
//-----------------------------------------------------------------------------
void CBoom::Update()
{
	BOOM_LIST::iterator itor;
	BOOM_LIST::iterator	del[30];
	int nCnt = -1;

	for (itor = m_listBoom.begin(); itor != m_listBoom.end(); ++ itor)
	{
		switch ((*itor)->nFlag)
		{
		case 0:		// Ʈ 0
			if (++(*itor)->nIndex > 7)
			{
				del[++nCnt] = itor;
			}
			break;

		case 1:		// Ʈ 1
			if (++(*itor)->nIndex > 10)
			{
				del[++nCnt] = itor;
			}
			break;

		case 2:		// Ʈ 2 
			if (timeGetTime() - (*itor)->dwDealy > 10)
			{

				switch ((*itor)->nIndex)
				{
				case 12:
					Add(0, (*itor)->ptPos.x + 50, (*itor)->ptPos.y + 50);
					break;
				case 14:
					Add(0, (*itor)->ptPos.x - 50, (*itor)->ptPos.y - 50);
					break;
				case 16:
					Add(1, (*itor)->ptPos.x - 50, (*itor)->ptPos.y + 50);
					break;
				case 18:
					Add(1, (*itor)->ptPos.x + 50, (*itor)->ptPos.y - 50);
					break;
				}

				if ((*itor)->nLoop < 3)
				{
					if (++(*itor)->nIndex == 20)
					{
						m_pMusic->PlaySound(7, FALSE);
						m_pMusic->PlaySound(6, FALSE);
						m_pMusic->PlaySound(5, FALSE);
						(*itor)->nLoop++;
						(*itor)->nIndex = 10;
					}
				}
				else if ((*itor)->nLoop >= 3)
				{
					if (++(*itor)->nIndex == 20)
						del[++nCnt] = itor;
				}

				(*itor)->dwDealy = timeGetTime();
			}
			break;
		} // switch

	}


	// 
	for (int i = 0; i <= nCnt; i++)
	{
		delete *del[i];
		m_listBoom.erase(del[i]);
	}

}




//-----------------------------------------------------------------------------
// Ʈ ׸
//-----------------------------------------------------------------------------
void CBoom::Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	BOOM_LIST::iterator itor;
	RECT rtDraw, rtSprite;

	// Ʈ
	//Update();


	// Ʈ ο
	for (itor = m_listBoom.begin(); itor != m_listBoom.end(); ++itor)
	{
		MakeCenterToRect(&m_osBoom[(*itor)->nFlag].pSpr[(*itor)->nIndex].ptSprCenterPos,
						 &m_osBoom[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos,
						 &(*itor)->ptPos,
						 &rtDraw);

		rtSprite.left	= m_osBoom[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.left;
		rtSprite.top	= m_osBoom[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.top;
		rtSprite.right	= m_osBoom[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.right;
		rtSprite.bottom = m_osBoom[(*itor)->nFlag].pSpr[(*itor)->nIndex].rcSprPos.bottom;


		
		// Ŭ ó
		if (rtDraw.left < 0)
		{
			rtSprite.left += (-rtDraw.left);
			rtDraw.left = 0;
		}
		if (rtDraw.right > 600)
		{
			rtSprite.right -= (rtDraw.right - 600);
			rtDraw.right = 600;
		}
		if (rtDraw.top < 0)
		{
			rtSprite.top += (-rtDraw.top);
			rtDraw.top = 0;
		}
		if (rtDraw.bottom > 600)
		{
			rtSprite.bottom -= (rtDraw.bottom - 600);
			rtDraw.bottom = 600;
		}
	
		// 
		//(*m_pddsBB)->Blt(&rtDraw, m_psurBoom[(*itor)->nFlag]->GetDDrawSurface(),
		//				 &rtSprite,
		//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);

		(*m_pddsBB)->BltFast(rtDraw.left, rtDraw.top,
								m_psurBoom[(*itor)->nFlag]->GetDDrawSurface(),
								&rtSprite,
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
	}
}





//-----------------------------------------------------------------------------
// Ʈ ı
//-----------------------------------------------------------------------------
void CBoom::Destroy()
{
	BOOM_LIST::iterator itor;

	for (itor = m_listBoom.begin(); itor != m_listBoom.end(); ++itor)
	{
		delete (*itor);
	}

	if (m_psurBoom[0])
		m_psurBoom[0]->Destroy();
	if (m_psurBoom[1])
		m_psurBoom[1]->Destroy();
	if (m_psurBoom[2])
		m_psurBoom[2]->Destroy();

	DestroyLOSD(&m_osBoom[0]);
	DestroyLOSD(&m_osBoom[1]);
	DestroyLOSD(&m_osBoom[2]);
	
}





//-----------------------------------------------------------------------------
// Ʈ  ε
//-----------------------------------------------------------------------------
BOOL CBoom::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
		return FALSE;

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
	{
		delete[] os->pSpr;
		os->pSpr = NULL;
		return FALSE;
	}

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  
//-----------------------------------------------------------------------------
void CBoom::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
		delete[] os->pSpr;
	os->pSpr = NULL;

}



//-----------------------------------------------------------------------------
// ǥ ̿ؼ ȭ ǥ 
//-----------------------------------------------------------------------------
inline void CBoom::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);

}










