//-----------------------------------------------------------------------------
// Note: CBoss Ŭ 
//  :  Ŭ
// ϸ : CBoss.h
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------


#ifndef _CBOSS_H_
#define _CBOSS_H_


#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include "CBullet.h"
#include "CBoom.h"
#include "CForces.h"
#include "CDxMusic.h"
#include "CDirectShow.h"
#include <list>
using namespace std;

#define PI 3.1415

struct BOSS
{
	POINT	ptPos;		//  ߽ ǥ
	POINT	ptEnege;
	int		nLife;		//  
	int		nState;		//  
	int		nMove;		//  
	int		nShip;		//   3
	int		nDrawBoss;	// Ʈ ε
	int		nOpt;		//  3 ɼ
	int		nOpt2;		//  3 ɼ2
	double	nMoveX;		// Ӵ ӵȭ X
	double	nMoveY;		// Ӵ ӵȭ Y
	double	nAcc;			// ӵ
	DWORD	dwCreateTime;	//  ð
	DWORD	dwDealy;		//  
};

typedef list<BOSS*>	BOSS_LIST;

enum BOSSSTATE { B_NORMAL, B_WARNING };					//  ο 
enum MOVESTATE { M_CREATE, M_MOVE1, M_MOVE2, M_DEAD };	//   


//Class CEnemy ##
//-----------------------------------------------------------------------------
class CBoss : public CDisplay
{
	private:

		BOSS_LIST		m_listBoss;			// 	Ʈ

		CSurface		*m_psurBoss[3];		//  ǥ		
		ONLY_SPRITE		 m_osBoss[3];		//  

		CSurface		*m_psurEnege;		// 
		ONLY_SPRITE		 m_osEnege;


		CForces			*m_pForces;			// Ʊü 
		CDxMusic		*m_pMusic;			// ̷Ʈ  
		CDirectShow		*m_pDShow;			// Ÿ̷Ʈ  

		int				m_nCount;		
		int				m_nBullet;			
		int				m_nStage;			

		DWORD			m_dwDeathDealy;		// Ʈ  
		DWORD			m_dwDealy;			
		DWORD			m_dwMove;

		POINT			m_ptTemp;			//  3  Ʈ
		POINT			m_ptTemp2[3];
		int				m_nPos2[2];
		int				m_nPos;

		BOOL			m_bExt;
		int				m_movex;

	public:
		CBoss();
		virtual ~CBoss();

		// ʱȭ Լ
		void Create(LPDIRECTDRAW7 *pDD, CForces *pForces, CDxMusic *pMusic, CDirectShow	 *pDShow);
		void InitBoss();

		// Ʈ ε&  Լ
		void LoadBoss(int nStage);
		void ReleaseBoss();

		// ü Լ
		void AddBoss(int nBoss, int nOpt, int nOpt2, int x, int y);
		void UpdateBoss(CBoom *pBoom,  CBullet *pBullet);
		void Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB, CBoom *pBoom,  CBullet *pBullet);
		void DrawEnege(LPDIRECTDRAWSURFACE7 *m_pddsBB);
		void Destroy();

		// Լ
		void SetStage(int stage) { m_nStage = stage; }

		//  
		BOSS_LIST*	 GetListBoss() { return &m_listBoss; }
		ONLY_SPRITE* GetOnlySprite(int nOpt) { return &m_osBoss[nOpt]; } 

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);

};

//-----------------------------------------------------------------------------
#endif












