//-----------------------------------------------------------------------------
// Note: CBullet Ŭ 
//  :  Ѿ Ŭ
// ϸ : CBullet.h
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------


#ifndef _CBULLET_H_
#define _CBULLET_H_


#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include "CForces.h"
#include <list>
using namespace std;

struct _BULLET
{
	POINT	*pptBullet;		// Ѿ ǥ
	BOOL	*pbLife;		//  Ѿ  
	int		nKind;			// Ѿ 
	int		nCnt;			// Ѿ 
	int		nIndex;			// Ʈ ε
	float	fMovex;
	float	fMovey;
};

typedef list<_BULLET*>	BULLET_LIST;


//Class CBullet ##
//-----------------------------------------------------------------------------
class CBullet : public CDisplay
{
	private:

		BULLET_LIST		 m_listBullet;		// Ѿ Ʈ
		CForces			*m_pForces;

		CSurface		*m_psurBullet;		// BOOM ǥ		
		ONLY_SPRITE		 m_osBullet;;		// BOOM 

	public:
		CBullet();
		virtual ~CBullet();

		// ʱȭ Լ
		void Create(LPDIRECTDRAW7 *pDD, CForces *pForces);
		void InitBullet();

		// Ʈ ε& 
		void LoadBullet();
		void ReleaseBullet();


		// ü 
		void AddBullet(int x, int y, int move, int kind);
		void UpdateBullet();
		void Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB);
		void Destroy();

		// Ѿ 
		void AllDelBullet();

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);

		// ׼ 
		BULLET_LIST*	GetBullet() { return &m_listBullet; }
		ONLY_SPRITE*	GetOnlySprite() { return &m_osBullet; }
};

//-----------------------------------------------------------------------------
#endif












