//-----------------------------------------------------------------------------
// Note : CForces Ŭ 
//  : Ʊ ĳ Ŭ
// ϸ : CForces.h
// 2004.8.27 Ora_llundiov
//-----------------------------------------------------------------------------

#ifndef _CFORCES_H_
#define _CFORCES_H_


// 
#include <windows.h>
#include "ddraw.h"
#include "ddutil.h"
#include "CSprite.h"
#include "CEffect.h"
#include "CItem.h"
#include "CDxMusic.h"
#include "CBoom.h"
#include <list>
using namespace std;

// 
#define MOVE_TO_FRAME	10
#define CNT_PLANE		2
#define CNT_BOMB		2

#define START_POS_X	300
#define START_POS_Y	500

class CForces;

// Ѿ ü
struct BUL
{
	POINT	ptPos;		// Ѿ ġ
	BOOL	bLife;		// Ѿ 
	BOOL	bSp;		// ƽ
	BOOL	nSpIndex;	// Ѿ Ʈ ε
	int		dblFlag;	
	BOOL	bEx;		// exѾ
	double	dMoveX;
	double	dMoveY;
	double dAcc;
	int		nExFlag;
};
typedef list<BUL*> BULLET;

//  
enum FISH { F_FRONT, F_LEFT, F_RIGHT, F_BACK, F_WARING, F_MUJUC, F_CREATE, F_CLEAR };

//  
enum FACE { FACE_NORMAL, FACE_SPSHOT, FACE_WARNING };




//-----------------------------------------------------------------------------
class CForces : public CDisplay
{
	private:
		int		m_nCountPlane;		//  ü
		int		m_nCountBomb;		//  Ź
		int		m_nHP;				// 
		int		m_nMP;				// 
		int		m_nMoveFrame;		// Ӵ ̵Ÿ
		int		m_nStateBullet;		// Ѿ Ŀ 
		int		m_nStateFish;		// ü 
		int		m_nDrawFish;		// ü ׸ ÷
		int		m_nKindShip;		//  (ũ  Ʈ)
		int		m_nStateFace;		// ĳ  
		int		m_nPrevBullet;		//  Ѿ 
		DWORD	m_dwScore;			// 
		BOOL	m_bMujuc;			// ΰ?
		DWORD	m_dwStartM;			// ۽ð

		BOOL	m_bClear;			//  Ŭ?
		DWORD	m_dwClearDealy;		// Ŭ 
		BOOL	m_bClearMove;		// ü ̱ 

		POINT	m_ptCenterPos;		// ü ȭ ߽ġ
		RECT	m_rtPos;			// ü ȭ ġ

		POINT	m_ptHP;				//   ǥ
		POINT	m_ptMP;
		POINT	m_ptBoom;
		POINT	m_ptPlane;

		DWORD	m_dwExDealy;
		BOOL	m_bExBullet;

		CSurface		*m_psurFish;		// ҵǽ Ʈ ǥ
		ONLY_SPRITE		 m_osFish;			// Ʈ 

		CSurface		*m_psurSp;			// ƽ ǥ
		ONLY_SPRITE		 m_osSp;			// ƽ 

		CSurface		*m_psurInfo;		//  ǥ
		ONLY_SPRITE		 m_osInfo;			//  Ʈ 

		CSurface		*m_psurFace;		// ɸ  ǥ
		ONLY_SPRITE		 m_osFace;			//  Ʈ 
		POINT			 m_ptFace;
		DWORD			 m_dwChangeTime;	// 󱼻	

		CSurface		*m_psurClear;		//  Ŭ
		ONLY_SPRITE		 m_osClear;			//  Ŭ
		POINT			 m_ptClearPos;
		BOOL			 m_bDrawClear;

		CSurface		*m_psurSay;			// ϱ ǥ
		ONLY_SPRITE		 m_osSay;			// ϱ Ʈ 
		POINT			 m_ptSayPos;		// ϱ  ȭ ߽ǥ
		POINT			 m_ptWordPos;		//  ǥ
		BOOL			 m_bSay;			// Ұΰ~?
		int				 m_nFlagSay;		// ÷
		DWORD			 m_dwSayDealy;		// ʵ 

		BULLET			 m_listBullet;		// Ѿ Ʈ

		BOOL			 m_bReady;

		CEffect			*m_pEffect;			// Ʈ ü 
		CItem			*m_pItem;			//  ü 
		CDxMusic		*m_pDMusic;		
		CBoom			*m_pBoom;


	public:
		CForces();
		virtual ~CForces();

		BOOL	Create(LPDIRECTDRAW7 *pDD, CEffect* pEffect,
					   CItem *pItem, CDxMusic *pDMusic, CBoom *pBoom);	// Լ
		void	InItShip();
		void	InitNewShip();

		void	LoadForces(int nCha);
		void	ReleaseForces();

		BOOL	Update();									//  Ʈ
		void	Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB);		// 
		void	DrawClear(LPDIRECTDRAWSURFACE7 *m_pddsBB);	// 
		void	DrawSay(LPDIRECTDRAWSURFACE7 *m_pddsBB);	// ϱ
		void	Destroy();									// ۾

		//  
		void MoveRight();
		void MoveLeft();
		void MoveUp();
		void MoveDown();
		void SetStateFish(int state) { m_nStateFish = state; };

		// Ѿ 
		void BT_Add(int x, int  y, BOOL sp, int flag);
		void BT_Add(int x, int y);
		void BT_Add(int x, int y, int flag, double movex, double movey, double acc);
		void BT_Update();
		void BT_Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB);
		void BT_SetPower(int nPower = 0);

		// ÷   Լ
		void DrawInfo(LPDIRECTDRAWSURFACE7 *m_pddsBB);

		// Ʈ 
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									 POINT *ptScreen, RECT *rtScreen);

		// ׼  Լ
		BULLET*		 GetBullet() { return &m_listBullet; }
		ONLY_SPRITE* GetOnlySprite() { return &m_osFish; }
		int			 GetStateBullet() { return m_nStateBullet; }
		POINT		 GetCenterPos() { return m_ptCenterPos; } 
		int			 GetDrawFish() { return m_nDrawFish; }
		BOOL		 GetMujuc() { return m_bMujuc; }
		int			 GetMp() { return m_nMP; }
		int			 GetHp() { return m_nHP; }
		int			 GetBoom() { return m_nCountBomb; }
		int			 GetPlane() { return m_nCountPlane; }
		int			 GetStateFish() { return m_nStateFish; }
		BOOL		 GetClear() { return m_bClear; }
		DWORD		 GetScore() { return m_dwScore; }

		//  Լ
		void SetHP(int power = 0); 
		void SetMP(int power = 0);
		void SetBoom(int inc = 0);
		void SetPlane(int inc = 0);
		void SetBullet(int inc = 0);
		void SetKindShip(int cha) { m_nKindShip = cha; }
		void SetScore(DWORD inc);
		void SetPrevBullet();
		void SetMujuc(BOOL bMujuc) { m_bMujuc = bMujuc; }
		void SetClear(BOOL bClear) { m_bClear = bClear; }
		void SetClearDealy(DWORD dwTime) { m_dwClearDealy = dwTime; }
		void SetFace(int state)
		{
			m_nStateFace = state;
			m_dwChangeTime = timeGetTime();
		}
		void SetMTime(DWORD dwTime) { m_dwStartM = dwTime; }
		void SetPrevBullet(int bullet)
		{
			if (m_nStateBullet != 9)
				m_nPrevBullet = m_nStateBullet; 
		}
		void SetDrawClear(BOOL bDraw) { m_bDrawClear = bDraw; }

		void SetSay(int flag)
		{
			m_dwSayDealy = timeGetTime();
			m_nFlagSay = flag;
			m_bSay = TRUE;
		}

};


#endif