
//-----------------------------------------------------------------------------
// NOTE : CScript Ŭ  
//  : ũ Ŭ
// ϸ : CScript.cpp
// 2004.8.27 ora_llundiov
//-----------------------------------------------------------------------------


#include "CScript.h"

int stage[3][50][2] = {
	{ {0, 0},{0, 1},{1, 0},{2, 0},{0, 2},{0, 3},{1, 1},{2, 1},{0, 4},{0, 5}, 
	  {0, 1},{0, 0},{0, 2},{2, 0},{1, 1},{0, 3},{0, 4},{0, 5},{1, 2},{1, 3}, 
	  {0, 2},{0, 5},{0, 0},{1, 4},{1, 5},{0, 2},{2, 2},{1, 6},{0, 0},{0, 2}, 
	  {0, 1},{0, 5},{0, 2},{1, 2},{2, 0},{0, 5},{2, 3},{0, 0},{0, 2},{0, 4}, 
	  {0, 1},{0, 0},{0, 2},{1, 3},{1, 6},{0, 2},{2, 1},{0, 0},{0, 2},{0, 3}  }, //  1

	{ {0, 5},{0, 4},{1, 3},{2, 2},{0, 2},{0, 3},{1, 5},{2, 1},{0, 3},{0, 2}, 
	  {0, 1},{0, 0},{0, 4},{2, 0},{1, 2},{0, 3},{0, 4},{0, 5},{1, 0},{1, 3}, 
	  {0, 2},{0, 5},{0, 2},{1, 6},{1, 5},{0, 1},{2, 0},{1, 3},{0, 3},{0, 2}, 
	  {0, 1},{0, 4},{0, 1},{1, 3},{2, 1},{0, 1},{2, 0},{0, 1},{0, 3},{0, 2}, 
	  {0, 5},{0, 4},{0, 3},{1, 2},{1, 0},{0, 2},{2, 3},{0, 3},{0, 2},{0, 1}  }, //  2

	{ {0, 0},{0, 1},{0, 2},{0, 3},{0, 4},{0, 5},{1, 0},{1, 2},{1, 3},{1, 4}, 
	  {1, 5},{1, 6},{2, 0},{2, 1},{2, 2},{2, 3},{0, 1},{0, 2},{0, 3},{0, 4}, 
	  {0, 5},{1, 0},{1, 1},{1, 2},{1, 3},{1, 4},{1, 5},{1, 6},{2, 0},{2, 1}, 
	  {2, 2},{2, 3},{0, 0},{0, 1},{0, 2},{0, 3},{0, 4},{0, 5},{1, 0},{1, 1}, 
	  {1, 2},{1, 3},{1, 4},{1, 5},{1, 6},{2, 0},{2, 1},{0, 2},{0, 3},{0, 2}  } //  3
};



//-----------------------------------------------------------------------------
//  / Ҹ Լ
//-----------------------------------------------------------------------------
CScript::CScript()
{
	m_bStart	= FALSE;
	m_nStage	= 0;
}


CScript::~CScript()
{

}




//-----------------------------------------------------------------------------
// Լ
//-----------------------------------------------------------------------------
void CScript::Create(CEnemy* pEnemy)
{
	m_pEnemy = pEnemy;
}




//-----------------------------------------------------------------------------
// Լ
//-----------------------------------------------------------------------------
void CScript::Init(int nStage)
{	
	m_nStage	= nStage;
	m_dwDealy	= timeGetTime(); 
	m_nIndex	= 0;
}




//-----------------------------------------------------------------------------
// ũ Լ
//-----------------------------------------------------------------------------
void CScript::Start()
{
	m_bStart = TRUE;
}




//-----------------------------------------------------------------------------
// Ʈ Լ
//-----------------------------------------------------------------------------
void CScript::Update()
{
	if ((timeGetTime() - m_dwDealy) > 2000 && m_bStart)
	{
		Add(stage[m_nStage][m_nIndex][0], stage[m_nStage][m_nIndex][1]);

		m_dwDealy = timeGetTime();

		if (++m_nIndex > 50)
		{
			m_bStart = FALSE;
		}
	}

}




//-----------------------------------------------------------------------------
// ߰ Լ
//-----------------------------------------------------------------------------
void CScript::Add(int nSize, int nFlag)
{
	switch (nSize)
	{
	case 0: //  
		switch (nFlag)
		{
		case 0:
			m_pEnemy->AddShip(440, 70,		12, 0,	0, 0,	700);
			m_pEnemy->AddShip(460, 0,		12, 0,	0, 0,	1000);
			m_pEnemy->AddShip(480, -70,		12, 0,	0, 0,	1000);
			m_pEnemy->AddShip(500, -140,	12, 0,	0, 0,	1000);
			break;

		case 1:
			m_pEnemy->AddShip(160,  70,		12, 1,	0, 0,	700);
			m_pEnemy->AddShip(140, 0,		12, 1,	0, 0,	1000);
			m_pEnemy->AddShip(120, -70,		12, 1,	0, 0,	1000);
			m_pEnemy->AddShip(100, -140,	12, 1,	0, 0,	1000);
			break;

		case 2:
			m_pEnemy->AddShip(300, 0,		12, 0,	0, 1,	600);
			m_pEnemy->AddShip(200, 0,		12, 1,	0, 1,	800);
			m_pEnemy->AddShip(300, 0,		12, 1,	0, 1,	600);
			m_pEnemy->AddShip(400, 0,		12, 0,	0, 1,	800);
			m_pEnemy->AddShip(300, 0,		12, 4,	0, 1,	600);
			break;

		case 3:
			m_pEnemy->AddShip(100, -70,		12, 4,	1, 0,	600);
			m_pEnemy->AddShip(200, -40,		12, 4,	1, 1,	600);
			m_pEnemy->AddShip(300, -10,		12, 4,	1, 1,	600);
			m_pEnemy->AddShip(400, -40,		12, 4,	1, 1,	600);
			m_pEnemy->AddShip(500, -70,		12, 4,	1, 0,	600);
			break;

		case 4:
			m_pEnemy->AddShip(60,  -80,		12, 1,	1, 1,	600);
			m_pEnemy->AddShip(100, -30,		12, 1,	1, 0,	600);
			m_pEnemy->AddShip(140, -80,		12, 1,	1, 1,	600);
			break;

		case 5:
			m_pEnemy->AddShip(460, -80,		12, 0,	1, 1,	600);
			m_pEnemy->AddShip(500, -30,		12, 0,	1, 0,	600);
			m_pEnemy->AddShip(540, -80,		12, 0,	1, 1,	600);
			break;
		}
		break;

	case 1: // ߰ 
		switch (nFlag)
		{
		case 0:
			m_pEnemy->AddShip(100, -50,		12, 1,	1, 4,	800);
			m_pEnemy->AddShip(500, -50,		12, 0,	1, 4,	800);
			m_pEnemy->AddShip(200, -50,		1, 5,	1, 0,	700);
			m_pEnemy->AddShip(400, -50,		1, 5,	1, 0,	700);
			break;

		case 1:
			m_pEnemy->AddShip(300, -50,		12, 0,	1, 0,	800);
			m_pEnemy->AddShip(300, -50,		12, 1,	1, 0,	800);
			m_pEnemy->AddShip(200, -50,		2, 5,	1, 1,	700);
			m_pEnemy->AddShip(400, -50,		2, 5,	1, 1,	700);
			
			break;

		case 2:
			m_pEnemy->AddShip(200, -50,		12, 5,	1, 1,	500);
			m_pEnemy->AddShip(200, -50,		12, 1,	1, 0,	500);
			m_pEnemy->AddShip(300, -50,		3, 5,	1, 1,	1000);
			m_pEnemy->AddShip(400, -50,		12, 0,	1, 0,	500);
			m_pEnemy->AddShip(400, -50,		12, 5,	1, 1,	500);
			break;

		case 3:
			m_pEnemy->AddShip(550, -50,		12, 0,	1, 1,	500);
			m_pEnemy->AddShip(50,  -50,		12, 1,	1, 1,	500);
			m_pEnemy->AddShip(250, -50,		4, 5,	1, 4,	700);
			m_pEnemy->AddShip(350, -50,		4, 5,	1, 4,	700);
			break;

		case 4:
			m_pEnemy->AddShip(300, -50,		12, 4,	1, 0 ,	500);
			m_pEnemy->AddShip(200, -80,		12, 4,	1, 1,	500);
			m_pEnemy->AddShip(400, -80,		12, 4,	1, 0,	500);
			m_pEnemy->AddShip(50,  -50,		5, 1,	0, 0,	500);
			m_pEnemy->AddShip(550, -50,		5, 0,	0, 0,	500);
			break;

		case 5:
			m_pEnemy->AddShip(200, -30,		12, 5,	0, 1,	400);
			m_pEnemy->AddShip(300, -80,		6, 5,	0, 3,	400);
			m_pEnemy->AddShip(400, -30,		12, 5,	0, 1,	400);
			break;

		case 6:
			m_pEnemy->AddShip(100, -30,		12, 1,	1, 0,	500);
			m_pEnemy->AddShip(300, -30,		7, 5,	1, 2,	1000);
			m_pEnemy->AddShip(500, -30,		12, 0,	1, 0,	500);
			break;

		}
		break;

	case 2: // ū 
		switch (nFlag)
		{
		case 0:
			m_pEnemy->AddShip(100, -70,		12, 1,	0, 0,	700);
			m_pEnemy->AddShip(200, -70,		12, 1,	0, 0,	700);
			m_pEnemy->AddShip(200, -50,		 8, 2,	3, 2,	1000); 
			break;

		case 1:
			m_pEnemy->AddShip(500, -70,		12, 0,	0, 0,	700);
			m_pEnemy->AddShip(400, -70,		12, 0,	0, 0,	700);
			m_pEnemy->AddShip(400, -50,		 9, 3,	3, 3,	1000); 
			break;

		case 2:
			m_pEnemy->AddShip(100, -70,		12, 1,	0, 0,	700);
			m_pEnemy->AddShip(200, -70,		12, 1,	0, 0,	700);
			m_pEnemy->AddShip(200, -50,		10, 2,	3, 4,	1000);
			break;

		case 3:
			m_pEnemy->AddShip(500, -70,		12, 0,	0, 0,	700);
			m_pEnemy->AddShip(400, -70,		12, 0,	0, 0,	700);
			m_pEnemy->AddShip(400, -50,		11, 3,	3, 3,	1000);
			break;
		}
		break;

	}
}















